﻿Imports System.Math

Public Class frmDock

    Private Sub subDockLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        On Error Resume Next
        UpDnLocX.Value = tmcDock.X
        UpDnLocY.Value = tmcDock.Y
        updnOrientation.Value = intDockOrientation
        UpDownPCTrigger.Value = intDockTriggerPC
        txtBotBatteryTrigger.Text = sngDockTriggerBot.ToString
        chkBackIn.Checked = boolDockBackIn
    End Sub



    Private Sub UpDnLocX_ValueChanged(sender As System.Object, e As System.EventArgs) Handles UpDnLocX.ValueChanged
        On Error Resume Next
        boolSettingsChanged = True
        tmcDock.X = UpDnLocX.Value
        tmcDock = ftnCheckMapArrayLimits(tmcDock)
        UpDnLocX.Value = tmcDock.X
    End Sub


    Private Sub UpDnLocY_ValueChanged(sender As System.Object, e As System.EventArgs) Handles UpDnLocY.ValueChanged
        On Error Resume Next
        tmcDock.Y = UpDnLocY.Value
        tmcDock = ftnCheckMapArrayLimits(tmcDock)
        UpDnLocY.Value = tmcDock.Y
        boolSettingsChanged = True
    End Sub


    Private Sub updnOrientation_ValueChanged(sender As System.Object, e As System.EventArgs) Handles updnOrientation.ValueChanged
        On Error Resume Next
        intDockOrientation = updnOrientation.Value
        boolSettingsChanged = True
    End Sub


    Private Sub ChkBackIn_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkBackIn.CheckedChanged
        On Error Resume Next
        boolDockBackIn = chkBackIn.Checked()
        boolSettingsChanged = True
    End Sub

    Private Sub UpDownPCTrigger_ValueChanged(sender As System.Object, e As System.EventArgs) Handles UpDownPCTrigger.ValueChanged
        On Error Resume Next
        intDockTriggerPC = UpDownPCTrigger.Value
        boolSettingsChanged = True
    End Sub

    Private Sub txtBotBatteryTrigger_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtBotBatteryTrigger.TextChanged
        On Error Resume Next
        If (txtBotBatteryTrigger.Text <> "") Then sngDockTriggerBot = Val(txtBotBatteryTrigger.Text)
1:      boolSettingsChanged = True
    End Sub


    Private Sub OK_Button_Click(sender As System.Object, e As System.EventArgs) Handles OK_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Visible = False
        GotABotClass.subRedraw(tbpBotPose)
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(sender As System.Object, e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
        GotABotClass.mnuLoadSettings_Click(tlmLandMarkArray, e)
    End Sub


    Private Sub Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosing
        Me.Visible = False
        GotABotClass.subRedraw(tbpBotPose)
    End Sub


    '*****************************************************************************************************************************


    Public Sub subDock()
        On Error Resume Next
        boolDock = True
        ftnSendCommand("play phrase 'Docking.'")
        boolRangeReadingsAreFresh = False
        tbpBotPose = ftnLocalize_Top(tbpBotPose)
        subDriveToPreDock()
        tbpBotPose = ftnLocalize_Top(tbpBotPose)
        Do
            subPreDockAdjust()  ' Want accurate positioning before attempting Dock contact
            subCheckForPause()
            boolDocked = ftnDockMakeContact()
            If Not boolDocked Then subUnDock()
            tbpBotPose = ftnLocalize_Top(tbpBotPose)
            If Not boolDocked And ftnIAmLost(tbpBotPose) Then ftnLostRecoveryTop(tbpBotPose, tbpBotPose)
        Loop Until (boolDocked Or boolStop Or ftnIAmLost(tbpBotPose)) Or boolShutDown
        If boolDocked And Not boolStop And Not boolShutDown Then
            If ftnIAmLost(tbpBotPose) Then
                boolRangeReadingsAreFresh = False
                tbpBotPose = ftnLocalize_Top(tbpBotPose)
            End If
            tbpBotPose.Location = tmcDock
            If Not GotABotClass.InvokeRequired Then
                frmDebug.subWriteFinishedMessage()
                GotABotClass.StatusDriving.ForeColor = Color.Black
                strStatusDriving = "DOCKED"
                GotABotClass.mnuDock.Checked = False
            End If
            ftnSendCommand("play phrase 'Docking Completed.'")
            intMovementsSinceLocalization = 0
            boolDocked = True
        ElseIf boolStop Then
            boolDocked = False
            GotABotClass.mnuDock.Checked = False
            ftnSendCommand("play phrase 'By your command.'")
        Else
            boolDocked = False
            GotABotClass.mnuDock.Checked = False
            ftnSendCommand("play phrase 'Docking Failed.'")
        End If
        GotABotClass.subRedraw(tbpBotPose)
    End Sub

    Public Sub subUnDock()
        On Error Resume Next
        If Not boolStop And Not boolPause And (ftnMapLocationsEqual(tbpBotPose.Location, tmcDock) Or boolDocked) And Not boolShutDown Then
            frmDebug.subWriteLogs(Color.Black, Now() & "    ")
            frmDebug.subWriteLogs(Color.Black, Now() & "    ")
            frmDebug.subWriteLogs(Color.Black, Now() & "    ")
            frmDebug.subWriteLogs(Color.Black, Now() & "    --------------------------  UnDocking.  ----------------------- ")
            boolPoseConfirmedAfterCollision = True
            For I As Integer = 1 To 5
                If Not boolMute Then Beep()
                subWait(200)
            Next I
            Dim tbpTargetPose As typeBotPose = tbpBotPose
            If boolDockBackIn Then
                tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngSixInches)
            Else
                tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngFourInches + sngBotRadius)
            End If
            tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)  '  
            intMovementsSinceLocalization = 99  'Force Localization
            tbpBotPose = ftnPostMovement(tbpBotPose, "Fwd", tbpBotPose, tbpTargetPose)
            boolDocked = False
            GotABotClass.mnuDock.Checked = False
        End If
    End Sub

    Function ftnGetBatteryPreDock() As Single
        On Error Resume Next
        ftnSendCommand("battery")
        Dim timeOut As DateTime = Now().AddMilliseconds(4000)
        Do
            ftnGetBatteryPreDock = sngBotBatteryVoltage
            ftnSendCommand("battery")
        Loop Until ((ftnGetBatteryPreDock - sngBotBatteryVoltage) < (ftnGetBatteryPreDock / 100)) Or boolStop Or boolShutDown Or (Now() > timeOut) ' wait for battery voltage to stabilize
    End Function

    Sub subDriveToPreDock()
        On Error Resume Next
        tmcDestination = ftnPreDockLocation()
        subDriveToDestination_Top(tmcDestination)
        tbpBotPose = ftnLocalize_Top(tbpBotPose)
    End Sub

    Sub subPreDockAdjust()
        ' Turn towards preDock location
        ' Goto preDock Location
        ' Turn towards Dock orientation
        On Error Resume Next  ' Fine positioning before final docking maneuvers. Called when Bot has arrived near its pre docking position (approx 5" in front of dock)
        Dim boolLWMTemp As Boolean = boolEnableLocalizationWhileMoving
        boolEnableLocalizationWhileMoving = False
        Dim sngPreDockOrientation As Single = intDockOrientation  ' Desired orientation when at preDock location
        If boolDockBackIn Then sngPreDockOrientation = ftnConvertTo360(sngPreDockOrientation + 180)
        Dim sngBotToPreDockOrientation As Single
        While Not (boolStop Or boolShutDown Or ftnIAmLost(tbpBotPose)) And _
               ((ftnDistanceBetweenLocations(tbpBotPose.Location, ftnPreDockLocation) > ftnInchesToMapUnits(3)) Or _
               (Abs(ftnAngleDifference(tbpBotPose.Orientation, sngPreDockOrientation)) > 12) Or _
               (Abs(ftnAngleDifference(tbpBotPose.Orientation, ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation))) > 8))
            subDoEventsIfMainThread()
            frmDebug.subWriteLogs(Color.Black, "    ")
            frmDebug.subWriteLogs(Color.Black, "    ")
            frmDebug.subWriteLogs(Color.Black, "    ")
            frmDebug.subWriteLogs(Color.Black, Now() & "    --------------------------  PreDocking Adjustment  ----------------------- ")
            sngBotToPreDockOrientation = (ftnP1ToP2Angle(tbpBotPose.Location, ftnPreDockLocation))
            Dim sngDistanceToPreDock As Single = ftnDistanceBetweenLocations(tbpBotPose.Location, ftnPreDockLocation)
            Dim tbpTargetPose As typeBotPose = tbpBotPose
            If (Abs(ftnConvertTo180(sngBotToPreDockOrientation - tbpBotPose.Orientation)) > 135) And (sngDistanceToPreDock > ftnInchesToMapUnits(3)) And (sngDistanceToPreDock < ftnInchesToMapUnits(12)) Then
                frmDebug.subWriteLogs(Color.Red, Now() & " ***** Turn and Backup: . ***************************")
                tbpTargetPose.Orientation = ftnConvertTo360(sngBotToPreDockOrientation - 180)
                If (Abs(ftnConvertTo180(sngBotToPreDockOrientation - tbpBotPose.Orientation)) > 4) Then tbpBotPose = ftnBotTurn(tbpBotPose, True, tbpTargetPose) ' Turn to preDock Location
                If (ftnPoseUncertaintyFactor(tbpBotPose) > 560) Then ' 560=(14+14)*20
                    tbpBotPose = ftnLocalize_Top(tbpBotPose)  ' readjust if poor localization
                    If (Abs(ftnConvertTo180(sngBotToPreDockOrientation - tbpBotPose.Orientation)) > 4) Then tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' Turn to preDock Location
                End If
                subPostDockingMovement()
                tbpTargetPose = tbpBotPose
                tbpTargetPose.Location = ftnPreDockLocation() '
                tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose) ' backup 
            ElseIf (sngDistanceToPreDock > ftnInchesToMapUnits(3)) Then
                sngBotToPreDockOrientation = ((ftnP1ToP2Angle(tbpBotPose.Location, ftnPreDockLocation))) '
                tbpTargetPose.Orientation = sngBotToPreDockOrientation
                If (Abs(ftnConvertTo180(sngBotToPreDockOrientation - tbpBotPose.Orientation)) > 5) Then tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' turn towards PreDock Location
                subPostDockingMovement()
                tbpTargetPose.Location = ftnPreDockLocation()
                tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)  ' Goto preDock Location
            ElseIf (Abs(ftnAngleDifference(tbpBotPose.Orientation, sngPreDockOrientation)) > 12) Then
                tbpTargetPose = tbpBotPose
                tbpTargetPose.Orientation = sngPreDockOrientation
                tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' Turn to Dock
            ElseIf (Abs(ftnAngleDifference(tbpBotPose.Orientation, ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation))) > 8) Then
                tbpTargetPose = tbpBotPose
                tbpTargetPose.Orientation = ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation)
                tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' Turn to Dock
            Else
                sngBotToPreDockOrientation = ((ftnP1ToP2Angle(tbpBotPose.Location, ftnPreDockLocation))) '
                tbpTargetPose.Orientation = sngBotToPreDockOrientation
                If (Abs(ftnConvertTo180(sngBotToPreDockOrientation - tbpBotPose.Orientation)) > 5) Then tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' turn towards PreDock Location
                subPostDockingMovement()
                tbpTargetPose.Location = ftnPreDockLocation()
                tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)  ' Goto preDock Location
            End If
            subPostDockingMovement()
            If Not boolStop And (Abs(ftnConvertTo180(ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation) - tbpBotPose.Orientation)) > 4) Then
                tbpTargetPose = tbpBotPose
                tbpTargetPose.Orientation = ftnConvertTo180(ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation)) '
                tbpBotPose = ftnBotTurn(tbpBotPose, True, tbpTargetPose) '  Turn to Dock Contacts
            End If
            subPostDockingMovement()
            tbpBotPose = ftnLocalize_Top(tbpBotPose)
            subDoEventsIfMainThread()
        End While
        boolEnableLocalizationWhileMoving = boolLWMTemp
    End Sub

    Function ftnDockMakeContact() As Boolean  ' returns true if docking successful
        On Error Resume Next ' Final docking maneuvers
        If Not boolStop And Not boolShutDown Then
            ftnDockMakeContact = False
            Dim boolLWMTemp As Boolean = boolEnableLocalizationWhileMoving
            Dim sngBotBatteryPreDock As Single = ftnGetBatteryPreDock()  '  Bot's Battery voltage used to determine docking success
            boolEnableLocalizationWhileMoving = False
            subDoEventsIfMainThread()
            frmDebug.subWriteLogs(Color.Black, "    ")
            frmDebug.subWriteLogs(Color.Black, "    ")
            frmDebug.subWriteLogs(Color.Black, "    ")
            frmDebug.subWriteLogs(Color.Black, Now() & "    --------  Final Docking Sequence  --------- ")
            Dim tbpTargetPose As typeBotPose = tbpBotPose
            tbpTargetPose.Orientation = ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation)
            If boolDockBackIn And Not boolStop And Not boolShutDown And Not boolPause Then  ' Dock contacts are accessed via the rear of the robot
                tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 180)
                tbpBotPose = ftnBotTurn(tbpBotPose, True, tbpTargetPose) ' Turn so that rear of Bot faces Dock
                subPostDockingMovement()
                If (Abs(ftnAngleDifference(ftnConvertTo360(tbpBotPose.Orientation + 180), ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation))) < 15) Then
                    tbpTargetPose = tbpBotPose
                    tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDock) + sngFiveInches)
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                    intDrivingSequenceNumber += 1
                End If
            ElseIf Not boolStop And Not boolShutDown And Not boolPause Then
                tbpBotPose = ftnBotTurn(tbpBotPose, True, tbpTargetPose) ' Face the Dock
                subPostDockingMovement()
                If (Abs(ftnAngleDifference(tbpBotPose.Orientation, ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation))) < 10) Then
                    tbpTargetPose = tbpBotPose
                    tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDock) + ftnInchesToMapUnits(5))
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                    intDrivingSequenceNumber += 1
                End If
            End If
            If boolSimulatedMovement Then
                ftnDockMakeContact = True
            ElseIf Not boolStop And Not boolShutDown And Not boolPause Then
                subWait(4000) ' wait for battery to charge a bit
                Dim i As Integer = 0
                While (i < 12) And Not ftnDockMakeContact And Not boolShutDown And Not boolStop And Not boolPause
                    i += 1
                    subWait(1000)
                    ftnDockMakeContact = ftnDocked(sngBotBatteryPreDock)
                    If boolDebugDock Then frmDebug.subWriteLogs(Color.Black, Now() & " >DOCKING CHECK: sngBotBatteryPreDock: " & sngBotBatteryPreDock & "    sngBotBatteryVoltage: " & sngBotBatteryVoltage)
                End While
                If Not ftnDockMakeContact Then frmDebug.subWriteLogs(Color.Black, Now() & " >DOCKING FAILED: sngBotBatteryPreDock: " & sngBotBatteryPreDock & "    sngBotBatteryVoltage: " & sngBotBatteryVoltage)
            End If
            boolEnableLocalizationWhileMoving = boolLWMTemp
        End If
    End Function

    Sub subPostDockingMovement() ' TODO -Change to function, return pose
        ' Check for collision, pause
        If Not boolSimulatedMovement And Not boolStop Then
            subWait(1000)
            boolCollisionDetected = ftnCheckForCollision()
            If boolCollisionDetected Then tbpBotPose = ftnCollisionRecovery(tbpBotPose)
            intDrivingSequenceNumber += 1
            subCheckForPause()
        End If
    End Sub

    Public Function ftnPreDockLocation() As typeMapCoordinate
        On Error Resume Next
        If boolDockBackIn Then
            ftnPreDockLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, ftnInchesToMapUnits(5))
        Else
            ftnPreDockLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, -ftnInchesToMapUnits(5))
        End If
    End Function

    Function ftnDockContactLocation() As typeMapCoordinate
        On Error Resume Next
        If boolDockBackIn Then
            ftnDockContactLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, -sngBotRadius)
        Else
            ftnDockContactLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, +sngBotRadius)
        End If
    End Function


    Function ftnDocked(ByVal sngBotBatteryPreDock As Single) As Boolean  ' True if Bot Battery is a higher voltage than when previously measured
        On Error Resume Next
        If boolSimulatedMovement Then
            ftnDocked = True
        ElseIf Not boolStop And Not boolShutDown Then
            ftnSendCommand("battery")
            ftnDocked = (sngBotBatteryVoltage > (sngBotBatteryPreDock * 1.015))
        End If
    End Function


End Class