﻿
'Option Strict On

'=============================================================================================================================================================

' NOTE:  This project requires that drivers for Phidgets (http://www.phidgets.com/docs/OS_-_Windows#Quick_Downloads) 
' and Kinect (http://www.microsoft.com/en-us/kinectforwindows/develop/) be installed on the PC

' intRobot_Port  = 9000
' intLocalRccPort  = 9200
' API_Port = 9100
' 2nd API_Port = 9400
' GotAGlyph Port = 9050
' RoboRealm_Port = 6060
' Face Detect Port = 9150   (GotAMissile - interface not implemented yet)
' GotAKinect Port = 9060
' GotAnArm Port = 9070

'=============================================================================================================================================================


Imports System.Net
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Text.RegularExpressions
Imports System.Threading
Imports System.EventArgs
Imports System.Net.Sockets
Imports System.Text

Imports Emgu.CV
Imports Emgu.CV.UI
Imports Emgu.Util
Imports Emgu.CV.Structure
Imports Emgu.CV.CvEnum
Imports Microsoft.Kinect

Imports Phidgets
Imports Phidgets.Events


Public Class GotABotClass
    Public imgMap As Image = System.Drawing.Image.FromFile("GotABot_Map.bmp")

    Dim boolMouseDown As Boolean = False
    Dim boolSettingsChangedTemp As Boolean = False
    Dim boolPlaceBot As Boolean = False
    Dim boolPlaceDestination As Boolean = False

    Public Sub New()
        InitializeComponent()
    End Sub


    Private Sub subGotABotLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        On Error Resume Next
        Dim infoReader As System.IO.FileInfo = My.Computer.FileSystem.GetFileInfo("GotABot_Log.txt")
        If (Dir("GotABot_Log.txt") <> "") Then
            If infoReader.Length > 10000000 Then MsgBox(" GotABot_Log.txt is growing excessively large.  Please start a new log file")
        End If
        mnuMapUnits.Items.Add("inch")
        mnuMapUnits.Items.Add("cm")
        LoadSettings("GotABot_Settings.xml") ' load settings
        Start_Threads()
        subOpenMap("GotABot_Map.bmp")
        Me.Text = "GOTABOT       (" & My.Application.Info.Version.ToString(3) & ")"
        Me.StatusDriving.ForeColor = Color.Black
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Sub subInitialize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Shown
        On Error Resume Next
        frmDebug.subWriteLogs(Color.Red, "")
        frmDebug.subWriteLogs(Color.Red, Now() & " ************************ GOTABOT       (" & My.Application.Info.Version.ToString(3) & ")  ********************************")
        frmDebug.subWriteLogs(Color.Red, "")
        For intRangerNumber As Integer = 0 To UBound(trfRangeFinders)
            trfRangeFinders(intRangerNumber).sngMaxRange = constIR_MaxRange
        Next
        If (ticCameraResolution.X = 0) Then
            ticCameraResolution.X = 640
            ticCameraResolution.Y = 480
        End If
        frmLandMarkEdit.UpDnLocX.Maximum = imgMap.Width
        frmLandMarkEdit.UpDnLocY.Maximum = imgMap.Height
        frmLandMarkEdit.UpDnValidX.Maximum = imgMap.Width
        frmLandMarkEdit.UpDnValidY.Maximum = imgMap.Height
        frmLandMarkEdit.UpDnValidWidth.Maximum = imgMap.Width
        frmLandMarkEdit.UpDnValidHeight.Maximum = imgMap.Height
        boolStop = False

        frmRangeFinder.Visible = False
        frmPose.Visible = False
        frmDebug.Visible = boolViewDebug
        frmLandMarkEdit.Visible = boolViewLM
        frmLM_Image.Visible = False
        frmRangeFinder.Visible = False
        boolRangersAreEnabled = frmRangeFinder.ftnRangersAreEnabled()
        tbpTargetPoseGlobal = tbpBotPose
        subEndImageRecognition()
        boolSettingsChanged = False
        If boolEnableGotAGlyph And (ProcessesRunning("GotAGlyph") = 0) Then Process.Start(Environment.CurrentDirectory & "\GotAGlyph\GotAGlyph.exe", "")
        timerWatchDog.Interval = 60000
        timerWatchDog.Enabled = True
        frmCompass.Visible = False
        frmCompass.subCompassLoad(sender, e)
        subCalculateKinectBeamAngles()
        subCalculateKinectCoefficients()
        strTypeOfMove = ""
        ftnSendCommand("stop")  ' force login for the ER1 I/F 
        subInitializeDrivingControl(tbpBotPose)
        ftnGotAGlyph_Communicate("glyph", ">", 500)
        ftnLRCC_Communicate("events" & vbCrLf, "OK", 1000)
        ftnSendCommand("battery")
        AboutBox1.LabelVer.Text = "Version " & My.Application.Info.Version.ToString
        subConvertMapToArray()
        timeMoveCommandSent = Now()
        subRecalculatePreDefinedDistances()
        subConfigure_Click(sender, e)
        ftnBotStop(tbpBotPose)
        strStatusDriving = "Waiting for command "
        subStartSpeechRecognition()
        System.Windows.Forms.Application.DoEvents()
        ftnSendCommand("play phrase 'Ready'")
        subRedraw(tbpBotPose)
    End Sub

    Dim boolRedrawInProgress As Boolean = False
    Public Sub subRedraw(ByVal tbpBotPose As typeBotPose)
        On Error Resume Next
        If Not boolRedrawInProgress Then
            boolRedrawInProgress = True
            If Not Me.myMap.InvokeRequired Then
                If (boolAllowRoboRealmToControlBot And (Not boolAllowRRToControlBotIsActive)) Then AllowRRToControlBot()
                If (Me.WindowState <> FormWindowState.Minimized) Then
                    If Me.Width > Screen.PrimaryScreen.Bounds.Width Then _
                        Me.Width = Screen.PrimaryScreen.Bounds.Width
                    If Me.Height > Screen.PrimaryScreen.Bounds.Height Then _
                        Me.Height = Screen.PrimaryScreen.Bounds.Height
                End If
                subLoadImage()
                subUpdateAllText(tbpBotPose)
                If boolPlaceBot Then
                    Me.picBot.BorderStyle = FormBorderStyle.Fixed3D
                Else
                    Me.picBot.BorderStyle = FormBorderStyle.None
                End If
                If boolPlaceDestination Then
                    Me.picDestination.BorderStyle = FormBorderStyle.Fixed3D
                Else
                    Me.picDestination.BorderStyle = FormBorderStyle.None
                End If
                If boolStop Then
                    Me.picStop.BorderStyle = FormBorderStyle.Fixed3D
                Else
                    Me.picStop.BorderStyle = FormBorderStyle.None
                End If
                If boolPause Then
                    Me.picPause.BorderStyle = FormBorderStyle.Fixed3D
                Else
                    Me.picPause.BorderStyle = FormBorderStyle.None
                End If
                If Not boolBotIsMoving Then
                    boolViewDebug = frmDebug.Visible
                    boolSettingsChangedTemp = boolSettingsChanged
                    boolViewLM = frmLandMarkEdit.Visible
                    boolSettingsChanged = boolSettingsChangedTemp
                    If boolDock Then subDrawSmallPurpleCircle(tmcDock)
                End If
                If Not boolDrivingToDestination Then myMap.Select()
            End If
            Me.Refresh()
            If boolDrivingToDestination Then subShowPath(tmcDestination)
            subDrawBot(tbpBotPose)
            boolRedrawInProgress = False
        End If
    End Sub

    Public Sub subUpdateAllText(ByVal tbpBotPose As typeBotPose)
        On Error Resume Next
        If Not Me.InvokeRequired Then
            Me.updnOrientation.Value = tbpBotPose.Orientation
            subUpdateStatusLine()

            If frmPose.Visible Then
                frmPose.updnLocationX.Value = tbpBotPose.Location.X
                frmPose.updnLocationY.Value = tbpBotPose.Location.Y
                frmPose.updnOrientation.Value = tbpBotPose.Orientation
                frmPose.updnUncertaintyX.Value = tbpBotPose.LocationUncertainty.X
                frmPose.updnUncertaintyY.Value = tbpBotPose.LocationUncertainty.Y
                frmPose.updnOrientationUncertainty.Value = tbpBotPose.OrientationUncertainty
            End If
        End If
    End Sub

    Public Sub subUpdateStatusLine()
        On Error Resume Next
        If Not Me.InvokeRequired Then
            If (sngLaptopBatteryPercent <> 999) Then _
                strStatusLaptopVoltage = "Laptop: " & sngLaptopBatteryPercent.ToString & "%"
            boolLocalRCCConnected = (boolEnableLocalRCC And classLRCCClient.Connected)
            boolRRConnected = ((boolRoboRealmBotSelected Or boolEnableLocalRR) And classRoboRealmClient.Connected)
            strStatusCommunications = "Comms: "
            If boolBotConnected Then strStatusCommunications += "Bot "
            If boolCompassAttached Then strStatusCommunications += "Compass "
            If boolRRConnected Then strStatusCommunications += "RR "
            If boolLocalRCCConnected Then strStatusCommunications += "LRCC "
            If classAPI1Server.Connected Then strStatusCommunications += "API "
            If classAPI2Server.Connected Then strStatusCommunications += "API2 "
            If boolEnableGotAGlyph And classGotAGlyphClient.Connected Then strStatusCommunications += "Glyph "
            If boolKinectConnected Then _
                strStatusCommunications += "Kinect "

            Dim stbStatus As StringBuilder = New StringBuilder(strStatusDriving)
            Dim cap As Int16 = stbStatus.EnsureCapacity(191)
            stbStatus.Append("                                             ")
            stbStatus.Remove(40, stbStatus.Length - 40)
            stbStatus.Append(strStatusCommunications)
            stbStatus.Append("                                   ")
            stbStatus.Remove(70, stbStatus.Length - 70)
            stbStatus.Append(strStatusBotVoltage)
            stbStatus.Append("                 ")
            stbStatus.Remove(85, stbStatus.Length - 85)
            stbStatus.Append(strStatusLaptopVoltage)
            stbStatus.Append("                         ")
            stbStatus.Remove(105, stbStatus.Length - 105)
            stbStatus.Append(strStatusMouseCoordinates)
            stbStatus.Append("                    ")
            stbStatus.Remove(120, stbStatus.Length - 120)
            stbStatus.Append(strStatusMapContents)

            Me.StatusDriving.Text = stbStatus.ToString
        End If
    End Sub

    Private Sub subSizeChanged(ByVal sender As System.Object, ByVal e As MouseEventArgs)
        subRedraw(tbpBotPose)
    End Sub

    Public Sub subBotSpeedCalculations()
        On Error Resume Next
        sngBotLinearAccelerationTime = sngBotLinearVelocity / sngBotLinearAcceleration
        sngBotLinearAccelerationDistance = ftnCmToMapUnits(sngBotLinearAcceleration * sngBotLinearAccelerationTime * sngBotLinearAccelerationTime * 0.5)
        sngBotLinearVelocityXY = ftnMinValue(sngBotLinearVelocity, 30)
        sngBotLinearAccelerationTimeXY = sngBotLinearVelocityXY / sngBotLinearAcceleration
        sngBotLinearAccelerationDistanceXY = ftnCmToMapUnits(sngBotLinearAcceleration * sngBotLinearAccelerationTimeXY * sngBotLinearAccelerationTimeXY * 0.5)
        sngBotAngularAccelerationTime = sngBotAngularVelocity / sngBotAngularAcceleration
        sngBotAngularAccelerationDistance = (sngBotAngularAcceleration * sngBotAngularAccelerationTime * sngBotAngularAccelerationTime * 0.5)
    End Sub

    Public Sub subLoadImage()
        On Error Resume Next
        myMap.Image = imgMap
        myMap.Width = CInt(sngZoom * imgMap.Width)
        myMap.Height = CInt(sngZoom * imgMap.Height)
    End Sub

    Private Sub myMap_MouseWheel(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles myMap.MouseWheel
        On Error Resume Next
        If Not Me.InvokeRequired Then
            If (e.Delta <> 0) And (Me.WindowState <> FormWindowState.Minimized) Then
                If (Me.Height > Me.Width) Then
                    Me.Height += CInt(Me.Height * e.Delta / 1000)
                    If e.Delta <= 0 Then
                        If Me.Height < 320 Then Me.Height = 320 'minimum 
                    End If
                    If Me.Height > Screen.PrimaryScreen.Bounds.Height Then _
                        Me.Height = Screen.PrimaryScreen.Bounds.Height
                    myMap.Height = Me.Height - 150
                    sngZoom = CSng(myMap.Height / Map_SizeY)
                    myMap.Width = sngZoom * Map_SizeX
                    Me.Width = myMap.Width + 80
                    If Me.Width > Screen.PrimaryScreen.Bounds.Width Then _
                       Me.Width = Screen.PrimaryScreen.Bounds.Width
                Else
                    Me.Width += CInt(Me.Width * e.Delta / 1000)
                    If e.Delta <= 0 Then
                        If Me.Width < 320 Then Me.Width = 320 'minimum 
                    End If
                    If Me.Width > Screen.PrimaryScreen.Bounds.Width Then _
                        Me.Width = Screen.PrimaryScreen.Bounds.Width
                    myMap.Width = Me.Width - 80
                    sngZoom = CSng(myMap.Width / Map_SizeX)
                    myMap.Height = sngZoom * Map_SizeY
                    Me.Height = myMap.Height + 150
                    If Me.Height > Screen.PrimaryScreen.Bounds.Height Then _
                       Me.Height = Screen.PrimaryScreen.Bounds.Height
                End If
                System.Windows.Forms.Application.DoEvents()
                subRedraw(tbpBotPose)
            End If
        End If
    End Sub


    Public Sub myMap_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles myMap.MouseClick, myMap.MouseUp, myMap.Click
        On Error Resume Next
        Dim tmcMapPoint As typeMapCoordinate = ftnMouseToMapPosition()
        tmcMapPoint = ftnCheckMapArrayLimits(tmcMapPoint)
        boolMouseDown = (e.Button = MouseButtons.Left)

        If e.Button = MouseButtons.Right Then
            boolMouseDown = False
            MapContextMenu.Visible = True
            MapContextMenu.Left = MousePosition.X
            MapContextMenu.Top = MousePosition.Y
        ElseIf (boolPlaceBot And boolMouseDown) Then
            frmDebug.subWriteLogs(Color.Black, " ")
            frmDebug.subWriteLogs(Color.Black, " ")
            frmDebug.subWriteLogs(Color.Black, " ******************************************************************************************")
            frmDebug.subWriteLogs(Color.Black, " ")
            frmDebug.subWriteLogs(Color.Black, " New Bot Location selected: Location = " & tmcMapPoint.X & ", " & tmcMapPoint.Y)
            tbpBotPose.Location = tmcMapPoint 'Place the bot icon
            subRedraw(tbpBotPose)
        ElseIf (boolPlaceDestination And boolMouseDown) Then
            boolPlaceDestination = False
            boolStop = False
            frmDebug.subWriteLogs(Color.Black, " ")
            frmDebug.subWriteLogs(Color.Black, " ")
            frmDebug.subWriteLogs(Color.Black, " ******************************************************************************************")
            frmDebug.subWriteLogs(Color.Black, " ")
            frmDebug.subWriteLogs(Color.Black, " New destination selected: Location = " & tmcMapPoint.X & ", " & tmcMapPoint.Y)
            tmcDestination = tmcMapPoint  'Place the Destination icon
            subRedraw(tbpBotPose)
            subDrawDestination(tmcDestination)
            ftnSendCommand("play phrase 'Searching for path!'")
            boolDock = False
            subDriveToDestination_Top(tmcDestination) ' Drive to destination
        ElseIf (frmLandMarkEdit.Visible And frmLandMarkEdit.boolLocationFocused And boolMouseDown) Then ' Enter a Landmark Location
            Dim tmcLMLocation As typeMapCoordinate = ftnMouseToMapPosition()
            frmLandMarkEdit.UpDnLocX.Value = tmcLMLocation.X
            frmLandMarkEdit.UpDnLocX.Text = tmcLMLocation.X
            frmLandMarkEdit.UpDnLocY.Value = tmcLMLocation.Y
            frmLandMarkEdit.UpDnLocY.Text = tmcLMLocation.Y
            subRedraw(tbpBotPose)
        End If
    End Sub

    Public Sub myMap_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles myMap.MouseMove
        On Error Resume Next
        Dim tmcMapPoint As typeMapCoordinate = ftnMouseToMapPosition()
        myMap.Select()
        strStatusMouseCoordinates = tmcMapPoint.X.ToString("0000") & ", " & tmcMapPoint.Y.ToString("0000")
        If boolSlam Then
            strStatusMapContents = byteSlamRawMapArray(tmcMapPoint.X, tmcMapPoint.Y).ToString & ", " & intPathArray(tmcMapPoint.X, tmcMapPoint.Y)
        Else
            strStatusMapContents = byteNavigationMap(tmcMapPoint.X, tmcMapPoint.Y).ToString & ", " & intPathArray(tmcMapPoint.X, tmcMapPoint.Y)
        End If
        If e.Button <> MouseButtons.Left Then boolMouseDown = False
        If (boolPlaceBot And boolMouseDown) Then    'Drag the bot icon
            tbpBotPose.Location = ftnMouseToMapPosition()
            boolSettingsChanged = True
            subRedraw(tbpBotPose)
        ElseIf (boolPlaceDestination And boolMouseDown) Then
            tmcDestination = tmcMapPoint  'Place the Destination icon
            subRedraw(tbpBotPose)
            subDrawDestination(tmcDestination)
        ElseIf frmLandMarkEdit.Visible And boolMouseDown And frmLandMarkEdit.boolValidtyRegionFocused Then
            subLMValidityRegion(tmcMouseDown)
        ElseIf frmLandMarkEdit.Visible And boolMouseDown And frmLandMarkEdit.boolLocationFocused Then
            frmLandMarkEdit.UpDnLocX.Value = tmcMapPoint.X
            frmLandMarkEdit.UpDnLocX.Text = tmcMapPoint.X
            frmLandMarkEdit.UpDnLocY.Value = tmcMapPoint.Y
            frmLandMarkEdit.UpDnLocY.Text = tmcMapPoint.Y
            subRedraw(tbpBotPose)
        Else
            subUpdateAllText(tbpBotPose)
        End If
    End Sub


    Dim tmcMouseDown As typeMapCoordinate
    Public Sub myMap_Down(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles myMap.MouseDown
        On Error Resume Next
        boolMouseDown = (e.Button = MouseButtons.Left)
        If e.Button = MouseButtons.Right Then
            boolMouseDown = False
            MapContextMenu.Visible = True
            MapContextMenu.Left = MousePosition.X
            MapContextMenu.Top = MousePosition.Y
        ElseIf boolPlaceDestination = False And boolPlaceBot = False And boolMouseDown _
            And frmLandMarkEdit.Visible And frmLandMarkEdit.boolValidtyRegionFocused Then  ' Determine LandMark Validity area
            tmcMouseDown = ftnMouseToMapPosition()
        ElseIf boolPlaceDestination = False And boolPlaceBot = False And boolMouseDown _
                 And frmLandMarkEdit.Visible And frmLandMarkEdit.boolLocationFocused And boolMouseDown Then
            Dim tmcLMLocation As typeMapCoordinate = ftnMouseToMapPosition()
            frmLandMarkEdit.UpDnLocX.Value = tmcLMLocation.X
            frmLandMarkEdit.UpDnLocX.Text = tmcLMLocation.X
            frmLandMarkEdit.UpDnLocY.Value = tmcLMLocation.Y
            frmLandMarkEdit.UpDnLocY.Text = tmcLMLocation.Y
            subRedraw(tbpBotPose)
        End If
    End Sub


    Public Sub myMap_DragOver(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Activated
        On Error Resume Next
        subWait(100)
        subDrawBot(tbpBotPose)
    End Sub

    Public Sub me_DragOver(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.DragOver
        subDrawBot(tbpBotPose)
    End Sub

    Public Sub me_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Shown
        On Error Resume Next
        subWait(100)
        subDrawBot(tbpBotPose)
    End Sub


    Sub subLMValidityRegion(ByVal tmcMouseDown As typeMapCoordinate)
        On Error Resume Next
        If (boolPlaceDestination = False And boolPlaceBot = False And boolMouseDown _
            And frmLandMarkEdit.Visible = True) And frmLandMarkEdit.boolValidtyRegionFocused Then  ' Determine LandMark Validity area
            If (ftnMouseToMapPosition().Y >= tmcMouseDown.Y) Then
                frmLandMarkEdit.UpDnValidHeight.Value = ftnMouseToMapPosition().Y - tmcMouseDown.Y
                frmLandMarkEdit.UpDnValidY.Value = tmcMouseDown.Y
            Else
                frmLandMarkEdit.UpDnValidHeight.Value = (tmcMouseDown.Y - ftnMouseToMapPosition().Y)
                frmLandMarkEdit.UpDnValidY.Value = ftnMouseToMapPosition().Y
            End If
            If (ftnMouseToMapPosition().X >= tmcMouseDown.X) Then
                frmLandMarkEdit.UpDnValidWidth.Value = ftnMouseToMapPosition().X - tmcMouseDown.X
                frmLandMarkEdit.UpDnValidX.Value = tmcMouseDown.X
            Else
                frmLandMarkEdit.UpDnValidWidth.Value = (tmcMouseDown.X - ftnMouseToMapPosition().X)
                frmLandMarkEdit.UpDnValidX.Value = ftnMouseToMapPosition().X
            End If
            tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.X = frmLandMarkEdit.UpDnValidX.Value
            tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Y = frmLandMarkEdit.UpDnValidY.Value
            tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Width = frmLandMarkEdit.UpDnValidWidth.Value
            tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Height = frmLandMarkEdit.UpDnValidHeight.Value
            frmLandMarkEdit.UpDnValidX.Text = frmLandMarkEdit.UpDnValidX.Value.ToString
            frmLandMarkEdit.UpDnValidY.Text = frmLandMarkEdit.UpDnValidY.Value.ToString
            frmLandMarkEdit.UpDnValidWidth.Text = frmLandMarkEdit.UpDnValidWidth.Value.ToString
            frmLandMarkEdit.UpDnValidHeight.Text = frmLandMarkEdit.UpDnValidHeight.Value.ToString
            frmLandMarkEdit.subLM_Refresh()
        End If
    End Sub



    Private Sub updnOrientation_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnOrientation.ValueChanged
        Try
            If Not Me.InvokeRequired Then
                System.Windows.Forms.Application.DoEvents()
                If (tbpBotPose.Orientation <> updnOrientation.Value) Then
                    updnOrientation.Enabled = False
                    tbpBotPose.Orientation = ftnConvertTo360(updnOrientation.Value)
                    tbpTargetPoseGlobal = tbpBotPose
                    subRedraw(tbpBotPose)
                    updnOrientation.Value = tbpBotPose.Orientation
                    updnOrientation.Enabled = True
                End If
            End If
        Catch
            updnOrientation.Enabled = True
        End Try
    End Sub
  


    Private Sub picStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picStop.Click
        On Error Resume Next
        boolStop = Not boolStop
        If boolStop Then
            Me.picStop.BorderStyle = FormBorderStyle.Fixed3D
        Else
            Me.picStop.BorderStyle = FormBorderStyle.None
        End If
        If boolStop Then
            tbpBotPose = ftnBotStop(tbpBotPose)
            boolDock = False
            boolDrivingToDestination = False
            subRedraw(tbpBotPose)
            frmDebug.subWriteLogs(Color.Black, Now() & "    >>>>  STOP button was pushed  >>> ")
            ftnSendCommand("play phrase 'By your command.'")
        End If
    End Sub


    Private Sub picPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picPause.Click
        On Error Resume Next
        boolPause = Not boolPause
        subRedraw(tbpBotPose)
        If boolPause Then frmDebug.subWriteLogs(Color.Black, Now() & "    >>>>  PAUSE button was pushed  >>> ")
    End Sub

    Private Function ftnMouseToMapPosition() As typeMapCoordinate
        On Error Resume Next
        If CBool(InStr(Environment.OSVersion.ToString, "6.2")) Then 'Windows 8
            ftnMouseToMapPosition.X = CShort((MousePosition.X - Me.Location.X - myMap.Location.X - myMap.Padding.Left - myMap.Margin.Left - 8) / sngZoom)
            ftnMouseToMapPosition.Y = (MousePosition.Y - Me.Location.Y - myMap.Location.Y - myMap.Padding.Top - myMap.Margin.Top - 29) / sngZoom
        Else
            ftnMouseToMapPosition.X = CShort((MousePosition.X - Me.Location.X - myMap.Location.X - myMap.Padding.Left - myMap.Margin.Left - 8) / sngZoom)
            ftnMouseToMapPosition.Y = (MousePosition.Y - Me.Location.Y - myMap.Location.Y - myMap.Padding.Top - myMap.Margin.Top - 19 - 10) / sngZoom
        End If
        ftnMouseToMapPosition = ftnCheckMapArrayLimits(ftnMouseToMapPosition)
    End Function









    '==========================  MENUS  ==================================================



    '==========================  File Menu  ==================================================

    Public Sub mnuLoadSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLoadSettings.Click
        On Error Resume Next
        Me.StatusDriving.ForeColor = Color.Black
        LoadSettings("GotABot_Settings.xml")
        boolSettingsChanged = False
        sngZoom = CSng(myMap.Height / Map_SizeY)
        subRedraw(tbpBotPose)
        subConvertMapToArray()
        strStatusDriving = "Waiting for command "
        subRedraw(tbpBotPose)
        ftnSendCommand("play phrase 'Ready'")
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuLoadSettingsFileSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLoadSettingsFileSelect.Click
        On Error Resume Next
        Me.StatusDriving.ForeColor = Color.Black
        OpenFD.Title = "Load GotABot Settings"
        OpenFD.Filter = "xml Files(*.xml)|*.xml"
        Dim DidWork As Integer = OpenFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then _
        LoadSettings(OpenFD.FileName)
        boolSettingsChanged = False
        sngZoom = CSng(myMap.Height / Map_SizeY)
        subRedraw(tbpBotPose)
        subConvertMapToArray()
        strStatusDriving = "Waiting for command "
        subRedraw(tbpBotPose)
        ftnSendCommand("play phrase 'Ready'")
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Public Sub mnuSaveSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveSettings.Click
        On Error Resume Next
        SaveSettings("GotABot_Settings.xml")
        boolSettingsChanged = False
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuSaveSettingsFileSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveSettingsFileSelect.Click
        On Error Resume Next
        Dim saveFD As New SaveFileDialog()
        saveFD.Title = "GotABot Settings Changed - Save?"
        saveFD.Filter = "xml Files(*.xml)|*.xml"
        Dim DidWork As Integer = saveFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then _
        SaveSettings(saveFD.FileName)
        boolSettingsChanged = False
        'GC.Collect()
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuNewLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNewLog.Click
        On Error Resume Next
        If (Dir("GotABot_Log.txt") <> "") Then My.Computer.FileSystem.DeleteFile("GotABot_Log.txt", _
                FileIO.UIOption.AllDialogs, FileIO.RecycleOption.DeletePermanently, FileIO.UICancelOption.DoNothing)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuOpenMapLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOpenMapLog.Click
        On Error Resume Next
        Process.Start("notepad", "GotABot_Log.txt")
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuVerboseLogFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuVerboseLogFile.Click
        On Error Resume Next
        boolVerboseLogFile = Not (boolVerboseLogFile)
        mnuVerboseLogFile.Checked = boolVerboseLogFile
        If boolVerboseLogFile Then
            boolDebugLWM = boolVerboseLogFile
            boolDebugER1IF = boolVerboseLogFile
            boolDebugAPI_IF = boolVerboseLogFile
            boolDebugOdometry = boolVerboseLogFile
            boolDebugLocalize2D = boolVerboseLogFile
            boolDebugKinect = boolVerboseLogFile
            boolDebugDock = boolVerboseLogFile
            boolDebugDrive = boolVerboseLogFile
            boolDebugObstacle = boolVerboseLogFile
        End If
        System.Windows.Forms.Application.DoEvents()
    End Sub




    Private Sub mnuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExit.Click
        Me.Close()
    End Sub

    Private Sub me_exit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosed
        On Error Resume Next
        tbpBotPose = modBotMovementControl.ftnBotStop(tbpBotPose)
        boolAllowRoboRealmToControlBot = False
        timerWatchDog.Enabled = False
        boolKinectConnected = False
        bmpMap.Dispose()
        ftnSendCommand("play phrase 'Goodby'")
        boolShutDown = True
        boolStop = True
        'modKinect.ftnKinectStop()
        Dim proc = Process.GetProcessesByName("GotAGlyph")
        For i As Integer = 0 To proc.Count - 1
            proc(i).CloseMainWindow()
            proc(i).Kill()
        Next i
        If boolSettingsChanged Then _
            mnuSaveSettingsFileSelect_Click(sender, e)
        subWait(3000)
    End Sub









    '==========================  Configure Menu  ==================================================


    Private Sub mnuMap_Click(sender As System.Object, e As System.EventArgs)
        On Error Resume Next
        mnuGridSize.Text = "Grid Size            (" & sngGridSize & ")"
        mnuUnits.Text = "Grid Units           (" & strUnits & ")"
    End Sub


    Private Sub mnuEditMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditMap.Click
        On Error Resume Next
        OpenFD.Title = "Edit a Map"
        OpenFD.Filter = "BitMap Files(*.bmp)|*.bmp"
        Dim DidWork As Integer = OpenFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then
            If Not Me.InvokeRequired Then System.Windows.Forms.Application.DoEvents()
            imgMap.Dispose()
            bmpMap.Dispose()

            Dim editMap As Process = Process.Start("mspaint", OpenFD.SafeFileName)
            editMap.WaitForExit()

            imgMap = System.Drawing.Image.FromFile(OpenFD.FileName)
            Me.myMap.Image = imgMap
            bmpMap = CType(System.Drawing.Image.FromFile(OpenFD.FileName), Bitmap)
            Me.myMap.Height = imgMap.Height
            Me.myMap.Width = imgMap.Width
            Map_SizeX = imgMap.Width
            Map_SizeY = imgMap.Height
            ReDim byteNavigationMap(Map_SizeX, Map_SizeY)
            ReDim intPathArray(CInt(Map_SizeX), CInt(Map_SizeY))
            subConvertMapToArray()
        End If
        If Not Me.InvokeRequired Then System.Windows.Forms.Application.DoEvents() ' 
        sngZoom = CSng(myMap.Height / Map_SizeY)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Public Sub mnuOpenMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOpenMap.Click
        On Error Resume Next
        OpenFD.Title = "Open a New Map"
        OpenFD.Filter = "BitMap Files(*.bmp)|*.bmp"
        Dim DidWork As Integer = OpenFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then subOpenMap(OpenFD.FileName)
    End Sub

    Private Sub mnuSaveMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveMap.Click
        On Error Resume Next
        Dim saveFD As New SaveFileDialog()
        saveFD.Title = "Save a copy of the map"
        saveFD.Filter = "BitMap Files(*.bmp)|*.bmp"
        Dim DidWork As Integer = saveFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then _
          bmpMap.Save(saveFD.FileName)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Public Sub subOpenMap(ByVal strFileName As String)
        On Error Resume Next
        imgMap.Dispose()
        bmpMap.Dispose()
        imgMap = System.Drawing.Image.FromFile(strFileName)
        Me.myMap.Height = imgMap.Height * sngZoom
        Me.myMap.Width = imgMap.Width * sngZoom
        Map_SizeX = imgMap.Width
        Map_SizeY = imgMap.Height
        Me.Width = Me.myMap.Width + 80
        Me.Height = Me.myMap.Height + 150
        sngZoom = CSng(myMap.Height / Map_SizeY)
        ReDim byteNavigationMap(Map_SizeX, Map_SizeY)
        ReDim intPathArray(CInt(Map_SizeX), CInt(Map_SizeY))
        Me.myMap.Image = imgMap
        bmpMap = New Bitmap(System.Drawing.Image.FromFile(strFileName), Map_SizeX, Map_SizeY)
        If Not boolSlam Then subConvertMapToArray() ' Convert the Map from .bmp format to a byte array
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuGridSize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuGridSize.Click
        On Error Resume Next
        Dim strGridSize As String
        strGridSize = InputBox("How big is each grid square ? ", "Grid Size", Str(sngGridSize))
        If strGridSize <> "" And IsNumeric(strGridSize) Then
            sngGridSize = Convert.ToSingle(strGridSize)
            If (sngGridSize <= 0) Then sngGridSize = 1
        End If
        mnuGridSize.Text = "Grid Size            (" & sngGridSize & ")"
        boolSettingsChanged = True
        subConvertMapToArray()
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuMapUnits_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMapUnits.Click
        On Error Resume Next
        strUnits = Me.mnuMapUnits.Text
        mnuUnits.Text = "Grid Units           (" & strUnits & ")"
        boolSettingsChanged = True
        subRecalculatePreDefinedDistances()
        subRedraw(tbpBotPose)
    End Sub

    Public Sub subRecalculatePreDefinedDistances()
        On Error Resume Next
        sngOneSigma = ftnInchesToMapUnits(5)
        sngOneDotFiveSigma = 1.5 * sngOneSigma
        sngTwoSigma = 2 * sngOneSigma
        sngOneInch = ftnInchesToMapUnits(1)
        sngTwoInches = ftnInchesToMapUnits(2)
        sngFourInches = ftnInchesToMapUnits(4)
        sngFiveInches = ftnInchesToMapUnits(5)
        sngSixInches = ftnInchesToMapUnits(6)
        sngTenInches = ftnInchesToMapUnits(10)
        sngFifteenInches = ftnInchesToMapUnits(15)
        sngTwentyFiveInches = ftnInchesToMapUnits(25)
        sngfortyInches = ftnInchesToMapUnits(40)
        sngSixtyFiveInches = ftnInchesToMapUnits(65)
    End Sub

    Private Sub mnuShowMore_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuShowDebugGraphics.Click
        On Error Resume Next
        boolShowMore = Not (boolShowMore)
        mnuShowDebugGraphics.Checked = boolShowMore
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub








    Private Sub mnuViewLM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuViewLM.Click
        On Error Resume Next
        boolViewLM = True
        frmLandMarkEdit.picLmLoad()
        frmLandMarkEdit.Visible = boolViewLM
        frmLandMarkEdit.Focus()
    End Sub



    Private Sub KinectConfigureToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles KinectConfigureToolStripMenuItem.Click
        On Error Resume Next
        frmKinectConfigure.Visible = True
        frmKinectConfigure.Focus()
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub subConfigure_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuConfigure.Click
        On Error Resume Next
        If boolER1Selected Then
            mnuBotIP.ForeColor = Color.Black
            mnuBotPort.ForeColor = Color.Black
            mnuXYMotion.ForeColor = Color.Black
        Else
            mnuBotIP.ForeColor = Color.LightGray
            mnuBotPort.ForeColor = Color.LightGray
            mnuXYMotion.ForeColor = Color.LightGray
        End If
        If boolER1Selected Then
            mnuBotSelect.Text = "Bot Select                   (ER1)"
        ElseIf boolRoboRealmBotSelected Then
            mnuBotSelect.Text = "Bot Select                   (RR Bot)"
        End If
        If ftnVisualRecognizerEnabled() Then
            mnuCameraFOV.ForeColor = Color.Black
            mnuCameraOffset.ForeColor = Color.Black
            mnuCameraResolution.ForeColor = Color.Black
            mnuRecognitionTime.ForeColor = Color.Black
        Else
            mnuCameraFOV.ForeColor = Color.LightGray
            mnuCameraOffset.ForeColor = Color.LightGray
            mnuCameraResolution.ForeColor = Color.LightGray
            mnuRecognitionTime.ForeColor = Color.LightGray
        End If
        If boolKinectConnected Then
            mnuMidCourseCorrection.ForeColor = Color.Black
        Else
            mnuMidCourseCorrection.ForeColor = Color.LightGray
        End If
        mnuBotIP.Text = "Bot IP Address            (" & ipRobot_IPAddress.ToString & ")"
        mnuBotPort.Text = "Bot Port                      (" & intRobot_Port & ")"
        mnuBotPose.Text = "Pose                      (" & tbpBotPose.Location.X & ", " & tbpBotPose.Location.Y & "    " & tbpBotPose.Orientation & ")"
        mnuBotDiameter.Text = "Bot Diameter                (" & sngBotDiameter & ")"
        mnuCameraResolution.Text = "Camera Resolution       (" & ticCameraResolution.X & ", " & ticCameraResolution.Y & ")"
        mnuCameraFOV.Text = "Camera FOV                 (" & sngCameraFOV & ")"
        mnuCameraOffset.Text = "Camera Offset              (" & sngCameraOffset & ")"
        mnuMovementAccuracy.Text = "Movement Accuracy     (" & sngBotMovementAccuracy & ")"
        mnuMaxTravel.Text = "Max Travel                    (" & sngMaxTravel & ")"
        mnuBotAcceleration.Text = "Acceleration                  (" & sngBotLinearAcceleration & ")"
        mnuVelocity.Text = "Velocity                          (" & sngBotLinearVelocity & ")"
        mnuAngularVelocity.Text = "Angular Velocity             (" & sngBotAngularVelocity & ")"
        mnuAngularAcceleration.Text = "Angular Acceleration      (" & sngBotAngularAcceleration & ")"
        mnuRecognitionTime.Text = "Visual Localization Time  (" & sngLocalizationTime & ")"
        mnuLocalVideoDelay.Text = "Local Video Delay            (" & sngStartOfMoveDelay & ")"
        mnuGridSize.Text = "Grid Size      (" & sngGridSize & ")"
    End Sub


    Private Sub mnuER1Selected_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuER1Selected.Click
        On Error Resume Next
        mnuER1Selected.Checked = Not mnuER1Selected.Checked
        boolER1Selected = mnuER1Selected.Checked
        If boolER1Selected Then
            mnuRoboRealmBotSelected.Checked = False
            boolRoboRealmBotSelected = False
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuEnableBumperSwitches_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableBumperSwitches.Click
        On Error Resume Next
        mnuEnableBumperSwitches.Checked = Not mnuEnableBumperSwitches.Checked
        boolEnableBumperSwitches_ER1 = mnuEnableBumperSwitches.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub




    Private Sub mnuEnableEvolutionIRs_Click(sender As System.Object, e As System.EventArgs) Handles mnuEnableEvolutionIRs.Click  ' 
        On Error Resume Next
        mnuEnableEvolutionIRs.Checked = Not mnuEnableEvolutionIRs.Checked
        boolEnableEvolutionIR_ER1 = mnuEnableEvolutionIRs.Checked
        boolSettingsChanged = True
        If boolEnableEvolutionIR_ER1 Then ftnER1_Communicate("ir all threshold " & intEvolution_IR_Threshold, "OK", 1000)
        If boolEnableEvolutionIR_ER1 Then ftnER1_Communicate("ir all flash 7 ", "OK", 1000)
        If boolEnableEvolutionIR_ER1 Then ftnER1_Communicate("sense ir", "OK", 1000)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuAdjustIR_Threshold_Click(sender As System.Object, e As System.EventArgs) Handles mnuAdjustIR_Threshold.Click
        On Error Resume Next
        Dim strEvolution_IR_Threshold As String
        strEvolution_IR_Threshold = InputBox("Enter IR Collision Threshold (1-100) ", "IR Collision Threshold", Str(intEvolution_IR_Threshold))
        If strEvolution_IR_Threshold <> "" And IsNumeric(strEvolution_IR_Threshold) Then
            intEvolution_IR_Threshold = CInt(Int(strEvolution_IR_Threshold))
            boolSettingsChanged = True
            ftnER1_Communicate("ir all threshold " & intEvolution_IR_Threshold, "OK", 1000)
        End If
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuEnableRangerAveraging_Click(sender As System.Object, e As System.EventArgs) Handles mnuEnableRangerAveraging.Click
        On Error Resume Next
        mnuEnableRangerAveraging.Checked = Not mnuEnableRangerAveraging.Checked
        boolEnableRangerAveraging = mnuEnableRangerAveraging.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuRoboRealmBotSelected_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRoboRealmBotSelected.Click
        On Error Resume Next
        mnuRoboRealmBotSelected.Checked = Not mnuRoboRealmBotSelected.Checked
        boolRoboRealmBotSelected = mnuRoboRealmBotSelected.Checked
        If boolRoboRealmBotSelected Then
            mnuER1Selected.Checked = False
            boolER1Selected = False
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuBotPort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotPort.Click
        On Error Resume Next
        Dim strPort As String
        strPort = InputBox("Enter Bot Port Address ", "Port Address", Str(intRobot_Port))
        If strPort <> "" And IsNumeric(strPort) Then
            intRobot_Port = CInt(Int(strPort))
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuPassword_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuPassword.Click
        On Error Resume Next
        strPassword = InputBox("Enter password ", "Password", "XXXXXXXX")
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuBotDiameter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotDiameter.Click
        On Error Resume Next
        Dim strBotDiameter As String
        strBotDiameter = InputBox("Enter Bot Diameter ", "Bot Diameter", Str(sngBotDiameter))
        If strBotDiameter <> "" And IsNumeric(strBotDiameter) Then
            sngBotDiameter = Convert.ToSingle(strBotDiameter)
            sngBotRadius = sngBotDiameter / 2
        End If
        subConvertMapToArray()
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuRangers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRangers.Click
        On Error Resume Next
        frmRangeFinder.Visible = True
        frmRangeFinder.Focus()
    End Sub

    Private Sub mnuCameraResolution_Click(sender As System.Object, e As System.EventArgs) Handles mnuCameraResolution.Click
        On Error Resume Next
        Dim strCameraResolution As String
        strCameraResolution = InputBox("Enter Camera Resolution in the form 640, 480", "Camera Resolution", Str(ticCameraResolution.X) & ", " & Str(ticCameraResolution.Y))
        strCameraResolution &= " , 640, 480"
        Dim strParsedText As String() = strCameraResolution.Split(","c)
        ticCameraResolution.X = Convert.ToInt16(strParsedText(0))
        ticCameraResolution.Y = Convert.ToInt16(strParsedText(1))
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub CameraFOVToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCameraFOV.Click
        On Error Resume Next
        Dim strCameraFOV As String
        strCameraFOV = InputBox("Enter Camera Field Of View ", "Camera FOV", Str(sngCameraFOV))
        If strCameraFOV <> "" And IsNumeric(strCameraFOV) Then
            sngCameraFOV = Convert.ToSingle(strCameraFOV)
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuCameraOffset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCameraOffset.Click
        On Error Resume Next
        Dim strCameraOffset As String
        strCameraOffset = InputBox("Enter Camera Offset from center of Bot ", "Camera Offset", Str(sngCameraOffset))
        If strCameraOffset <> "" And IsNumeric(strCameraOffset) Then
            sngCameraOffset = Convert.ToSingle(strCameraOffset)
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuMaxTravel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMaxTravel.Click
        On Error Resume Next
        Dim strMaxTravel As String
        strMaxTravel = InputBox("Enter Maximum Distance the Bot should travel before Localizing ", "Max Travel", Str(sngMaxTravel))
        If strMaxTravel <> "" And IsNumeric(strMaxTravel) Then
            sngMaxTravel = Convert.ToSingle(strMaxTravel)
        End If
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuAcceleration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotAcceleration.Click
        On Error Resume Next
        Dim strAcceleration As String
        strAcceleration = InputBox("Enter the Bot Acceleration in centimeters per second /second ", "Acceleration", Str(sngBotLinearAcceleration))
        If strAcceleration <> "" And IsNumeric(strAcceleration) Then
            sngBotLinearAcceleration = Convert.ToSingle(strAcceleration)
            If (sngBotLinearAcceleration <= 0) Then sngBotLinearAcceleration = 1
        End If
        subBotSpeedCalculations()
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuVelocity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuVelocity.Click
        On Error Resume Next
        Dim strVelocity As String
        strVelocity = InputBox("Enter the Bot Linear Velocity in centimeters per second  ", "Velocity", Str(sngBotLinearVelocity))
        If strVelocity <> "" And IsNumeric(strVelocity) Then
            sngBotLinearVelocity = Convert.ToSingle(strVelocity)
        End If
        subBotSpeedCalculations()
        boolSettingsChanged = True
        ftnSendCommand("set linear velocity " & Int(sngBotLinearVelocity).ToString)
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuAngularVelocity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAngularVelocity.Click
        On Error Resume Next
        Dim strAngularVelocity As String
        strAngularVelocity = InputBox("Enter the Bot Angular Velocity in degrees per second  ", "AngularVelocity", Str(sngBotAngularVelocity))
        If strAngularVelocity <> "" And IsNumeric(strAngularVelocity) Then
            sngBotAngularVelocity = Convert.ToSingle(strAngularVelocity)
        End If
        subBotSpeedCalculations()
        boolSettingsChanged = True
        ftnSendCommand("set angular velocity  " & Int(sngBotAngularVelocity).ToString)
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuAngularAcceleration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAngularAcceleration.Click
        On Error Resume Next
        Dim strAngularAcceleration As String
        strAngularAcceleration = InputBox("Enter the Bot Angular Acceleration in degrees per second per second ", "AngularAcceleration", Str(sngBotAngularAcceleration))
        If strAngularAcceleration <> "" And IsNumeric(strAngularAcceleration) Then
            sngBotAngularAcceleration = Convert.ToSingle(strAngularAcceleration)
            If (sngBotAngularAcceleration <= 0) Then sngBotAngularAcceleration = 1
        End If
        subBotSpeedCalculations()
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuMovementAccuracy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMovementAccuracy.Click
        On Error Resume Next
        Dim strBotMovementAccuracy As String
        strBotMovementAccuracy = InputBox("Enter the Bot Movement Accuracy Coefficient" & vbCrLf & _
                                          "        Range = (0 - 1) where:" & vbCrLf & _
                                          " '1' = the Bot moves exactly as commanded" & vbCrLf & _
                                          " '0' = the Bot moves wildly inaccurately", "MovementAccuracy", Str(sngBotMovementAccuracy))
        If strBotMovementAccuracy <> "" And IsNumeric(strBotMovementAccuracy) Then
            sngBotMovementAccuracy = Convert.ToSingle(strBotMovementAccuracy)
        End If
        If (sngBotMovementAccuracy < 0.01) Then sngBotMovementAccuracy = 0.01
        If (sngBotMovementAccuracy > 1) Then sngBotMovementAccuracy = 1
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuCompass_Click(sender As Object, e As EventArgs) Handles mnuCompass.Click
        frmCompass.Visible = True
    End Sub







    Private Sub mnuViewDebug_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuViewDebug.Click
        On Error Resume Next
        boolViewDebug = True
        frmDebug.Visible = boolViewDebug
        frmDebug.Focus()
    End Sub


    Private Sub mnuToolsOptions_Click(sender As System.Object, e As System.EventArgs)
        On Error Resume Next
    End Sub



    Private Sub mnuEnableLocalRCC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableLocalRCC.Click
        On Error Resume Next
        mnuEnableLocalRCC.Checked = Not mnuEnableLocalRCC.Checked
        boolEnableLocalRCC = mnuEnableLocalRCC.Checked
        frmLandMarkEdit.picLmLoad()
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuEnableLocalRR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableLocalRR.Click
        On Error Resume Next
        mnuEnableLocalRR.Checked = Not mnuEnableLocalRR.Checked
        boolEnableLocalRR = mnuEnableLocalRR.Checked
        frmLandMarkEdit.picLmLoad()
        boolSettingsChanged = True
        mnuTools.HideDropDown()
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuEnableBotRCC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableBotRCC.Click
        On Error Resume Next
        mnuEnableBotRCC.Checked = Not mnuEnableBotRCC.Checked
        boolEnableBotRCC = mnuEnableBotRCC.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuEnableGotAGlyph_Click(sender As System.Object, e As System.EventArgs) Handles mnuEnableGotAGlyph.Click
        On Error Resume Next
        mnuEnableGotAGlyph.Checked = Not mnuEnableGotAGlyph.Checked
        boolEnableGotAGlyph = mnuEnableGotAGlyph.Checked
        boolSettingsChanged = True
        If boolEnableGotAGlyph And (ProcessesRunning("GotAGlyph") = 0) Then
            Process.Start(Environment.CurrentDirectory & "\GotAGlyph\GotAGlyph.exe", "")
        End If
        ftnGotAGlyph_Communicate("glyph", ">", 500)
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuEnableAVM_Click(sender As System.Object, e As System.EventArgs) Handles mnuEnableAVM.Click
        On Error Resume Next
        mnuEnableAVM.Checked = Not mnuEnableAVM.Checked
        boolEnableAVM = mnuEnableAVM.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuRangeCalibration_Click(sender As System.Object, e As System.EventArgs) Handles mnuRangeCalibration.Click
        On Error Resume Next
        frmAvmRangeCorrection.Visible = True
        frmAvmRangeCorrection.Focus()
    End Sub


    Function ProcessesRunning(ByVal ProcessName As String) As Integer
        '  Generalized Function to Check if an Instance of Application is running in the machine
        Try
            Return Process.GetProcessesByName(ProcessName).GetUpperBound(0) + 1
        Catch
            Return 0
        End Try
    End Function



    Private Sub mnuEnableYRotation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableYRotation.Click
        On Error Resume Next
        mnuEnableYRotation.Checked = Not mnuEnableYRotation.Checked
        boolEnableYRotation = mnuEnableYRotation.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuSimulatedMovement_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSimulatedMovement.Click
        On Error Resume Next
        If (boolSimulatedMovement = False) Then
            boolSimulatedMovement = True
            mnuSimulatedMovement.Checked = True
        Else
            boolSimulatedMovement = False
            mnuSimulatedMovement.Checked = False
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuLocalize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLocalize.Click
        On Error Resume Next
        boolStop = False
        tbpTargetPoseGlobal = tbpBotPose
        boolRangeReadingsAreFresh = False
        tbpBotPose = ftnLocalize_Top(tbpBotPose)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuSLAM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSLAM.Click
        boolStop = False
        boolSlam = True
        frmSlam.Visible = True
        frmSlam.mnuOpenMapSLAMMap_Click(sender, e)
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuDock_Click(sender As System.Object, e As System.EventArgs) Handles mnuDock.Click
        On Error Resume Next
        mnuDock.Checked = Not mnuDock.Checked
        boolDock = mnuDock.Checked
        If boolDock Then
            boolStop = False
            mnuTools.HideDropDown()
            frmDock.subDock()
        End If
    End Sub

    Private Sub mnuDockConfigure_Click(sender As System.Object, e As System.EventArgs) Handles mnuDockConfigure.Click
        On Error Resume Next
        frmDock.Visible = True
        frmDock.Focus()
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub RecognitionTimeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRecognitionTime.MouseUp
        On Error Resume Next
        Dim strRecognitionTime As String
        strRecognitionTime = InputBox("Enter the time (in seconds) the robot will look for Land Marks (Longer gives better accuracy) ", "Localization Time", Str(sngLocalizationTime))
        If strRecognitionTime <> "" And IsNumeric(strRecognitionTime) Then
            sngLocalizationTime = Convert.ToSingle(strRecognitionTime)
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuLocalVideoDelay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLocalVideoDelay.Click
        On Error Resume Next
        Dim strLocalVideoDelay As String
        strLocalVideoDelay = InputBox("Enter the time (in milliseconds) the robot video is delayed before reaching the image recognizer ", " Video Delay", Str(sngStartOfMoveDelay))
        If strLocalVideoDelay <> "" And IsNumeric(strLocalVideoDelay) Then
            sngStartOfMoveDelay = Convert.ToSingle(strLocalVideoDelay)
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuAllowRoboRealmToControlBot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAllowRoboRealmToControlBot.Click
        On Error Resume Next
        mnuAllowRoboRealmToControlBot.Checked = Not mnuAllowRoboRealmToControlBot.Checked
        boolAllowRoboRealmToControlBot = mnuAllowRoboRealmToControlBot.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        If boolAllowRoboRealmToControlBot Then AllowRRToControlBot()
    End Sub

    Private Sub mnuMute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMute.Click
        On Error Resume Next
        boolMute = Not boolMute
        mnuMute.Checked = boolMute
        If boolMute Then
            ftnSendCommand("clear")
            ftnSendCommand("speak off")
        Else
            ftnSendCommand("clear")
            ftnSendCommand("speak on")
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuNewsURL_Click(sender As Object, e As EventArgs) Handles mnuNewsURL.Click
        On Error Resume Next
        strNewsURL = InputBox("Enter the URL of a news feed ", " News URL", strNewsURL)
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuWeatherURL_Click(sender As Object, e As EventArgs) Handles mnuWeatherURL.Click
        On Error Resume Next
        strWeatherURL = InputBox("Enter the URL of a Yahoo Weather feed.  See http://weather.yahoo.com/ for the URL of your location. ", " Yahoo Weather URL", strWeatherURL)
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuPCVoice_Click(sender As Object, e As EventArgs) Handles mnuPCVoice.Click
        On Error Resume Next
        boolPCVoice = Not boolPCVoice
        mnuPCVoice.Checked = boolPCVoice
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub




    Private Sub mnuBotPose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotPose.Click
        On Error Resume Next
        frmPose.updnLocationX.Value = tbpBotPose.Location.X
        frmPose.updnLocationY.Value = tbpBotPose.Location.Y
        frmPose.updnUncertaintyX.Value = tbpBotPose.LocationUncertainty.X
        frmPose.updnUncertaintyY.Value = tbpBotPose.LocationUncertainty.Y
        frmPose.updnOrientation.Value = tbpBotPose.Orientation
        frmPose.updnOrientationUncertainty.Value = tbpBotPose.OrientationUncertainty
        frmPose.Visible = True
        frmPose.Focus()
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub



    Private Sub mnuBotIP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotIP.Click
        On Error Resume Next
        Dim strIPAddr As String
        strIPAddr = InputBox("Enter Bot IP Address in form 111.222.333.444", "IP Address", Convert.ToString(ipRobot_IPAddress)).Trim
        If strIPAddr <> "" Then
            If ftnIsValidIP(strIPAddr) Then ipRobot_IPAddress = IPAddress.Parse(strIPAddr)
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub



    Private Sub mnuEnableLocalizationWhileMovingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableLocalizationWhileMoving.Click
        On Error Resume Next
        boolEnableLocalizationWhileMoving = Not (boolEnableLocalizationWhileMoving)
        mnuEnableLocalizationWhileMoving.Checked = boolEnableLocalizationWhileMoving
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuMidCourseCorrection_Click(sender As Object, e As EventArgs) Handles mnuMidCourseCorrection.Click
        On Error Resume Next
        boolEnableMidCourseCorrection = Not (boolEnableMidCourseCorrection)
        mnuMidCourseCorrection.Checked = boolEnableMidCourseCorrection
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuXYMotion_Click(sender As Object, e As EventArgs) Handles mnuXYMotion.Click
        On Error Resume Next
        boolEnableXY_Motion = Not (boolEnableXY_Motion)
        mnuXYMotion.Checked = boolEnableXY_Motion
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub VoiceCommandEnableToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles mnuVoiceCommandEnable.Click
        On Error Resume Next
        mnuVoiceCommandEnable.Checked = Not mnuVoiceCommandEnable.Checked
        boolVoiceCommandEnable = mnuVoiceCommandEnable.Checked
        subSpeechEnableChange()
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuLogFileEnable_Click(sender As Object, e As EventArgs) Handles mnuLogFileEnable.Click
        On Error Resume Next
        mnuLogFileEnable.Checked = Not mnuLogFileEnable.Checked
        boolLogFileEnable = mnuLogFileEnable.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    '==========================  Tool Strip  ==================================================


    Private Sub OpenToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripButton.Click
        mnuOpenMap_Click(sender, e)
    End Sub




    '==========================  Map Context Menu  ==================================================

    Private Sub ContextMenuStrip1_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MapContextMenu.Opening
        MapContextMenu.Visible = True
    End Sub



    Private Sub mnuLocalizeContext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLocalizeContext.Click
        mnuLocalize_Click(sender, e)
    End Sub


    Private Sub mnuAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAbout.Click
        AboutBox1.Visible = True
    End Sub



    '==================================== Keyboard Manual Control  =============================================
    Dim boolManualControl As Boolean = False
    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        On Error Resume Next
        boolStop = False
        If (boolSend_Complete And (boolManualControl = False)) Then
            If Not Me.InvokeRequired Then System.Windows.Forms.Application.DoEvents()
            boolManualControl = True
            boolDocked = False
            If boolDock Then
                boolDock = False
            End If
            Dim tbpTargetPose As typeBotPose
            If e.KeyCode = Keys.Down Then
                frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  BACK")
                tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngMaxTravel)
                tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
            End If
            If e.KeyCode = Keys.Up Then
                frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  FWD")
                tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngMaxTravel)
                tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
            End If
            If e.KeyCode = Keys.Right Then
                frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  TURN RIGHT")
                tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation - 135)
                tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
            End If
            If e.KeyCode = Keys.Left Then
                frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  TURN LEFT")
                tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 135)
                tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
            End If
        End If
    End Sub

    Private Sub Form_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
        On Error Resume Next
        If (boolManualControl And (boolBotConnected Or (strTypeOfMove = "Turn") Or strTypeOfMove = "Fwd")) Then
            tbpBotPose = ftnBotStop(tbpBotPose)
            subRedraw(tbpBotPose)
            strTypeOfMove = ""
        End If
        subWait(1500)
        boolCollisionDetected = False
        boolManualControl = False
    End Sub








    '==================================== Tool Strip  =============================================

    Private Sub picBot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picBot.Click
        boolPlaceBot = Not boolPlaceBot
        If boolPlaceBot Then boolPlaceDestination = False
        subRedraw(tbpBotPose)
    End Sub

    Private Sub picDestination_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picDestination.Click
        boolPlaceDestination = Not boolPlaceDestination
        If boolPlaceDestination Then boolPlaceBot = False
        subRedraw(tbpBotPose)
    End Sub

    Private Sub SaveToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripButton.MouseUp
        mnuSaveSettings_Click(sender, e)
    End Sub


    Private Sub StatusDriving_Click(sender As Object, e As EventArgs) Handles StatusDriving.Click
        On Error Resume Next
        ftnSendCommand("battery")
        Dim byteCollisionCode1 As Byte = Val(ftnSendCommand("bumper"))
        Select Case byteCollisionCode1
            Case 4
                subDrawBumperSwitch(tbpBotPose, 0)
            Case 6
                subDrawBumperSwitch(tbpBotPose, -45)
            Case 5
                subDrawBumperSwitch(tbpBotPose, 45)
            Case 3
                subDrawBumperSwitch(tbpBotPose, 180)
            Case Else
        End Select
    End Sub

    'Private Sub StatusDriving_Map(sender As Object, e As EventArgs) Handles StatusDriving.DoubleClick
    '    On Error Resume Next
    '    For intX = 0 To Map_SizeX - 1      '  Show the buffer space
    '        For intY = 0 To Map_SizeY - 1
    '            System.Windows.Forms.Application.DoEvents()
    '            If (byteNavigationMap(intX, intY) = 0) Then
    '                subDrawMapPixel(intX, intY, Color.Green)
    '            ElseIf (byteNavigationMap(intX, intY) > 0) And (byteNavigationMap(intX, intY) < byteNoGoNearWallSpaceThreshold) Then
    '                subDrawMapPixel(intX, intY, Color.Yellow)
    '            ElseIf (byteNavigationMap(intX, intY) > 0) And (byteNavigationMap(intX, intY) <= constMaxBufferSpaceCost) Then
    '                subDrawMapPixel(intX, intY, Color.Red)
    '            End If
    '        Next intY
    '    Next intX
    'End Sub


    Private Sub mnuHelpContents_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpContents.Click
        Process.Start("GotABot User Manual.pdf")
    End Sub

    Private Sub HelpToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HelpToolStripButton.Click
        Process.Start("GotABot User Manual.pdf")
    End Sub





    '==================================== WatchDog - Dock, API Disconnect  =============================================

    Private Sub timerWatchDog_Tick(sender As System.Object, e As System.EventArgs) Handles timerWatchDog.Tick
        On Error Resume Next
        If Not boolBotIsMoving And Not boolLocalizationInProgress And Not boolShutDown Then
            timerWatchDog.Enabled = False
            subCheckForAPITimeout()
            'ftnKinectInitializeTop()
            boolCompassAttached = (frmSpatial.spatial.compassAxes.Count > 0)
            If (strStatusBotVoltage = "   ??   ") Or CBool(InStr(strStatusBotVoltage, "--")) Then sngBotBatteryVoltage = sngDockTriggerBot
            ftnSendCommand("battery")  'Recheck
            If boolDock And ((sngBotBatteryVoltage > sngDockTriggerBot * 1.05) And (sngLaptopBatteryPercent > intDockTriggerPC * 1.1)) Then
                boolDock = False
            ElseIf Not boolDock And ((sngBotBatteryVoltage < sngDockTriggerBot) Or (sngLaptopBatteryPercent < intDockTriggerPC)) Then
                If (strStatusBotVoltage = "   ??   ") Then sngBotBatteryVoltage = sngDockTriggerBot
                If Not boolBotIsMoving And ((sngBotBatteryVoltage < sngDockTriggerBot) Or (sngLaptopBatteryPercent < intDockTriggerPC)) Then
                    If Not boolBotIsMoving And ((sngBotBatteryVoltage < sngDockTriggerBot) Or (sngLaptopBatteryPercent < intDockTriggerPC)) Then
                        subWait(1000)
                        ftnSendCommand("battery")  'Recheck
                        If (strStatusBotVoltage = "   ??   ") Then sngBotBatteryVoltage = sngDockTriggerBot
                        If Not boolDock And Not boolCollisionDetected And ((sngBotBatteryVoltage < sngDockTriggerBot) Or (sngLaptopBatteryPercent < intDockTriggerPC)) Then
                            mnuDock.Checked = True
                            boolStop = False
                            boolPause = False
                            frmDock.subDock()
                        End If
                    End If
                End If
            End If
            timerWatchDog.Enabled = True
        End If
    End Sub





    Public Sub subAPI_Redraw()
        On Error Resume Next
        If Me.myMap.InvokeRequired Then
            Dim newDelegate As New DelegateevntAPI(AddressOf subAPI_Redraw)
            Me.Invoke(newDelegate)
        Else
            If Not (Me.FileToolStripMenuItem1.Selected Or Me.FileToolStripMenuItem1.Pressed _
                      Or Me.mnuConfigure.Selected _
                      Or Me.mnuTools.Selected Or Me.mnuTools.Pressed _
                      Or Me.HelpToolStripMenuItem1.Selected Or Me.HelpToolStripMenuItem1.Pressed _
                      Or Me.updnOrientation.Focused Or boolSimulatedMovement Or boolBotIsMoving _
                      Or boolDrivingToDestination) Then _
                 Me.subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        End If
    End Sub
End Class








