﻿
Imports System.Math
Imports System.Threading
Imports Microsoft.Kinect


Public Module modCourseCorrection
    Public strDebug As String = ""
    Public Class classCourseCorrection
        Dim intStartPoseCorrection As Short = 0

        Public Sub subCourseCorrection_Top()
            On Error Resume Next
            Dim intLocalizationsWhileMoving As Short = 0
            Dim intCouseCorrections As Short = 0
            Dim tbpScanPose, tbpDRPose As typeBotPose
            Dim boolValidLocation As Boolean = False
            Dim sngCorrelationFactorBest As Single
            Dim timeLocalizationStart As DateTime
            While Not boolShutDown
                If Not boolSimulatedMovement And boolKinectConnected And (boolEnableMidCourseCorrection Or boolEnableLocalizationWhileMoving) _
                    And Not boolStop And Not boolPause And (ftnPoseUncertaintyFactor(tbpStartingPose) < 400) Then
                    Dim sngMinDistanceFromTarget As Single = sngFifteenInches * sngBotLinearVelocity / 50
                    Dim sngUncertainty As Single = sngTenInches / sngGridSize
                    While boolBotIsMoving
                        sngCorrelationFactorBest = 0
                        If (strTypeOfMove = "Fwd") Or (strTypeOfMove = "XY") Then
                            tbpDRPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, constGotAKinectDelay, tbpTargetPoseGlobal)
                            If (ftnDistanceBetweenLocations(tbpTargetPoseGlobal.Location, tbpDRPose.Location) > sngMinDistanceFromTarget) Then '  Abort localizations near end of a move which might delay the stationary localization
                                If boolDebugLWM Then
                                    strDebug &= " ===============  " & intLocalizationsWhileMoving & " ===============  " & vbCrLf
                                    strDebug &= " Elapsed Time - Course Correction pre localize :  " & ftnElapsedTime() & vbCrLf
                                End If
                                tbpDRPose.LocationUncertainty.X = sngUncertainty
                                tbpDRPose.LocationUncertainty.Y = sngUncertainty
                                If (strTypeOfMove = "XY") Then
                                    tbpDRPose.OrientationUncertainty = 15
                                Else
                                    tbpDRPose.OrientationUncertainty = 10
                                End If
                                intLocalizationsWhileMoving += 1
                                timeLocalizationStart = Now()
                                tbpScanPose = ftnLocalizeFrom2DScan_Top(tbpDRPose, tbpDRPose, True, boolValidLocation, sngCorrelationFactorBest)
                                If boolDebugLWM Then
                                    strDebug &= " Elapsed Time - Course Correction post localize:  " & ftnElapsedTime() & vbCrLf
                                    strDebug &= "  tbpDRPose = " & tbpDRPose.Location.X & ", " & tbpDRPose.Location.Y & " at " & tbpDRPose.Orientation & " degrees." & vbCrLf
                                    strDebug &= "  ScanPose =  " & tbpScanPose.Location.X & ", " & tbpScanPose.Location.Y & " at " & tbpScanPose.Orientation & " degrees." & vbCrLf
                                    strDebug &= "  sngCorrelationFactorBest =  " & sngCorrelationFactorBest & ", boolValidLocation = " & boolValidLocation & vbCrLf
                                End If
                            End If
                            If (sngCorrelationFactorBest > 0.8) And boolValidLocation And boolEnableLocalizationWhileMoving Then subCorrectStartingOrientation(tbpScanPose)
                            If boolBotIsMoving And boolValidLocation Then
                                If (sngCorrelationFactorBest > 0.9) And boolEnableMidCourseCorrection And _
                                    (ftnDistanceBetweenLocations(tbpTargetPoseGlobal.Location, tbpDRPose.Location) > sngTenInches) And _
                                    (ftnDistanceBetweenLocations(tbpStartingPose.Location, tbpDRPose.Location) > sngTenInches) Then ' perform course correction
                                    Dim timeMoveCommandSent_Old As DateTime = timeMoveCommandSent
                                    timeMoveCommandSent = timeLocalizationStart
                                    Dim tbpStartingPose_Old As typeBotPose = tbpStartingPose
                                    Thread.CurrentThread.Priority = ThreadPriority.Highest
                                    tbpStartingPose = tbpScanPose
                                    tbpDRPose = ftnLocalizeUsingDeadReckoning(tbpScanPose, -0.75, tbpTargetPoseGlobal) ' TODO - Need better delay factor based upon actual delays, velocity and PC speed
                                    strDebug &= "  tbpDRPose corrected for delay = " & tbpDRPose.Location.X & ", " & tbpDRPose.Location.Y & " at " & tbpDRPose.Orientation & " degrees." & vbCrLf
                                    tbpBotPose = tbpDRPose
                                    Dim strMoveType As String = ftnTypeOfMove(tbpDRPose, tbpTargetPoseGlobal)
                                    If (strMoveType <> "Turn") Then
                                        intCouseCorrections += 1
                                        If boolDebugLWM Then strDebug &= "  ##############  Course Correction   " & vbCrLf
                                        tbpDRPose.LocationUncertainty.X += sngTwoInches / sngGridSize
                                        tbpDRPose.LocationUncertainty.Y += sngTwoInches / sngGridSize
                                        tbpDRPose.OrientationUncertainty += 5
                                        Select Case strTypeOfMove
                                            Case "Fwd"
                                                tbpBotPose = ftnBotFwd(tbpDRPose, tbpTargetPoseGlobal)
                                            Case "XY"
                                                tbpTargetPoseGlobal.Orientation = ftnConvertTo360(tbpDRPose.Orientation + 15)
                                                tbpBotPose = ftnBotXY(tbpDRPose, tbpTargetPoseGlobal)
                                            Case "Stop"
                                                tbpBotPose = ftnBotStop(tbpDRPose)
                                        End Select
                                    Else
                                        tbpStartingPose = tbpStartingPose_Old
                                        timeMoveCommandSent = timeMoveCommandSent_Old
                                    End If
                                    Thread.CurrentThread.Priority = ThreadPriority.Normal
                                End If
                            End If
                        ElseIf (strTypeOfMove = "Turn") And (sngBotAngularVelocity <= 25) And boolEnableLocalizationWhileMoving Then  ' modify Starting Pose Location if good correlation
                            If Abs(ftnAngleDifference(tbpDRPose.Orientation, tbpTargetPoseGlobal.Orientation)) > 10 Then
                                tbpDRPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, constGotAKinectDelay, tbpTargetPoseGlobal)
                                tbpDRPose.OrientationUncertainty += sngMinDistanceFromTarget * 6
                                intLocalizationsWhileMoving += 1
                                tbpScanPose = ftnLocalizeFrom2DScan_Top(tbpDRPose, tbpDRPose, True, boolValidLocation, sngCorrelationFactorBest)
                                If (sngCorrelationFactorBest > 0.9) Then
                                    tbpStartingPose.Location = ftnFindAvgPose(tbpStartingPose, tbpScanPose, 0).Location
                                    intStartPoseCorrection += 1
                                    If boolDebugLWM Then strDebug &= "  ##############  Start Location Corrected to " & tbpStartingPose.Location.X & ", " & tbpStartingPose.Location.Y & vbCrLf
                                End If
                            End If
                        End If
                    End While
                    If (boolEnableMidCourseCorrection Or boolEnableLocalizationWhileMoving) And (intLocalizationsWhileMoving > 0) Then
                        If boolDebugLWM Then frmDebug.subWriteLogs(Color.Black, strDebug)
                        frmDebug.subWriteLogs(Color.Black, "         2D Localized While Moving " & intLocalizationsWhileMoving & " times.  Course corrections = " & intCouseCorrections & " times. Starting Pose corrections = " & intStartPoseCorrection & " times. ")
                    End If
                    intLocalizationsWhileMoving = 0
                    intCouseCorrections = 0
                    intStartPoseCorrection = 0
                    strDebug = ""
                Else
                    Thread.Sleep(1000)
                End If
            End While
        End Sub



        Public Sub subCorrectStartingOrientation(ByVal tbpEstimatedPose As typeBotPose)
            On Error Resume Next
            If (strTypeOfMove = "Fwd") Then ' And (tbpStartingPose.OrientationUncertainty < 13) Then
                If (tbpEstimatedPose.Orientation > 90) And (tbpEstimatedPose.Orientation < 270) Then
                    tbpStartingPose.Orientation = ftnConvertTo360(Convert.ToInt16((tbpEstimatedPose.Orientation + tbpStartingPose.Orientation + tbpStartingPose.Orientation)) * 0.33333)
                Else
                    tbpStartingPose.Orientation = ftnConvertTo360(Convert.ToInt16((ftnConvertTo180(tbpEstimatedPose.Orientation) + ftnConvertTo180(tbpStartingPose.Orientation) + ftnConvertTo180(tbpStartingPose.Orientation)) / 3))
                End If
                If boolDebugLWM Then strDebug &= "  ##############  Start Orientation Corrected to " & tbpStartingPose.Orientation & " degrees." & vbCrLf
                intStartPoseCorrection += 1
                'Else
                '    If boolDebugLWM Then strDebug &= "  ##############  No Start Orientation correction allowed for strTypeOfMove = " & strTypeOfMove & "   tbpStartingPose.OrientationUncertainty = " & tbpStartingPose.OrientationUncertainty & vbCrLf
            End If
        End Sub

    End Class
End Module
