﻿' scan 360 degrees and look for landmarks in order to localize
Imports System.Math
Imports Microsoft.Kinect


Module modLocalizeLost

    Public Function ftnLostRecoveryTop(ByVal tbpEstimatedPose As typeBotPose, ByVal tbpTargetPose As typeBotPose) As typeBotPose
        On Error Resume Next
        ftnLostRecoveryTop = tbpEstimatedPose
        If ftnIAmLost(tbpEstimatedPose) And Not boolStop And Not boolShutDown Then
            ftnLostRecoveryTop.OrientationUncertainty = 60
            ftnLostRecoveryTop.LocationUncertainty.X = sngfortyInches / sngGridSize
            ftnLostRecoveryTop.LocationUncertainty.Y = ftnLostRecoveryTop.LocationUncertainty.X
            ftnLostRecoveryTop = ftnLostRecovery(ftnLostRecoveryTop)
            If ftnIAmLost(ftnLostRecoveryTop) And Not boolStop And Not boolShutDown Then
                subWait(1500)
                ftnLostRecoveryTop.OrientationUncertainty = 140
                ftnLostRecoveryTop.LocationUncertainty.X = sngSixtyFiveInches / sngGridSize
                ftnLostRecoveryTop.LocationUncertainty.Y = ftnLostRecoveryTop.LocationUncertainty.X
                ftnLostRecoveryTop = ftnLostRecovery(ftnLostRecoveryTop)
            End If
            If ftnIAmLost(ftnLostRecoveryTop) And Not boolStop And Not boolShutDown Then
                subWait(1500)
                ftnLostRecoveryTop.OrientationUncertainty = 170
                ftnLostRecoveryTop.LocationUncertainty.X = ftnInchesToMapUnits(120) / sngGridSize
                ftnLostRecoveryTop.LocationUncertainty.Y = ftnLostRecoveryTop.LocationUncertainty.X
                ftnLostRecoveryTop = ftnLostRecovery(ftnLostRecoveryTop)
            End If
            If ftnIAmLost(ftnLostRecoveryTop) And Not boolStop And Not boolShutDown Then
                frmDebug.subWriteLogs(Color.Red, intDrivingSequenceNumber & " : HELP!  I'm lost - ")
                strStatusDriving = intDrivingSequenceNumber & " : HELP!  I'm lost -"
                If Not boolStop Then ftnSendCommand("play phrase 'I give up'")
                GotABotClass.subUpdateAllText(ftnLostRecoveryTop)
            ElseIf Not boolStop Then
                ftnSendCommand("play phrase 'Ok. I know where I am.'")
            End If
        End If
    End Function

    Public Function ftnIAmLost(ByVal tbpEstimatedPose As typeBotPose) As Boolean
        On Error Resume Next
        ftnIAmLost = False
        If Not boolSlam Then
            If ((ftnPoseUncertaintyFactor(tbpEstimatedPose) > 1200) _
            Or (tbpEstimatedPose.OrientationUncertainty > 40) _
            Or ((ftnMapUnitsToInches(tbpEstimatedPose.LocationUncertainty.X + tbpEstimatedPose.LocationUncertainty.Y) * sngGridSize) > 50)) Then
                ftnIAmLost = True
            Else
                ftnIAmLost = False
            End If
        End If
    End Function


    Private Function ftnLostRecovery(ByVal tbpEstimatedPose As typeBotPose) As typeBotPose   'Rotate 360 degrees in steps and attempt to localize
        On Error Resume Next
        ftnLostRecovery = tbpEstimatedPose
        tbpTargetPoseGlobal = ftnLostRecovery
        'Dim boolCollisionDetectionEnable_Temp As Boolean = boolCollisionDetectionEnable
        Dim intMaxLostTurns As Short
        Dim intTurnAngle As Short
        If boolKinectConnected Then
            intMaxLostTurns = 5
            intTurnAngle = 60
        Else
            intMaxLostTurns = 360 / sngCameraFOV
            intTurnAngle = sngCameraFOV
        End If
        Dim tbpStartingPose As typeBotPose = tbpEstimatedPose
        boolPoseConfirmedAfterCollision = True
        ftnSendCommand("play phrase 'i am lost'")
        frmDebug.subWriteLogs(Color.Red, "@@@@@@@@@@@@@@@@ I'm lost, Attempting recovery........@@@@@@@@@@@@@@@@@@ ")
        ftnLostRecovery = frmCompass.ftnLocalizeUsingCompass(tbpEstimatedPose, tbpTargetPoseGlobal)
        ftnLostRecovery = ftnGetUnStuck(ftnLostRecovery, "Fwd")
        ftnLostRecovery.OrientationUncertainty = tbpEstimatedPose.OrientationUncertainty
        Dim intTurn As Short = 0
        Do While (ftnIAmLost(ftnLostRecovery) And (intTurn < intMaxLostTurns) And Not boolStop)
            ftnLostRecovery.LocationUncertainty = tbpEstimatedPose.LocationUncertainty
            ftnLostRecovery.OrientationUncertainty = tbpEstimatedPose.OrientationUncertainty
            tbpTargetPoseGlobal = ftnLostRecovery
            subDoEventsIfMainThread()
            GotABotClass.subRedraw(ftnLostRecovery)
            ftnLostRecovery = ftnLocalize_Top(ftnLostRecovery)
            ftnLostRecovery = ftnRefineLocalization(ftnLostRecovery)

            If ftnIAmLost(ftnLostRecovery) Then
                tbpTargetPoseGlobal.Orientation = ftnConvertTo360(ftnLostRecovery.Orientation + intTurnAngle)
                ftnLostRecovery = ftnBotTurn(ftnLostRecovery, False, tbpTargetPoseGlobal)
                subWait(500)
                If ftnAmIStuck(ftnLostRecovery, "Turn", intTurnAngle, tbpStartingPose) Then ftnLostRecovery = ftnGetUnStuck(ftnLostRecovery, "Turn")
                If (ftnCheckForCollision()) Then ftnLostRecovery = ftnCollisionRecovery(ftnLostRecovery)
                intTurn += 1
            End If
        Loop
        'boolCollisionDetectionEnable = boolCollisionDetectionEnable_Temp
    End Function

    Function ftnRefineLocalization(ByVal tbpEstimatedPose As typeBotPose) As typeBotPose
        On Error Resume Next
        ftnRefineLocalization = tbpEstimatedPose
        If ftnVisualRecognizerEnabled() And Not boolStop Then
            For I As Integer = 1 To 3
                If (ftnRefineLocalization.OrientationUncertainty > 20) And (ftnRefineLocalization.OrientationUncertainty < 55) And Not boolStop Then
                    subDoEventsIfMainThread()
                    ftnRefineLocalization = ftnLocalize_Top(ftnRefineLocalization)
                    frmDebug.subWritePoseIfVerbose(" ftnLostRecovery - Refinement :  Bot Pose after Localization", ftnRefineLocalization)
                    GotABotClass.subRedraw(ftnRefineLocalization)
                End If
            Next
        End If
    End Function

   
End Module
