﻿Imports System.Math

Module modLocalizeTop

    Dim boolTemp As Boolean

    Public Function ftnLocalize_Top(ByVal tbpReferencePose As typeBotPose) As typeBotPose
        On Error Resume Next
        boolLocalizationInProgress = True
        ftnLocalize_Top = tbpReferencePose
        If Not boolSimulatedMovement And Not boolShutDown Then
            Dim boolSettingsChangedOld As Boolean = boolSettingsChanged
            tbpReferencePose.Orientation = ftnConvertTo360(tbpReferencePose.Orientation)
            Dim tbp2DPose, tbpVisualPose, tbpRangerPose As typeBotPose
            Dim boolGood2DLocalization As Boolean = False
            Dim boolGoodVisualLocalization As Boolean = False
            Dim boolGoodLocalization As Boolean = False
            Dim sngCorrelationFactorBest As Single = 0
            strStatusDriving = intDrivingSequenceNumber & ":  Localize = "
#If constCompile2dAccelerometer Then
        ftnLocalize_Top = ftnAccelerometerCheck(tbpReferencePose)
#End If
            tbp2DPose = ftnLocalizeFrom2DScan_Top(ftnLocalize_Top, tbpReferencePose, boolBotIsMoving, boolGood2DLocalization, sngCorrelationFactorBest)

            If ftnVisualRecognizerEnabled() Then
                If (Not boolGood2DLocalization Or (ftnPoseUncertaintyFactor(tbp2DPose) > 442)) Then  '(442 = (13 inches + 13 inches) * 17 degrees)
                    subStartImageRecognition()
                    tbpVisualPose = ftnLocalizeUsingVisualLMsTop(ftnLocalize_Top, tbpReferencePose, boolGoodVisualLocalization)
                End If
            End If

            If boolGood2DLocalization And boolGoodVisualLocalization Then
                ftnLocalize_Top = ftnFindAvgPose(tbp2DPose, tbpVisualPose, 0)
            ElseIf boolGood2DLocalization Then
                ftnLocalize_Top = tbp2DPose
            ElseIf boolGoodVisualLocalization Then
                ftnLocalize_Top = tbpVisualPose
            End If

            frmDebug.WritePose(ftnElapsedTime() & "       Pose Derived From All Data      ", ftnLocalize_Top)

            boolSettingsChanged = boolSettingsChangedOld
            GotABotClass.subRedraw(ftnLocalize_Top)
        End If
        boolLocalizationInProgress = False
    End Function






    Public Function ftnAccelerometerCheck(ByVal tbpReferencePose As typeBotPose) As typeBotPose ' check for collision using Kinect Accelerometer 
        ftnAccelerometerCheck = tbpReferencePose
#If constCompile2dAccelerometer Then
        If (strTypeOfMove = "Fwd") Then
            ftnTransmitGotAKinect("get accelerometer distance ", "OK", 500)
            frmDebug.subWriteLogs(Color.Red, "Kinect Accelerometer Distances: " & tmcAccelerometerDistance.X & ", " & tmcAccelerometerDistance.Y)
            Dim tmcAccelerometer As typeMapCoordinate = ftnLocationFromLocation(tbpStartingPose.Location, tbpStartingPose.Orientation, tmcAccelerometerDistance.X)
            frmDebug.subWriteLogs(Color.Navy, "Kinect Accelerometer Pose: " & tmcAccelerometer.X & ", " & tmcAccelerometer.Y)
            If (ftnDistanceBetweenLocations(tbpReferencePose.Location, tmcAccelerometer) > ftnInchesToMapUnits(12)) Then
                'tbpReferencePose.Location = tbpStartingPose.Location
                'ftnAccelerometerCheck.Location = ftnBotOffsetLocation(tmcAccelerometerDistance)
                'ftnAccelerometerCheck.LocationUncertainty.X += ftnInchesToMapUnits(9)
                'ftnAccelerometerCheck.LocationUncertainty.X += ftnInchesToMapUnits(9)
                'ftnAccelerometerCheck.OrientationUncertainty += 15
                frmDebug.WritePose(" Pose after Collision Detected by Kinect sensor", ftnAccelerometerCheck)
            End If
        End If
#End If
    End Function




    Function ftnFindPoseOverlap(ByVal tbpNewPoseReading As typeBotPose, ByVal tbpReferencePose As typeBotPose) As typeBotPose
        ' Use the existing pose to reduce the uncertainties of a new pose reading
        Dim intMaxX, intMaxY, intMinX, intMinY As Integer
        ftnFindPoseOverlap = tbpNewPoseReading
        If (tbpNewPoseReading.Location.X + tbpNewPoseReading.LocationUncertainty.X) > (tbpReferencePose.Location.X + tbpReferencePose.LocationUncertainty.X) Then
            intMaxX = (tbpReferencePose.Location.X + tbpReferencePose.LocationUncertainty.X)
        Else
            intMaxX = (tbpNewPoseReading.Location.X + tbpNewPoseReading.LocationUncertainty.X)
        End If
        If (tbpNewPoseReading.Location.Y + tbpNewPoseReading.LocationUncertainty.Y) > (tbpReferencePose.Location.Y + tbpReferencePose.LocationUncertainty.Y) Then
            intMaxY = (tbpReferencePose.Location.Y + tbpReferencePose.LocationUncertainty.Y)
        Else
            intMaxY = (tbpNewPoseReading.Location.Y + tbpNewPoseReading.LocationUncertainty.Y)
        End If
        If (tbpNewPoseReading.Location.X - tbpNewPoseReading.LocationUncertainty.X) < (tbpReferencePose.Location.X - tbpReferencePose.LocationUncertainty.X) Then
            intMinX = (tbpReferencePose.Location.X - tbpReferencePose.LocationUncertainty.X)
        Else
            intMinX = (tbpNewPoseReading.Location.X - tbpNewPoseReading.LocationUncertainty.X)
        End If
        If (tbpNewPoseReading.Location.Y - tbpNewPoseReading.LocationUncertainty.Y) < (tbpReferencePose.Location.Y - tbpReferencePose.LocationUncertainty.Y) Then
            intMinY = (tbpReferencePose.Location.Y - tbpReferencePose.LocationUncertainty.Y)
        Else
            intMinY = (tbpNewPoseReading.Location.Y - tbpNewPoseReading.LocationUncertainty.Y)
        End If
        ftnFindPoseOverlap.LocationUncertainty.X = (intMaxX - intMinX) / 2
        ftnFindPoseOverlap.Location.X = intMaxX - ftnFindPoseOverlap.LocationUncertainty.X
        ftnFindPoseOverlap.LocationUncertainty.Y = (intMaxY - intMinY) / 2
        ftnFindPoseOverlap.Location.Y = intMaxY - ftnFindPoseOverlap.LocationUncertainty.Y
        ftnFindPoseOverlap = ftnMinPoseUncertainty(ftnFindPoseOverlap)
    End Function


End Module
