﻿Imports System.Math

Module modLocalizeVisualLMs



    Public Function ftnLocalizeUsingVisualLMsTop(ByVal tbpCurrentPose As typeBotPose, ByVal tbpReferencePose As typeBotPose, ByRef boolGoodVisualDLocalization As Boolean) As typeBotPose
        On Error Resume Next
        ftnLocalizeUsingVisualLMsTop = tbpCurrentPose
        If Not boolStop Then
            Dim intValidRecognitions As Short = 0
            Dim intTotalRecognitions As Short = 0
            Dim strStatusDrivingRoot As String = strStatusDriving & ": "
            ftnLocalizeUsingVisualLMsTop = ftnGetPoseUsingObjectRecognition(tbpCurrentPose, tbpReferencePose, intValidRecognitions, intTotalRecognitions)
            ftnLocalizeUsingVisualLMsTop = ftnValidatePose(ftnLocalizeUsingVisualLMsTop, tbpReferencePose, boolGoodVisualDLocalization)
            subEndImageRecognition()

            frmDebug.subWriteLogs(Color.Green, "  ")
            frmDebug.subWriteLogs(Color.Green, "  ")
            frmDebug.subWriteLogs(Color.Green, " ##################################### ")
            frmDebug.subWriteLogs(Color.Green, "  Completed Image Localization.  Valid  = " & intValidRecognitions & ", Total = " & intTotalRecognitions)
            frmDebug.WritePose(ftnElapsedTime() & "       Pose Derived From LM Recognition:", ftnLocalizeUsingVisualLMsTop)
            strStatusDriving = strStatusDrivingRoot & " LMs= " & intValidRecognitions & "/" & intTotalRecognitions
            GotABotClass.subUpdateStatusLine()
            If boolGoodVisualDLocalization Then boolGoodVisualDLocalization = (intValidRecognitions > 0)
            GotABotClass.subRedraw(ftnLocalizeUsingVisualLMsTop)
        End If
    End Function



    Public Function ftnGetPoseUsingObjectRecognition(ByVal tbpCurrentPose As typeBotPose, ByVal tbpReferencePose As typeBotPose, _
                                                     ByRef intValidRecognitions As Short, ByRef intTotalRecognitions As Short) As typeBotPose
        On Error Resume Next
        ftnGetPoseUsingObjectRecognition = tbpCurrentPose
        If ftnVisualRecognizerEnabled() Then
            Dim strObjectRecognized As String = ""
            Dim Time_Now, timeOut, Time_Quit As DateTime
            Dim tbpBotAvgPose As typeBotPose = tbpCurrentPose
            Dim tbpPoseFromLM As typeBotPose
            Dim boolValidLocation As Boolean = False
            Dim boolTemp As Boolean = False
            Dim intBotOutOfLMValidRegion As Short = 0
            Dim intDistanceOutOfRange As Short = 0
            Dim intAngleOutOfRange As Short = 0
            Dim strStatusDrivingRoot As String = strStatusDriving
            If Not boolBotIsMoving Then
                strStatusDriving = strStatusDrivingRoot & "  LMs= Searching ..."
                GotABotClass.subUpdateStatusLine()
                subDrawBot(tbpCurrentPose)
                frmDebug.subWritePoseIfVerbose("Pose Before Using LMs:", tbpCurrentPose)
                subDoEventsIfMainThread()
                Time_Now = Now()
                timeOut = Time_Now.AddMilliseconds(sngLocalizationTime * 1000)
                Time_Quit = Time_Now.AddMilliseconds(sngLocalizationTime * 300)
                If ftnIAmLost(tbpBotPose) Then tbpBotAvgPose = ftnLocalizeMultipleLM_Top(intValidRecognitions, intTotalRecognitions)
                While ((Time_Now < timeOut) And (intValidRecognitions < 15) And (Not boolStop) And _
                      Not boolShutDown And Not ((Time_Now > Time_Quit) And (intTotalRecognitions = 0)))
                    boolValidLocation = False
                    strObjectRecognized = ftnGetNextObject()
                    If strObjectRecognized <> "" Then ' Is it a valid recognition?
                        tbpPoseFromLM = ftnFindPoseFromLM(strObjectRecognized, boolValidLocation, tbpReferencePose, _
                                                       intTotalRecognitions, _
                                                       intBotOutOfLMValidRegion, intDistanceOutOfRange, _
                                                       intAngleOutOfRange)
                        If boolValidLocation Then tbpBotAvgPose = ftnFindAvgPose(tbpBotAvgPose, tbpPoseFromLM, intValidRecognitions)
                        If CBool(InStr(strObjectRecognized, "object")) Then strObjectRecognized = strObjectRecognized.Replace("object", "")
                        strStatusDriving = strStatusDrivingRoot & " LMs= " & "(" & intValidRecognitions & "/" & intTotalRecognitions & ") " & strObjectRecognized
                        GotABotClass.subUpdateStatusLine()
                    End If
                    subDoEventsIfMainThread()
                    Time_Now = Now()
                End While
                If ftnVisualRecognizerEnabled() Then strStatusDriving = strStatusDrivingRoot & " LMs= " & intValidRecognitions & "/" & intTotalRecognitions & " ; "
            End If
            ftnGetPoseUsingObjectRecognition = ftnValidatePose(tbpBotAvgPose, tbpReferencePose, boolTemp)
        End If
    End Function



    Public Function ftnFindPoseFromLM(ByVal strImageRecognized As String, _
                        ByRef boolValidLocation As Boolean, ByVal tbpReferencePose As typeBotPose, _
                        ByRef intTotalRecognitions As Short, _
                        ByRef intBotOutOfLMValidRegion As Short, _
                        ByRef intDistanceOutOfRange As Short, _
                        ByRef intAngleOutOfRange As Short) As typeBotPose
        On Error Resume Next
        Dim tlmLandMark As typeLandMark
        Dim tirLandMark As typeImageRecognized
        Dim sngLMtoBotAngle, sngBottoLMRelativeAngle As Single
        Dim tbpPoseFromLM As typeBotPose
        ftnFindPoseFromLM = tbpReferencePose
        tirLandMark = ftnDecodeRecognitionString(strImageRecognized)    ' Convert the image recognition string to useable units
        tlmLandMark = ftnGetLandMarkDetails(tirLandMark.Name, tirLandMark.intNumber) ' Find the Land Mark in the database
        sngLMtoBotAngle = ftnLMtoBotAngle(tirLandMark, tbpReferencePose.Orientation)
        sngBottoLMRelativeAngle = ftnRelativeLandMarkBearing(tirLandMark)
        tlmLandMarkArray(tirLandMark.intNumber).LandMarkRecognized += 1
        If Not boolBotIsMoving And frmLandMarkEdit.Visible And Not GotABotClass.InvokeRequired Then frmLandMarkEdit.Refresh()
        boolValidLocation = False
        frmDebug.subWriteLogs(Color.Green, "  Localizing: " & intTotalRecognitions & ":  " & " LM = " & tirLandMark.Name)
        If ((tlmLandMark.LandMarkName = tirLandMark.Name) And (tirLandMark.Name <> "")) Then ' Is it a valid Land Mark recognition?
            intTotalRecognitions += 1
            subDrawBotToLM(tlmLandMark.LandMarkLocation, Color.Red)   ' Show the potential sighting on the map
            If Not ftnPoseWithinLMValidRegion(tbpReferencePose, tlmLandMark) Then
                intBotOutOfLMValidRegion += 1
                boolValidLocation = False
                subDrawBotToLM(tlmLandMark.LandMarkLocation, Color.Gray)   ' 
                frmDebug.subWriteLogs(Color.Green, " - - - - - - - -  - -   - - - -  Bot location outside of Land Mark Validity Region")
            Else
                If ((tirLandMark.sngYRotation = 9999) Or (Not boolEnableYRotation)) Then
                    tbpPoseFromLM = ftnPoseFromLM(tlmLandMark, tirLandMark, boolValidLocation, tbpReferencePose)
                Else
                    tbpPoseFromLM = ftnPoseFromYRotation(tlmLandMark, tirLandMark, sngBottoLMRelativeAngle, boolValidLocation, tbpReferencePose)
                End If
                If boolValidLocation Then  ' It is a Valid Landmark detection
                    ftnFindPoseFromLM = tbpPoseFromLM
                    subDrawBotToLM(tlmLandMark.LandMarkLocation, Color.Green)   ' confirm the sighting on the map
                    tlmLandMarkArray(tirLandMark.intNumber).LandMarkValid += 1
                    frmDebug.WritePose("- - - - - - - - Pose From LM: ", tbpPoseFromLM)
                ElseIf (Abs(ftnDistanceBetweenLocations(tbpReferencePose.Location, tlmLandMark.LandMarkLocation) - tirLandMark.Range) _
                        > Sqrt(tbpReferencePose.LocationUncertainty.X ^ 2 + tbpReferencePose.LocationUncertainty.Y ^ 2) * sngGridSize ^ 2) Then
                    intDistanceOutOfRange += 1
                    subDrawBotToLM(tlmLandMark.LandMarkLocation, Color.Blue)   ' 
                    frmDebug.subWriteLogs(Color.Green, " - - - - - - - -  - -   - - - -  Range invalid for this Land Mark")
                ElseIf Not ftnBotToLMAngleCheck(tlmLandMark, sngBottoLMRelativeAngle) Then
                    intAngleOutOfRange += 1
                    subDrawBotToLM(tlmLandMark.LandMarkLocation, Color.Yellow)   ' 
                    frmDebug.subWriteLogs(Color.Green, " - - - - - - - -  - -   - - - -  Bot orientation invalid for this Land Mark")
                Else
                    frmDebug.subWriteLogs(Color.Green, " - - - - - - - -  - -   - - - -  No location determined")
                End If
            End If
        Else
            frmDebug.subWriteLogs(Color.Green, " - - - - - - - -  - -   - - - -  Unknown LM")
        End If  ' (tlmLandMark.LandMarkName = tirLandMark.Name)
        UpdateStats()
    End Function


    Public Function ftnDecodeRecognitionString(ByVal strImageRecognized As String) As typeImageRecognized
        ' IF the Robot recognizes an object then it will report it in the form
        ' object  "object name"   FeaturesMatched   TotalFeatures   PixelX   PixelY   Distance(cm)
        '   0               1                2           3             4        5         6        
        On Error Resume Next
        Dim strLineOfText As String()
        Dim strParsedText1 As String()
        Dim strParsedText As String()
        ftnDecodeRecognitionString.Name = "Null"
        strImageRecognized = strImageRecognized & "  Null" & "  Null" & vbCr
        strLineOfText = strImageRecognized.Split(vbCr)
        If CBool(InStr(strLineOfText(0), """")) Then
            strParsedText1 = strLineOfText(0).Split(""""c) ' strParsedText1(0) = object;  strParsedText1(1) = "object name"  ;   
            '                                                 strParsedText1(2) = " "FeaturesMatched   TotalFeatures   PixelX   PixelY   Distance(cm) 
            '                                                                     0           1            2              3         4       5
            If (UBound(strParsedText1) >= 2) Then
                strParsedText = strParsedText1(2).Split(" "c) ' 
                If (UBound(strParsedText) >= 5) Then
                    If (strParsedText1(0) = "object ") Then
                        ftnDecodeRecognitionString.Name = strParsedText1(1)
                        If (Val(strParsedText(3)) >= 0) Then
                            ftnDecodeRecognitionString.intPixelX = CInt(Int(Val(strParsedText(3)))) ' make sure 'PixelX' is a valid number
                        Else
                            ftnDecodeRecognitionString.intPixelX = 0
                        End If
                        If CBool(InStr(strParsedText(5), "object")) Then strParsedText(5) = strParsedText(5).Replace("object", "  ") ' kludge
                        If (Val(strParsedText(5)) >= 0) And Not CBool(InStr(strParsedText(5), "object")) Then
                            ftnDecodeRecognitionString.Range = Convert.ToSingle(Val(strParsedText(5)))
                        Else
                            ftnDecodeRecognitionString.Range = 0
                        End If
                        ftnDecodeRecognitionString.Range = ftnCmToMapUnits(ftnDecodeRecognitionString.Range) + sngCameraOffset
                    Else
                        ftnDecodeRecognitionString.Name = "Null"
                    End If
                End If
                If (UBound(strParsedText) >= 7) Then
                    If (strParsedText(6) = "Rotation") Then
                        ftnDecodeRecognitionString.sngYRotation = ftnConvertTo360(Convert.ToSingle(Val(strParsedText(7))))
                    Else
                        ftnDecodeRecognitionString.sngYRotation = 9999
                    End If
                End If
            End If
        Else
            ftnDecodeRecognitionString.Name = "Null"
        End If
        If CBool(InStr(ftnDecodeRecognitionString.Name, "_!#$")) Then  '  Nonstandard sized Fiducial or glyph
            Dim sngSizeFactor As Single = Val(Right(ftnDecodeRecognitionString.Name, 1))
            Select Case sngSizeFactor
                Case 0 : sngSizeFactor = 0.125
                Case 1 : sngSizeFactor = 0.25
                Case 2 : sngSizeFactor = 0.5
                Case 3 : sngSizeFactor = 1
                Case 4 : sngSizeFactor = 2
                Case 5 : sngSizeFactor = 4
                Case 6 : sngSizeFactor = 8
                Case 7 : sngSizeFactor = 16
                Case 8 : sngSizeFactor = 32
                Case 9 : sngSizeFactor = 64
            End Select
            ftnDecodeRecognitionString.Range = ftnDecodeRecognitionString.Range * sngSizeFactor
        End If
    End Function


    Private Sub UpdateStats()
        On Error Resume Next
        If Not GotABotClass.InvokeRequired Then
            frmLandMarkEdit.TextBoxRecognized.Text = tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkRecognized
            frmLandMarkEdit.TextBoxValid.Text = tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValid
            If frmLandMarkEdit.Visible Then frmLandMarkEdit.Refresh()
        End If
    End Sub


    Public Function ftnGetLandMarkDetails(ByVal strLandMarkName As String, ByRef intLandMarkNo As Short) As typeLandMark
        On Error Resume Next
        ftnGetLandMarkDetails.LandMarkLocation.X = -1000
        ftnGetLandMarkDetails.LandMarkLocation.Y = -1000
        ftnGetLandMarkDetails.LandMarkName = ""
        intLandMarkNo = -1
        Dim intHighestLM As Short = UBound(tlmLandMarkArray)
        Do
            intLandMarkNo = intLandMarkNo + 1
        Loop Until ((intLandMarkNo = intHighestLM) Or (strLandMarkName = tlmLandMarkArray(intLandMarkNo).LandMarkName)) Or boolStop
        ftnGetLandMarkDetails = tlmLandMarkArray(intLandMarkNo)
    End Function




    Public Function ftnLMtoBotAngle(ByVal tirRecognizedLandmark As typeImageRecognized, ByVal sngBotOrientation As Single) As Single
        ' Get the angle of the Bot from the point of view of the Land Mark. 
        Try
            ftnLMtoBotAngle = 180 + (ftnConvertTo360(sngBotOrientation + ftnRelativeLandMarkBearing(tirRecognizedLandmark)))
            ftnLMtoBotAngle = ftnConvertTo360(ftnLMtoBotAngle)
        Catch
            ftnLMtoBotAngle = 0
        End Try
    End Function


    Public Function ftnRelativeLandMarkBearing(ByVal tirRecognizedLandmark As typeImageRecognized) As Single
        ' Get the angle of the LandMark relative to the Bot center line. 
        ' EXAMPLE:  For a camera with a resolution of 640 x 480
        '   If intX = 320 then the angle TO THE CAMERA is 0 degrees
        '    intX = 0                     FOV/2 degrees
        '    intX = 640                  -FOV/2 degrees
        Try
            Dim sngX, sngY As Single
            ftnRelativeLandMarkBearing = Convert.ToSingle((ticCameraResolution.X / 2 - tirRecognizedLandmark.intPixelX) / ticCameraResolution.X * sngCameraFOV) ' Angle to Camera
            sngX = tirRecognizedLandmark.Range * Cos(ftnDegreeToRadian(ftnRelativeLandMarkBearing)) + sngCameraOffset
            sngY = tirRecognizedLandmark.Range * Sin(ftnDegreeToRadian(ftnRelativeLandMarkBearing))
            If (sngX = 0) Then
                ftnRelativeLandMarkBearing = 90
            Else
                ftnRelativeLandMarkBearing = ftnRadianToDegree(Atan(sngY / sngX)) ' Angle to Bot center
            End If
            sngX = 0.000001
        Catch
            ftnRelativeLandMarkBearing = 145
        End Try
    End Function



    Function ftnPoseFromLM(ByVal tlmLandMark As typeLandMark, _
                               ByVal tirLandMark As typeImageRecognized, _
                               ByRef boolValidLocation As Boolean, _
                               ByVal tbpReferencePose As typeBotPose) As typeBotPose
        ' Determine the Bot's Pose based upon the Land Mark recognition
        On Error Resume Next
        boolValidLocation = False
        subDoEventsIfMainThread()
        tirLandMark.Range = ftnRangeCorrectForHeight(tlmLandMark, tirLandMark)
        ftnPoseFromLM = ftnPoseFromLM_Loop(tlmLandMark, tirLandMark, boolValidLocation, tbpReferencePose)
    End Function


    Public Function ftnPoseFromLM_Loop(ByVal tlmLandMark As typeLandMark, _
                               ByVal tirLandMark As typeImageRecognized, _
                               ByRef boolValidLocation As Boolean, _
                               ByVal tbpReferencePose As typeBotPose) As typeBotPose
        On Error Resume Next
        Dim intMinAngle, intMaxAngle As Short
        Dim intStartAngle, intEndAngle As Short
        Dim tmcMinLocation, tmcMaxLocation As typeMapCoordinate ' used to calculate location
        tmcMinLocation.X = tbpReferencePose.Location.X + tbpReferencePose.LocationUncertainty.X
        tmcMinLocation.Y = tbpReferencePose.Location.Y + tbpReferencePose.LocationUncertainty.Y
        tmcMaxLocation.X = 0
        tmcMaxLocation.Y = 0
        Dim tmcCandidateLocation As typeMapCoordinate
        Dim sngLMtoBotAngle As Single
        subFindStartEndAngles(tbpReferencePose, intStartAngle, intEndAngle)
        intMinAngle = intEndAngle
        intMaxAngle = intStartAngle
        For intBotCandidateOrientation As Short = intStartAngle To intEndAngle  ' Check All Bot Positions over Orientation Uncertainty range to see if its a valid location for this LM sighting 
            sngLMtoBotAngle = ftnLMtoBotAngle(tirLandMark, ftnConvertTo360(intBotCandidateOrientation))
            tmcCandidateLocation = ftnLocationFromLocation(tlmLandMark.LandMarkLocation, sngLMtoBotAngle, tirLandMark.Range)
            If ftnLocationOKForLM(tmcCandidateLocation, tlmLandMark, tbpReferencePose) Then  ' check that its within LM valid range, within Bot Pose, not in a wall
                If (intBotCandidateOrientation < intMinAngle) Then intMinAngle = intBotCandidateOrientation
                If (intBotCandidateOrientation > intMaxAngle) Then intMaxAngle = intBotCandidateOrientation
                If (tmcCandidateLocation.X > tmcMaxLocation.X) Then tmcMaxLocation.X = tmcCandidateLocation.X
                If (tmcCandidateLocation.Y > tmcMaxLocation.Y) Then tmcMaxLocation.Y = tmcCandidateLocation.Y
                If (tmcCandidateLocation.X < tmcMinLocation.X) Then tmcMinLocation.X = tmcCandidateLocation.X
                If (tmcCandidateLocation.Y < tmcMinLocation.Y) Then tmcMinLocation.Y = tmcCandidateLocation.Y
                boolValidLocation = True
                subDrawSmallLimeCircle(tmcCandidateLocation)
                ' Else
                'subDrawSmallRedCircle(tmcCandidateLocation)
            End If
        Next intBotCandidateOrientation
        subDoEventsIfMainThread()

        If boolValidLocation Then      'Calculate the pose
            If ftnOrientationPointsRight(tbpReferencePose.Orientation) Then
                ftnPoseFromLM_Loop.OrientationUncertainty = Abs(ftnConvertTo180(intMaxAngle) - ftnConvertTo180(intMinAngle)) / 2
            Else
                ftnPoseFromLM_Loop.OrientationUncertainty = Abs(intMaxAngle - intMinAngle) / 2
            End If
            ftnPoseFromLM_Loop.Orientation = ftnConvertTo360(intMinAngle + ftnPoseFromLM_Loop.OrientationUncertainty)
            If ftnPoseFromLM_Loop.OrientationUncertainty > 20 Then ftnPoseFromLM_Loop.OrientationUncertainty = 20
            ftnPoseFromLM_Loop.LocationUncertainty.X = (tmcMaxLocation.X - tmcMinLocation.X) / 2     ' 
            ftnPoseFromLM_Loop.LocationUncertainty.Y = (tmcMaxLocation.Y - tmcMinLocation.Y) / 2
            ftnPoseFromLM_Loop = ftnMinPoseUncertainty(ftnPoseFromLM_Loop)

            sngLMtoBotAngle = ftnLMtoBotAngle(tirLandMark, ftnPoseFromLM_Loop.Orientation)
            ftnPoseFromLM_Loop.Location = ftnLocationFromLocation(tlmLandMark.LandMarkLocation, sngLMtoBotAngle, tirLandMark.Range)
            ftnPoseFromLM_Loop = ftnValidatePose(ftnPoseFromLM_Loop, tbpReferencePose, boolValidLocation)
        Else
            ftnPoseFromLM_Loop = tbpReferencePose
            subDrawSmallRedCircle(ftnPoseFromLM_Loop.Location)
        End If
    End Function




    Function ftnPoseFromYRotation(ByVal tlmLandMark As typeLandMark, _
                           ByVal tirLandMark As typeImageRecognized, _
                           ByVal sngBottoLMRelativeAngle As Single, _
                           ByRef boolValidLocation As Boolean, _
                           ByVal tbpReferencePose As typeBotPose) As typeBotPose
        ' Y Rotation is supplied br RoboRealm Fiducial detection
        Dim intDeltaX As Short = (tlmLandMark.LandMarkLocation.X - tbpReferencePose.Location.X)
        Dim intDeltaY As Short = (tlmLandMark.LandMarkLocation.Y - tbpReferencePose.Location.Y)
        ftnPoseFromYRotation = tbpReferencePose
        If (Abs(intDeltaY) > Abs(intDeltaX)) Then  ' bot orientation tends toward 90 or 270 degrees
            If (intDeltaY < 0) Then  ' bot orientation tends toward 90 degrees
                ftnPoseFromYRotation.Location.X = tlmLandMark.LandMarkLocation.X - (tirLandMark.Range) * Sin(ftnDegreeToRadian(tirLandMark.sngYRotation)) / sngGridSize
                ftnPoseFromYRotation.Location.Y = tlmLandMark.LandMarkLocation.Y + (tirLandMark.Range) * Cos(ftnDegreeToRadian(tirLandMark.sngYRotation)) / sngGridSize
            Else ' bot orientation tends toward 270 degrees
                ftnPoseFromYRotation.Location.X = tlmLandMark.LandMarkLocation.X + (tirLandMark.Range) * Sin(ftnDegreeToRadian(tirLandMark.sngYRotation)) / sngGridSize
                ftnPoseFromYRotation.Location.Y = tlmLandMark.LandMarkLocation.Y - (tirLandMark.Range) * Cos(ftnDegreeToRadian(tirLandMark.sngYRotation)) / sngGridSize
            End If
        Else
            If (intDeltaX > 0) Then  ' bot orientation tends toward 0 degrees
                ftnPoseFromYRotation.Location.X = tlmLandMark.LandMarkLocation.X - (tirLandMark.Range) * Cos(ftnDegreeToRadian(tirLandMark.sngYRotation)) / sngGridSize
                ftnPoseFromYRotation.Location.Y = tlmLandMark.LandMarkLocation.Y - (tirLandMark.Range) * Sin(ftnDegreeToRadian(tirLandMark.sngYRotation)) / sngGridSize
            Else ' bot orientation tends toward 180 degrees
                ftnPoseFromYRotation.Location.X = tlmLandMark.LandMarkLocation.X + (tirLandMark.Range) * Cos(ftnDegreeToRadian(tirLandMark.sngYRotation)) / sngGridSize
                ftnPoseFromYRotation.Location.Y = tlmLandMark.LandMarkLocation.Y + (tirLandMark.Range) * Sin(ftnDegreeToRadian(tirLandMark.sngYRotation)) / sngGridSize
            End If
        End If

        ftnPoseFromYRotation.Orientation = ftnConvertTo360(ftnP1ToP2Angle(ftnPoseFromYRotation.Location, tlmLandMark.LandMarkLocation) _
                                             - Convert.ToSingle((ticCameraResolution.X / 2 - tirLandMark.intPixelX) / ticCameraResolution.X * sngCameraFOV))
        If (ftnLocationValidForLM(ftnPoseFromYRotation.Location, tlmLandMark, tbpReferencePose) And ftnLocationWithinPose(ftnPoseFromYRotation.Location, tbpReferencePose)) Then
            boolValidLocation = True
        Else
            boolValidLocation = False
            ftnPoseFromYRotation = tbpReferencePose
        End If
    End Function


End Module
