﻿'Option Strict On
Imports System.Threading

Module modMapDraw

    '=================================================

    '       Map Draw MODULE
    '  This module is responsible for:
    '    - Drawing on the map (Bot, Destination, Path, etc)
    '

    '=================================================


    Public Sub subDrawBot(ByVal tbpBotPose As typeBotPose)    ' Draw the robot icon on the map.  The icon is a green circle with a yellow line to indicate orientation
        On Error Resume Next
        If Not GotABotClass.myMap.InvokeRequired Then
            Dim sngDiameterZoomGrid As Single = sngBotDiameter * sngZoom / sngGridSize
            tbpBotPose.Location = ftnCheckMapArrayLimits(tbpBotPose.Location)
            If Not (tbpBotPose.Location.X = 0 And tbpBotPose.Location.Y = 0) Then
                Dim intBotRadius As Integer = Int(sngDiameterZoomGrid * 0.5)
                Dim intZoomBotX As Integer = Int(tbpBotPose.Location.X * sngZoom)
                Dim intZoomBotY As Integer = Int(tbpBotPose.Location.Y * sngZoom)
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Green, (intZoomBotX - intBotRadius), (intZoomBotY - intBotRadius), sngDiameterZoomGrid, sngDiameterZoomGrid, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Green, (intZoomBotX - intBotRadius), (intZoomBotY - intBotRadius), sngDiameterZoomGrid, sngDiameterZoomGrid)
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Yellow, (intZoomBotX), (intZoomBotY), CInt(intZoomBotX + intBotRadius * Math.Cos(ftnDegreeToRadian(tbpBotPose.Orientation))), CInt(intZoomBotY - intBotRadius * Math.Sin(ftnDegreeToRadian(tbpBotPose.Orientation))))
                If Not boolBotIsMoving Then subDrawBotUncertaintyOutline()
                GotABotClass.myMap.CreateGraphics.Flush()
                GotABotClass.myMap.CreateGraphics.Dispose()
            End If
            If frmLandMarkEdit.Visible Then
                subDrawLandMark()
                frmLandMarkEdit.Refresh()
            End If
        End If
    End Sub


    Public Sub subEraseOldBotLocation(ByVal tmcOldBotLocation As typeMapCoordinate)
        On Error Resume Next
        If Not GotABotClass.InvokeRequired Then
            Dim sngDiameterZoomGrid As Single = sngBotDiameter * sngZoom / sngGridSize
            Dim intZoomBotX As Integer = Int(tmcOldBotLocation.X * sngZoom)
            Dim intZoomBotY As Integer = Int(tmcOldBotLocation.Y * sngZoom)
            If boolShowMore Then
                Dim intBotRadius As Integer = Int(sngDiameterZoomGrid * 0.5)
                tmcOldBotLocation = ftnCheckMapArrayLimits(tmcOldBotLocation)
                If Not (tmcOldBotLocation.X = 0 And tmcOldBotLocation.Y = 0) Then
                    GotABotClass.myMap.CreateGraphics.DrawArc(Pens.White, (intZoomBotX - intBotRadius), (intZoomBotY - intBotRadius), sngDiameterZoomGrid, sngDiameterZoomGrid, 0, 360)
                    GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.White, (intZoomBotX - intBotRadius), (intZoomBotY - intBotRadius), sngDiameterZoomGrid, sngDiameterZoomGrid)
                    GotABotClass.myMap.CreateGraphics.Flush()
                    GotABotClass.myMap.CreateGraphics.Dispose()
                End If
            End If
        End If
    End Sub

    Public Sub subDrawBotUncertaintyOutline()
        On Error Resume Next
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            Dim sngHalfDiameterZoomGrid As Single = 0.5 * sngBotDiameter * sngZoom / sngGridSize
            Dim LocX, LocY As Single
            Dim LocY2, LocX2 As Single
            LocX = Convert.ToSingle(tbpBotPose.Location.X - tbpBotPose.LocationUncertainty.X)
            LocY = Convert.ToSingle(tbpBotPose.Location.Y - tbpBotPose.LocationUncertainty.Y)
            subCheckMapArrayLimits(LocX, LocY)
            LocX2 = Convert.ToSingle(tbpBotPose.Location.X + tbpBotPose.LocationUncertainty.X)
            LocY2 = Convert.ToSingle(tbpBotPose.Location.Y + tbpBotPose.LocationUncertainty.Y)
            subCheckMapArrayLimits(LocX2, LocY2)

            GotABotClass.myMap.CreateGraphics.DrawRectangle(Pens.YellowGreen, LocX * sngZoom, (LocY * sngZoom), _
                                                                   ((LocX2 - LocX) * sngZoom), ((LocY2 - LocY) * sngZoom))
            GotABotClass.myMap.CreateGraphics.DrawLine(Pens.YellowGreen, (tbpBotPose.Location.X * sngZoom), (tbpBotPose.Location.Y * sngZoom), _
                                                       CInt(tbpBotPose.Location.X * sngZoom + sngHalfDiameterZoomGrid * (Math.Cos(ftnDegreeToRadian(tbpBotPose.Orientation + tbpBotPose.OrientationUncertainty)))), _
                                                       CInt(tbpBotPose.Location.Y * sngZoom - sngHalfDiameterZoomGrid * (Math.Sin(ftnDegreeToRadian(tbpBotPose.Orientation + tbpBotPose.OrientationUncertainty)))))
            GotABotClass.myMap.CreateGraphics.DrawLine(Pens.YellowGreen, (tbpBotPose.Location.X * sngZoom), (tbpBotPose.Location.Y * sngZoom), _
                                                       CInt(tbpBotPose.Location.X * sngZoom + sngHalfDiameterZoomGrid * (Math.Cos(ftnDegreeToRadian(tbpBotPose.Orientation - tbpBotPose.OrientationUncertainty)))), _
                                                       CInt(tbpBotPose.Location.Y * sngZoom - sngHalfDiameterZoomGrid * (Math.Sin(ftnDegreeToRadian(tbpBotPose.Orientation - tbpBotPose.OrientationUncertainty)))))
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub



    Public Sub subDrawDestination(ByVal tmcDestination As typeMapCoordinate)    ' Draw the destination icon on the map.  The icon is a red 'X' (as in "X marks the spot and red indicates STOP here)
        On Error Resume Next
        If Not GotABotClass.InvokeRequired Then
            Dim wideRedPen As New Pen(Brushes.Red)
            Dim intBotRadius As Integer = Int(sngBotDiameter / sngGridSize * sngZoom * 0.5)
            tmcDestination = ftnCheckMapArrayLimits(tmcDestination)
            wideRedPen.Width = 8.0F
            wideRedPen.LineJoin = Drawing2D.LineJoin.Bevel
            GotABotClass.myMap.CreateGraphics.DrawLine(wideRedPen, tmcDestination.X * sngZoom - intBotRadius, tmcDestination.Y * sngZoom - intBotRadius, tmcDestination.X * sngZoom + intBotRadius, tmcDestination.Y * sngZoom + intBotRadius)
            GotABotClass.myMap.CreateGraphics.DrawLine(wideRedPen, tmcDestination.X * sngZoom - intBotRadius, tmcDestination.Y * sngZoom + intBotRadius, tmcDestination.X * sngZoom + intBotRadius, tmcDestination.Y * sngZoom - intBotRadius)
            wideRedPen.Dispose()
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
            System.Windows.Forms.Application.DoEvents()
        End If
    End Sub


    Public Sub subDrawVectorFromBot(ByVal tbpEstimatedPose As typeBotPose, ByVal sngRange As Single, ByVal sngRelativeAngle As Single, ByVal boolGreen As Boolean)    ' Draw a line from the bot to the Ranger supplied vector
        On Error Resume Next
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            Dim tmcEndPoint As typeMapCoordinate = ftnLocationFromEstimatedPose(tbpEstimatedPose, sngRelativeAngle, sngRange)
            If boolGreen Then
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Lime, (tbpBotPose.Location.X * sngZoom), (tbpBotPose.Location.Y * sngZoom), (tmcEndPoint.X * sngZoom), (tmcEndPoint.Y * sngZoom))
                subDrawSmallLimeCircle(tmcEndPoint)
            Else
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Red, (tbpBotPose.Location.X * sngZoom), (tbpBotPose.Location.Y * sngZoom), (tmcEndPoint.X * sngZoom), (tmcEndPoint.Y * sngZoom))
                subDrawSmallRedCircle(tmcEndPoint)
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub

    Public Sub subDrawVector(ByVal tmcStartLocation As typeMapCoordinate, ByVal trvVector As typeRangeVector, ByVal boolGreen As Boolean)    ' Draw a vector
        On Error Resume Next
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            Dim tmcEndPoint As typeMapCoordinate = ftnLocationFromLocation(tmcStartLocation, trvVector.sngAngle, trvVector.sngRange)
            If boolGreen Then
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Lime, (tmcStartLocation.X * sngZoom), (tmcStartLocation.Y * sngZoom), (tmcEndPoint.X * sngZoom), (tmcEndPoint.Y * sngZoom))
                subDrawSmallLimeCircle(tmcEndPoint)
            Else
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Red, (tmcStartLocation.X * sngZoom), (tmcStartLocation.Y * sngZoom), (tmcEndPoint.X * sngZoom), (tmcEndPoint.Y * sngZoom))
                subDrawSmallRedCircle(tmcEndPoint)
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub

    Public Sub subDrawVector(ByVal tmcStartLocation As typeMapCoordinate, ByVal sngRange As Single, ByVal sngOrientation As Single, ByVal boolGreen As Boolean)    ' Draw a line from the Range Finder
        On Error Resume Next
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            Dim tmcEndPoint As typeMapCoordinate = ftnLocationFromLocation(tmcStartLocation, sngOrientation, sngRange)
            If boolGreen Then
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Lime, (tmcStartLocation.X * sngZoom), (tmcStartLocation.Y * sngZoom), (tmcEndPoint.X * sngZoom), (tmcEndPoint.Y * sngZoom))
                subDrawSmallLimeCircle(tmcEndPoint)
            Else
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Red, (tmcStartLocation.X * sngZoom), (tmcStartLocation.Y * sngZoom), (tmcEndPoint.X * sngZoom), (tmcEndPoint.Y * sngZoom))
                subDrawSmallRedCircle(tmcEndPoint)
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub

    Public Sub subDrawBotToLM(ByVal tmcLM As typeMapCoordinate, ByVal colColor As Color)    ' Draw a line from the bot to the LM
        On Error Resume Next
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            tmcLM = ftnCheckMapArrayLimits(tmcLM)
            If colColor = Color.Green Then
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Green, (tbpBotPose.Location.X * sngZoom), (tbpBotPose.Location.Y * sngZoom), (tmcLM.X * sngZoom), (tmcLM.Y * sngZoom))
            ElseIf colColor = Color.Yellow Then
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Yellow, (tbpBotPose.Location.X * sngZoom), (tbpBotPose.Location.Y * sngZoom), (tmcLM.X * sngZoom), (tmcLM.Y * sngZoom))
            ElseIf colColor = Color.Gray Then
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Gray, (tbpBotPose.Location.X * sngZoom), (tbpBotPose.Location.Y * sngZoom), (tmcLM.X * sngZoom), (tmcLM.Y * sngZoom))
            ElseIf colColor = Color.Blue Then
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Blue, (tbpBotPose.Location.X * sngZoom), (tbpBotPose.Location.Y * sngZoom), (tmcLM.X * sngZoom), (tmcLM.Y * sngZoom))
            Else
                GotABotClass.myMap.CreateGraphics.DrawLine(Pens.Red, (tbpBotPose.Location.X * sngZoom), (tbpBotPose.Location.Y * sngZoom), (tmcLM.X * sngZoom), (tmcLM.Y * sngZoom))
            End If
            If frmLandMarkEdit.Visible Then
                subDrawLandMark()
                frmLandMarkEdit.Refresh()
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub


    Public Sub subDrawLandMark()
        On Error Resume Next
        If Not GotABotClass.InvokeRequired Then
            Dim LocX, LocY As Single
            Dim ValidX, ValidY, ValidHeight, ValidWidth As Single
            LocX = Convert.ToSingle(frmLandMarkEdit.UpDnLocX.Value)
            LocY = Convert.ToSingle(frmLandMarkEdit.UpDnLocY.Value)
            subCheckMapArrayLimits(LocX, LocY)
            ValidX = Convert.ToSingle(frmLandMarkEdit.UpDnValidX.Value)
            ValidY = Convert.ToSingle(frmLandMarkEdit.UpDnValidY.Value)
            subCheckMapArrayLimits(ValidX, ValidY)
            ValidWidth = Convert.ToSingle(frmLandMarkEdit.UpDnValidWidth.Value)
            ValidHeight = Convert.ToSingle(frmLandMarkEdit.UpDnValidHeight.Value)

            Dim sngDotHeight As Single = 4 * sngZoom
            GotABotClass.myMap.CreateGraphics.DrawArc(Pens.CornflowerBlue, (LocX * sngZoom - sngDotHeight / 2), _
                                                 (LocY * sngZoom - sngDotHeight / 2), sngDotHeight, sngDotHeight, 0, 360)
            GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.CornflowerBlue, (LocX * sngZoom - sngDotHeight / 2), _
                                                            LocY * sngZoom - sngDotHeight / 2, sngDotHeight, sngDotHeight)
            GotABotClass.myMap.CreateGraphics.DrawRectangle(Pens.CornflowerBlue, ValidX * sngZoom, (ValidY * sngZoom), _
                                                                   (ValidWidth * sngZoom), (ValidHeight * sngZoom))
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub

    Public Sub subDrawMapPixel(ByVal intPixelX As Short, ByVal intPixelY As Short, ByVal colPixel As Color)
        On Error Resume Next
        If Not GotABotClass.InvokeRequired Then
            If (colPixel = Color.Red) Then   ' TO DO - Change to CASE statement
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Red, (intPixelX * sngZoom - sngZoom), _
                                                      (intPixelY * sngZoom - sngZoom), sngZoom, sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Red, (intPixelX * sngZoom - sngZoom), _
                                                                intPixelY * sngZoom - sngZoom, sngZoom, sngZoom)
            ElseIf (colPixel = Color.Yellow) Then
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Yellow, (intPixelX * sngZoom - sngZoom), _
                                                     (intPixelY * sngZoom - sngZoom), sngZoom, sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Yellow, (intPixelX * sngZoom - sngZoom), _
                                                                intPixelY * sngZoom - sngZoom, sngZoom, sngZoom)
            ElseIf (colPixel = Color.Black) Then
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Black, (intPixelX * sngZoom - sngZoom), _
                                                     (intPixelY * sngZoom - sngZoom), sngZoom, sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Black, (intPixelX * sngZoom - sngZoom), _
                                                                intPixelY * sngZoom - sngZoom, sngZoom, sngZoom)
            ElseIf (colPixel = Color.White) Then
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.White, (intPixelX * sngZoom - sngZoom), _
                                                     (intPixelY * sngZoom - sngZoom), sngZoom, sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.White, (intPixelX * sngZoom - sngZoom), _
                                                                intPixelY * sngZoom - sngZoom, sngZoom, sngZoom)
            ElseIf (colPixel = Color.CornflowerBlue) Then
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.CornflowerBlue, (intPixelX * sngZoom - sngZoom), _
                                                    (intPixelY * sngZoom - sngZoom), sngZoom, sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.CornflowerBlue, (intPixelX * sngZoom - sngZoom), _
                                                                intPixelY * sngZoom - sngZoom, sngZoom, sngZoom)
            Else
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Green, (intPixelX * sngZoom - sngZoom), _
                                                    (intPixelY * sngZoom - sngZoom), sngZoom, sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Green, (intPixelX * sngZoom - sngZoom), _
                                                                intPixelY * sngZoom - sngZoom, sngZoom, sngZoom)
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub

    Public Sub subShowPath(ByVal tmcDestination As typeMapCoordinate)  ' Draw the Bot to Destination path on the map
        '  Called from subroutine ftnGeneratePathCosts and subRedraw
        On Error Resume Next
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            On Error Resume Next
            Dim tmcPathStep As typeMapCoordinate
            Dim tmcOldPathStep As typeMapCoordinate
            Dim boolNearWall As Boolean = False

            tmcPathStep.X = CShort(Int(tbpBotPose.Location.X))
            tmcPathStep.Y = CShort(Int(tbpBotPose.Location.Y))
            tmcOldPathStep = tbpBotPose.Location
            tmcPathStep = ftnLowestValueNeighbor(tmcPathStep)
            subHighLightPathStep(tmcPathStep.X, tmcPathStep.Y)
            Dim timeOut As DateTime = Now().AddMilliseconds(10000)
            Do While ((intPathArray(tmcPathStep.X, tmcPathStep.Y) <> constDestinationCost) And _
                      (tmcPathStep.X <> tmcOldPathStep.X) Or (tmcPathStep.Y <> tmcOldPathStep.Y)) _
                      And Not boolStop And Not boolShutDown And (Now() < timeOut)
                tmcOldPathStep = tmcPathStep
                tmcPathStep = ftnLowestValueNeighbor(tmcPathStep)
                subHighLightPathStep(tmcPathStep.X, tmcPathStep.Y)
            Loop
            subDrawBot(tbpBotPose) ' Restore the bot icon
            subDrawDestination(tmcDestination) ' Restore the destination icon
        End If
    End Sub



    Public Sub subHighLightPathStep(ByVal intPathX As Short, ByVal intPathY As Short)
        On Error Resume Next
        Dim sngZoomGrid As Single = sngZoom / sngGridSize
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            Dim intBotRadius As Integer = Int(sngBotDiameter * sngZoomGrid * 0.5)
            GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Yellow, _
                                (intPathX * sngZoom - intBotRadius), _
                                (intPathY * sngZoom - intBotRadius), _
                                sngBotDiameter * sngZoomGrid, _
                                sngBotDiameter * sngZoomGrid, 0, 360)
            GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Yellow, _
                            ((intPathX) * sngZoom - intBotRadius), _
                            ((intPathY) * sngZoom - intBotRadius), _
                            sngBotDiameter * sngZoomGrid, sngBotDiameter * sngZoomGrid)
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub





    Public Sub subDrawSmallLimeCircle(ByVal tmcMapLocation As typeMapCoordinate)    ' Draw a small lime circle 
        On Error Resume Next
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            tmcMapLocation = ftnCheckMapArrayLimits(tmcMapLocation)
            If Not (tmcMapLocation.X = 0 And tmcMapLocation.Y = 0) Then
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Lime, (tmcMapLocation.X * sngZoom - (5 * sngZoom / 2)), (tmcMapLocation.Y * sngZoom - (5 * sngZoom / 2)), 5 * sngZoom, 5 * sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Lime, (tmcMapLocation.X * sngZoom - (5 * sngZoom / 2)), (tmcMapLocation.Y * sngZoom - (5 * sngZoom / 2)), 5 * sngZoom, 5 * sngZoom)
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub

    Delegate Sub DelegateDrawSmallRedCircle(ByVal tmcMapLocation As typeMapCoordinate)
    Public Sub subDrawSmallRedCircle(ByVal tmcMapLocation As typeMapCoordinate)    ' Draw a small red circle 
        On Error Resume Next
        If GotABotClass.InvokeRequired And Not boolShutDown And boolShowMore Then
            Dim newDelegate As New DelegateDrawSmallBlueCircle(AddressOf subDrawSmallRedCircle)
            GotABotClass.Invoke(newDelegate, New Object() {tmcMapLocation})
            GotABotClass.Invoke(newDelegate)
            Thread.Sleep(50)
        ElseIf boolShowMore And Not GotABotClass.InvokeRequired Then
            tmcMapLocation = ftnCheckMapArrayLimits(tmcMapLocation)
            If Not (tmcMapLocation.X = 0 And tmcMapLocation.Y = 0) Then
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Red, (tmcMapLocation.X * sngZoom - (5 * sngZoom / 2)), (tmcMapLocation.Y * sngZoom - (5 * sngZoom / 2)), 5 * sngZoom, 5 * sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Red, (tmcMapLocation.X * sngZoom - (5 * sngZoom / 2)), (tmcMapLocation.Y * sngZoom - (5 * sngZoom / 2)), 5 * sngZoom, 5 * sngZoom)
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub

    Public Sub subDrawSmallPurpleCircle(ByVal tmcMapLocation As typeMapCoordinate)    ' Draw a small purple circle 
        On Error Resume Next
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            tmcMapLocation = ftnCheckMapArrayLimits(tmcMapLocation)
            If Not (tmcMapLocation.X = 0 And tmcMapLocation.Y = 0) Then
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Purple, (tmcMapLocation.X * sngZoom - (5 * sngZoom / 2)), (tmcMapLocation.Y * sngZoom - (5 * sngZoom / 2)), 5 * sngZoom, 5 * sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Purple, (tmcMapLocation.X * sngZoom - (5 * sngZoom / 2)), (tmcMapLocation.Y * sngZoom - (5 * sngZoom / 2)), 5 * sngZoom, 5 * sngZoom)
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub

    Public Sub subDrawSmallyellowCircle(ByVal tmcMapLocation As typeMapCoordinate)    ' Draw a small yellow circle 
        On Error Resume Next
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            tmcMapLocation = ftnCheckMapArrayLimits(tmcMapLocation)
            If Not (tmcMapLocation.X = 0 And tmcMapLocation.Y = 0) Then
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Yellow, (tmcMapLocation.X * sngZoom - (5 * sngZoom / 2)), (tmcMapLocation.Y * sngZoom - (5 * sngZoom / 2)), 5 * sngZoom, 5 * sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Yellow, (tmcMapLocation.X * sngZoom - (5 * sngZoom / 2)), (tmcMapLocation.Y * sngZoom - (5 * sngZoom / 2)), 5 * sngZoom, 5 * sngZoom)
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub

    Delegate Sub DelegateDrawSmallBlueCircle(ByVal tmcMapLocation As typeMapCoordinate)
    Public Sub subDrawSmallBlueCircle(ByVal tmcMapLocation As typeMapCoordinate)    ' Draw a small blue circle 
        On Error Resume Next
        If GotABotClass.InvokeRequired And Not boolShutDown And boolShowMore Then
            Dim newDelegate As New DelegateDrawSmallBlueCircle(AddressOf subDrawSmallBlueCircle)
            GotABotClass.Invoke(newDelegate, New Object() {tmcMapLocation})
            Thread.Sleep(50)
        ElseIf boolShowMore And Not GotABotClass.InvokeRequired Then
            tmcMapLocation = ftnCheckMapArrayLimits(tmcMapLocation)
            If Not (tmcMapLocation.X = 0 And tmcMapLocation.Y = 0) Then
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Blue, (tmcMapLocation.X * sngZoom - (5 * sngZoom / 2)), (tmcMapLocation.Y * sngZoom - (5 * sngZoom / 2)), 5 * sngZoom, 5 * sngZoom, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Blue, (tmcMapLocation.X * sngZoom - (5 * sngZoom / 2)), (tmcMapLocation.Y * sngZoom - (5 * sngZoom / 2)), 5 * sngZoom, 5 * sngZoom)
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub



    Public Sub subDrawBumperSwitch(ByVal tbpEstimatedPose As typeBotPose, ByVal sngRelativeAngle As Single)    ' Highlight the bumper switch 
        On Error Resume Next
        If boolShowMore And Not GotABotClass.InvokeRequired Then
            Dim tmcBumperSwitch As typeMapCoordinate
            Dim sngDiameter As Single = sngBotDiameter / sngGridSize / 4 * sngZoom
            tmcBumperSwitch = ftnLocationFromEstimatedPose(tbpEstimatedPose, sngRelativeAngle, sngBotDiameter / 2)
            If Not (tmcBumperSwitch.X = 0 And tmcBumperSwitch.Y = 0) Then
                GotABotClass.myMap.CreateGraphics.DrawArc(Pens.Red, (tmcBumperSwitch.X * sngZoom - (sngDiameter / 2)), (tmcBumperSwitch.Y * sngZoom - (sngDiameter / 2)), sngDiameter, sngDiameter, 0, 360)
                GotABotClass.myMap.CreateGraphics.FillEllipse(Brushes.Red, (tmcBumperSwitch.X * sngZoom - (sngDiameter / 2)), (tmcBumperSwitch.Y * sngZoom - (sngDiameter / 2)), sngDiameter, sngDiameter)
            End If
            GotABotClass.myMap.CreateGraphics.Flush()
            GotABotClass.myMap.CreateGraphics.Dispose()
        End If
    End Sub




End Module
