﻿Imports System.Math

Module modNavigationArray

    ''''''''''''''''''''''''''''''''''''''''''''''
    '
    '     Map Array Module: 
    '
    '  This module is responsible for:
    '    - converting a map (bmpMap) to a byte array (byteNavigationMap)
    '              0 = free,  255 = occupied
    '    - adding a buffer space around occupied cells 
    '
    ''''''''''''''''''''''''''''''''''''''''''''''
    Public Sub subConvertMapToArray()
        ' Red = 
        ' Green = free / grey /
        ' Blue = 
        ' Occupied = (pixMap.R = 0) And (pixMap.G = 0) And (pixMap.B = 0) 
        On Error Resume Next
        strStatusDriving = "Generating Map Array"
        GotABotClass.subUpdateStatusLine()
        If Not boolSlam Then
            Dim intSizeX As Short = Map_SizeX - 1
            Dim intSizeY As Short = Map_SizeY - 1
            Dim intY, intX As Short
            Dim pixMap As Color
            ReDim byteNavigationMap(Map_SizeX, Map_SizeY)
            ReDim boolOccupiedCell(Map_SizeX, Map_SizeY)
            ReDim boolCompassIsSuspect(Map_SizeX, Map_SizeY)
            For intX = 0 To intSizeX   ' Convert the map image into byteNavigationMap.   0 = free,  255 = occupied, grey = 33-64(?)
                For intY = 0 To intSizeY
                    pixMap = bmpMap.GetPixel(intX, intY)
                    boolCompassIsSuspect(intX, intY) = (pixMap.R = 255) And (pixMap.G = 216) And (pixMap.B = 176)
                    boolOccupiedCell(intX, intY) = (pixMap.R = 0) And (pixMap.G = 0) And (pixMap.B = 0)
                    If boolCompassIsSuspect(intX, intY) Then
                        byteNavigationMap(intX, intY) = 0
                    Else
                        byteNavigationMap(intX, intY) = 255 - bmpMap.GetPixel(intX, intY).G
                    End If
                Next intY
                subDoEventsIfMainThread()  ' Jan2014 - i7 - For Loop = 148 ms with and without doevents
            Next intX
        Else
            subThresholdSlamRawMapArrayToMapArray()
        End If
        subAddBufferSpace() ' Jan2014 - i7 =  2.9s
        strStatusDriving = "Map Array Generated "
        GotABotClass.subUpdateStatusLine()
    End Sub

    Public Sub subAddBufferSpace() '  Add a buffer space around all walls and objects so that the robot won't bang into them
        On Error Resume Next
        Dim intCellXMin, intCellXMax, intCellyMin, intCellyMax As Short
        Dim intDistanceFromWall As Short
        Dim intDistanceFromWallThreshold As Short = intBufferSpaceMaxSize * sngGridSize
        Dim intBufferSpaceCost As Short
        Dim tmcLocation1, tmcLocation2 As typeMapCoordinate
        Dim intSizeX As Short = Map_SizeX
        Dim intSizeY As Short = Map_SizeY
        intBufferSpaceMaxSize = (sngBotRadius + sngSixInches) / sngGridSize + 0.5 ' buffer space around occupied cells, (1-32)
        If (intBufferSpaceMaxSize > 32) Then intBufferSpaceMaxSize = 32
        If intBufferSpaceMaxSize = 0 Then intBufferSpaceMaxSize = 1
        For intX As Short = 0 To intSizeX - 1
            For intY As Short = 0 To intSizeY - 1
                tmcLocation1.X = intX
                tmcLocation1.Y = intY
                If boolOccupiedCell(intX, intY) Then
                    intCellXMin = (intX - intBufferSpaceMaxSize)
                    If intCellXMin < 0 Then intCellXMin = 0
                    intCellXMax = (intX + intBufferSpaceMaxSize)
                    If intCellXMax > intSizeX Then intCellXMax = intSizeX
                    intCellyMin = (intY - intBufferSpaceMaxSize)
                    If intCellyMin < 0 Then intCellyMin = 0
                    intCellyMax = (intY + intBufferSpaceMaxSize)
                    If intCellyMax > intSizeY Then intCellyMax = intSizeX
                    For tmcLocation2.X = intCellXMin To intCellXMax ' left and right neighbors
                        For tmcLocation2.Y = intCellyMin To intCellyMax ' up and down neighbors
                            If (Not boolOccupiedCell(tmcLocation2.X, tmcLocation2.Y)) Then
                                intDistanceFromWall = (ftnDistanceBetweenLocations(tmcLocation1, tmcLocation2))
                                If (intDistanceFromWall <= intDistanceFromWallThreshold) Then
                                    intBufferSpaceCost = constMaxBufferSpaceCost - ftnMapUnitsToInches(intDistanceFromWall)
                                    If (intBufferSpaceCost < constMinimumBufferSpaceCost) Then intBufferSpaceCost = constMinimumBufferSpaceCost
                                    If (intBufferSpaceCost > byteNavigationMap(tmcLocation2.X, tmcLocation2.Y)) Then _
                                        byteNavigationMap(tmcLocation2.X, tmcLocation2.Y) = intBufferSpaceCost
                                End If
                            End If
                        Next tmcLocation2.Y
                        subDoEventsIfMainThread()
                    Next tmcLocation2.X
                End If
            Next intY
        Next intX
    End Sub

End Module
