﻿
Imports System.Math
Imports System.Threading
Imports Microsoft.Kinect

Module modObstacle

    Public Function ftnObstacleAvoid(ByRef tbpEstimatedPose As typeBotPose, ByVal tbpTargetPose As typeBotPose) As typeBotPose
        On Error Resume Next
        ftnObstacleAvoid = ftnLocalize_Top(tbpEstimatedPose)
        If ((strTypeOfMove = "Fwd") Or (strTypeOfMove = "XY")) And Not boolSimulatedMovement Then  'TODO - Add API Range Measurements
            Dim sngFwdDistance As Single = ftnDistanceCommanded(ftnObstacleAvoid, tbpTargetPose)
            Dim sngObstacleFwdDistance As Single
            Dim trvObstacleVector As typeRangeVector = ftnObstacleVectorTop(ftnObstacleAvoid, strTypeOfMove, tbpTargetPose)
            Dim tmcObstacleLocation As typeMapCoordinate
            sngObstacleFwdDistance = ftnObstacleForwardDistance(trvObstacleVector)
            If (sngObstacleFwdDistance <= sngFwdDistance) Then
                ftnSendCommand("play phrase 'Oh Oh. Obstacle Detected'")
                frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ": ")
                frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ":#########################  Obstacle Detected  ##################################### ")
                frmDebug.subWriteLogs(Color.Green, "               Obstacle Vector =" & trvObstacleVector.sngRange & " @ " & trvObstacleVector.sngAngle & " degrees")
                tmcObstacleLocation = ftnLocationFromEstimatedPose(ftnObstacleAvoid, trvObstacleVector)
                subDrawSmallPurpleCircle(tmcObstacleLocation)
                subDoEventsIfMainThread()
                If (sngObstacleFwdDistance > ftnInchesToMapUnits(18)) Then
                    tmcObstacleLocation = ftnLocationFromEstimatedPose(ftnObstacleAvoid, trvObstacleVector)
                    sngFwdDistance = sngObstacleFwdDistance - ftnInchesToMapUnits(12)
                    tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngFwdDistance)
                    ftnObstacleAvoid = ftnBotFwd(ftnObstacleAvoid, tbpTargetPose) ' 
                ElseIf (sngFwdDistance > 0) Then  ' Dont backup if obstacle behind Bot
                    tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngSixInches)
                    ftnObstacleAvoid = ftnBotFwd(ftnObstacleAvoid, tbpTargetPose) ' back up
                    ftnObstacleAvoid = ftnLocalize_Top(ftnObstacleAvoid)
                    If (ftnConvertTo180(trvObstacleVector.sngAngle) < 0) Then
                        strStatusDriving = intDrivingSequenceNumber & ":  Avoiding Obstacle - Turning Left"
                        GotABotClass.subUpdateStatusLine()
                        frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ": Avoiding Obstacle - Turning Left")
                        tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 10 * (ftnInchesToMapUnits(12) / trvObstacleVector.sngRange))
                        ftnObstacleAvoid = ftnBotTurn(ftnObstacleAvoid, False, tbpTargetPose)
                    Else
                        tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation - 15 * (ftnInchesToMapUnits(12) / trvObstacleVector.sngRange))
                        ftnObstacleAvoid = ftnBotTurn(ftnObstacleAvoid, False, tbpTargetPose)
                        strStatusDriving = intDrivingSequenceNumber & ":  Avoiding Obstacle - Turning Right"
                        GotABotClass.subUpdateStatusLine()
                        frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ": Avoiding Obstacle - Turning Right")
                    End If
                Else  ' Obstacle behind Bot and Bot is backing up
                    If (ftnConvertTo180(trvObstacleVector.sngAngle) < 0) Then
                        strStatusDriving = intDrivingSequenceNumber & ":  Avoiding Obstacle - Turning Left"
                        GotABotClass.subUpdateStatusLine()
                        frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ": Avoiding Obstacle - Turning Left")
                        tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 10 * (ftnInchesToMapUnits(12) / trvObstacleVector.sngRange))
                        ftnObstacleAvoid = ftnBotTurn(ftnObstacleAvoid, False, tbpTargetPose)
                    Else
                        tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation - 15 * (ftnInchesToMapUnits(12) / trvObstacleVector.sngRange))
                        ftnObstacleAvoid = ftnBotTurn(ftnObstacleAvoid, False, tbpTargetPose)
                        strStatusDriving = intDrivingSequenceNumber & ":  Avoiding Obstacle - Turning Right"
                        GotABotClass.subUpdateStatusLine()
                        frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ": Avoiding Obstacle - Turning Right")
                    End If
                End If
                intMovementsSinceLocalization = 10 'Force localization
            End If
            subDoEventsIfMainThread()
        End If
    End Function

    Public Function ftnObstacleDetected(ByVal tbpEstimatedPose As typeBotPose, ByVal strTypeOfMove As String, ByVal tbpTargetPose As typeBotPose) As Boolean
        On Error Resume Next
        ftnObstacleDetected = False
        Dim sngFwdDistance As Single = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpTargetPose.Location)
        If ((strTypeOfMove = "Fwd") Or (strTypeOfMove = "XY")) And Not boolSimulatedMovement Then  'TODO - Add API Range Measurements
            Dim trvObstacleVector As typeRangeVector = ftnObstacleVectorTop(tbpEstimatedPose, strTypeOfMove, tbpTargetPose)
            Dim sngObstacleFwdDistance As Single = ftnObstacleForwardDistance(trvObstacleVector)
            ftnObstacleDetected = (sngObstacleFwdDistance < sngFwdDistance)
        End If
    End Function


    '============================================   Obstacle Detection ===================all=======================================================

    Public Function ftnObstacleVectorTop(ByVal tbpEstimatedPose As typeBotPose, ByVal strTypeOfMove As String, ByVal tbpTargetPose As typeBotPose) As typeRangeVector ' returns a vector ( relative to bot center and orientation) of nearest obstacle.
        '  checks Evolution IRs, IRs, Kinect and the map for obstacles
        On Error Resume Next
        ftnObstacleVectorTop.sngAngle = 0
        ftnObstacleVectorTop.sngRange = 99999
        Dim sngFwdDistance As Single = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpTargetPose.Location)
        If boolER1Selected And boolEnableEvolutionIR_ER1 And Not boolBotIsMoving Then   ' Accessing Evolution IRs or RCM connected IRs during movement may cause communication errors
            Dim strParsedMessage As String()
            strParsedMessage = ftnER1_Communicate("sense all", vbCrLf, 1500).Split(vbCr)
            strParsedMessage = strParsedMessage(0).Split(" "c)
            If (strParsedMessage(0) = "OK") And (UBound(strParsedMessage) >= 9) Then
                If (Val(strParsedMessage(1)) >= intEvolution_IR_Threshold) Then
                    ftnObstacleVectorTop.sngRange = 0
                    ftnObstacleVectorTop.sngAngle = 45
                    sngFwdDistance = 0
                End If
                If (Val(strParsedMessage(4)) >= intEvolution_IR_Threshold) And (Val(strParsedMessage(4)) >= Val(strParsedMessage(1))) Then
                    ftnObstacleVectorTop.sngRange = 0
                    ftnObstacleVectorTop.sngAngle = 0
                    sngFwdDistance = 0
                End If
                If (Val(strParsedMessage(7)) >= intEvolution_IR_Threshold) And (Val(strParsedMessage(7)) >= Val(strParsedMessage(4))) And (Val(strParsedMessage(7)) >= Val(strParsedMessage(1))) Then
                    ftnObstacleVectorTop.sngRange = 0
                    ftnObstacleVectorTop.sngAngle = -45
                    sngFwdDistance = 0
                End If
            End If
        End If
        If (strTypeOfMove = "Fwd") And boolER1Selected And Not boolBotIsMoving Then   ' Accessing Evolution IRs or RCM connected IRs during movement may cause communication errors
            Dim trvRangerVector As typeRangeVector = ftnRangerObstacleVector(tbpEstimatedPose)
            If (ftnObstacleForwardDistance(trvRangerVector) < sngFwdDistance) Then
                ftnObstacleVectorTop = trvRangerVector
                sngFwdDistance = ftnObstacleForwardDistance(trvRangerVector)
                If boolDebugObstacle Then _
                   frmDebug.subWriteLogs(Color.Black, "      OBSTACLE DETECTED BY RANGERS.  Range = " & ftnObstacleVectorTop.sngRange & " at " & ftnObstacleVectorTop.sngAngle & " degrees.")
            End If
        End If
        If ((strTypeOfMove = "Fwd") Or ((strTypeOfMove = "XY") And ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpStartingPose.Location) > sngBotDiameter)) And boolKinectConnected Then
            Dim trvKinectVector As typeRangeVector = ftnKinectObstacleVector(tbpEstimatedPose)
            If (ftnObstacleForwardDistance(trvKinectVector) < sngFwdDistance) Then
                ftnObstacleVectorTop = trvKinectVector
                sngFwdDistance = ftnObstacleForwardDistance(trvKinectVector)
                If boolDebugObstacle Then
                    frmDebug.WritePose("      OBSTACLE DETECTED BY KINECT.   From Pose = ", tbpEstimatedPose)
                    Dim tmcObstacleLocation As typeMapCoordinate = ftnLocationFromEstimatedPose(tbpEstimatedPose, ftnObstacleVectorTop.sngAngle, ftnObstacleVectorTop.sngRange)
                    frmDebug.subWriteLogs(Color.Black, "            'OBSTACLE DETECTED BY KINECT.  Obstacle Vector  = " & ftnObstacleVectorTop.sngRange & " at " & ftnObstacleVectorTop.sngAngle & " degrees.")
                    frmDebug.subWriteLogs(Color.Black, "            OBSTACLE DETECTED BY KINECT.  Obstacle Location = " & tmcObstacleLocation.X & ", " & tmcObstacleLocation.Y)
                End If
            End If
        End If
        If (strTypeOfMove = "Fwd") Or ((strTypeOfMove = "XY") And (ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpStartingPose.Location) > sngBotDiameter)) Then
            Dim trvMapVector As typeRangeVector = ftnMapObstacleVector(tbpEstimatedPose, tbpTargetPose)
            If (ftnObstacleForwardDistance(trvMapVector) < sngFwdDistance) Then
                ftnObstacleVectorTop = trvMapVector
                If boolDebugObstacle Then
                    frmDebug.WritePose("      OBSTACLE DETECTED ON MAP.   From Pose = ", tbpEstimatedPose)
                    Dim tmcObstacleLocation As typeMapCoordinate = ftnLocationFromEstimatedPose(tbpEstimatedPose, ftnObstacleVectorTop.sngAngle, ftnObstacleVectorTop.sngRange)
                    frmDebug.subWriteLogs(Color.Black, "            OBSTACLE DETECTED ON MAP.  Obstacle Vector  = " & ftnObstacleVectorTop.sngRange & " at " & ftnObstacleVectorTop.sngAngle & " degrees.")
                    frmDebug.subWriteLogs(Color.Black, "            OBSTACLE DETECTED ON MAP.  Obstacle Location = " & tmcObstacleLocation.X & ", " & tmcObstacleLocation.Y)
                End If
            End If
        End If
    End Function


    Function ftnMapObstacleVector(ByVal tbpEstimatedPose As typeBotPose, ByVal tbpTargetPose As typeBotPose) As typeRangeVector  ' Check the map for obstacles
        On Error Resume Next
        ftnMapObstacleVector.sngRange = 9999
        ftnMapObstacleVector.sngAngle = 0
        Dim tmcCheckLocation As typeMapCoordinate = tbpEstimatedPose.Location
        Dim sngDistanceToTarget As Single = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpTargetPose.Location)
        If (sngDistanceToTarget > sngBotDiameter) Then
            Dim sngDistanceFromStart As Single = sngBotDiameter
            If (strTypeOfMove = "Fwd") Then tbpTargetPose.Location = ftnLocationFromLocation(tmcCheckLocation, tbpEstimatedPose.Orientation, sngDistanceToTarget)
            ftnMapObstacleVector.sngAngle = 0
            Do
                If boolSlam Then
                    If (byteSlamRawMapArray(tmcCheckLocation.X, tmcCheckLocation.Y) > 128) Then _
                        ftnMapObstacleVector.sngRange = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tmcCheckLocation)
                ElseIf ftnInWall(tmcCheckLocation) Then
                    ftnMapObstacleVector.sngRange = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tmcCheckLocation)
                End If
                If (strTypeOfMove = "Fwd") Then
                    'tmcCheckLocation = ftnNextPointOnLine(tmcCheckLocation, tbpTargetPose.Location)
                    tmcCheckLocation = ftnLocationFromEstimatedPose(tbpEstimatedPose, 0, sngDistanceFromStart)
                ElseIf (strTypeOfMove = "XY") Then
                    tmcCheckLocation = ftnXY_DR(tbpStartingPose, sngDistanceFromStart, tbpTargetPose, False).Location
                End If
                sngDistanceFromStart += sngTwoInches
            Loop Until ftnMapLocationsEqual(tmcCheckLocation, tbpTargetPose.Location) Or (ftnMapObstacleVector.sngRange <> 9999) Or _
                (ftnDistanceBetweenLocations(tmcCheckLocation, tbpTargetPose.Location) <= sngTwoInches) Or boolStop
        End If
    End Function




    Public Function ftnKinectObstacleVector(ByVal tbpEstimatedPose As typeBotPose) As typeRangeVector ' returns a vector ( relative to bot center and orientation) of nearest obstacle. 
        On Error Resume Next
        ftnKinectObstacleVector.sngRange = 99999
        ftnKinectObstacleVector.sngAngle = 0
        If boolKinectConnected And Not ftnIAmLost(tbpEstimatedPose) Then
            evntVectorsAreFresh.WaitOne(1000) ' wait for fresh Kinect data
            Dim sngAdjacent, sngOpposite As Single
            Dim sngFwdDistanceToObstacle As Single = 99999
            Dim sngMinFwdDistanceToObstacle As Single = 99999
            Dim tmcObstacleLocation, typeMapCoordinate
            Dim tbpKinectPose As typeBotPose = tbpEstimatedPose
            For intKinectNumber As Short = 0 To 127 Step 3   ' 
                If (trvScanVectors(intKinectNumber).sngRange > 0) Then ' 
                    If ftnOrientationPointsRight(trvScanVectors(intKinectNumber).sngAngle) Then
                        If (trvScanVectors(intKinectNumber).sngAngle > 0) Then
                            sngAdjacent = sngBotRadius - tmcScanVectorOffset.Y
                        Else
                            sngAdjacent = sngBotRadius + tmcScanVectorOffset.Y
                        End If
                        If (trvScanVectors(intKinectNumber).sngAngle = 0) Then
                            sngOpposite = 99999 + 1
                        Else
                            sngOpposite = sngAdjacent * Tan(ftnDegreeToRadian(90 - Abs(trvScanVectors(intKinectNumber).sngAngle)))
                        End If
                        If (Sqrt(sngOpposite ^ 2 + sngAdjacent ^ 2) < trvScanVectors(intKinectNumber).sngRange) Then
                            sngFwdDistanceToObstacle = 99999
                        Else
                            sngFwdDistanceToObstacle = trvScanVectors(intKinectNumber).sngRange * Sin(ftnDegreeToRadian(90 - Abs(trvScanVectors(intKinectNumber).sngAngle))) + tmcScanVectorOffset.X - sngBotRadius
                        End If
                        If (sngFwdDistanceToObstacle < 99999) Then
                            tbpKinectPose.Location = ftnLocationFromEstimatedPose(tbpEstimatedPose, tmcScanVectorOffset)
                            tmcObstacleLocation = ftnLocationFromEstimatedPose(tbpKinectPose, trvScanVectors(intKinectNumber))
                            ftnKinectObstacleVector.sngRange = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tmcObstacleLocation)
                            ftnKinectObstacleVector.sngAngle = trvScanVectors(intKinectNumber).sngAngle
                            sngMinFwdDistanceToObstacle = sngFwdDistanceToObstacle
                        End If
                    End If
                End If
            Next intKinectNumber
        End If
    End Function

    Function ftnRangerObstacleVector(ByVal tbpEstimatedPose As typeBotPose) As typeRangeVector ' returns a vector ( relative to bot center and orientation) of nearest obstacle. 
        On Error Resume Next
        ftnRangerObstacleVector.sngRange = 99999
        ftnRangerObstacleVector.sngAngle = 0
        If boolVerboseLogFile Then frmDebug.subWriteLogs(Color.DarkGray, Now() & " ************************************ Check Rangers for obstacles ")
        Dim sngAdjacent, sngOpposite As Single
        Dim sngObstacleRange As Single = 99999
        Dim sngFwdDistanceToObstacle As Single = 99999
        Dim sngMinFwdDistanceToObstacle As Single = sngFwdDistanceToObstacle
        Dim tmcObstacleLocation As typeMapCoordinate
        Dim tbpRangerPose As typeBotPose = tbpEstimatedPose
        Dim trvVector As typeRangeVector
        ftnRangerObstacleVector.sngRange = 99999
        ftnRangerObstacleVector.sngAngle = 0
        If boolER1Selected Then frmRangeFinder.subGetAllRangerReadingsER1()
        For intRangerNumber As Short = 1 To intHighestEnabledRangerNumber   ' For each IR Range Finder
            If trfRangeFinders(intRangerNumber).boolEnable And (sngObstacleRange < ftnCmToMapUnits(70)) And (sngObstacleRange <> 0) Then
                trvVector.sngRange = trfRangeFinders(intRangerNumber).sngRange
                trvVector.sngAngle = trfRangeFinders(intRangerNumber).intOrientation
                sngObstacleRange = trfRangeFinders(intRangerNumber).sngRange ' Get the Range Finder reading
                If ftnOrientationPointsRight(trfRangeFinders(intRangerNumber).intOrientation) Then
                    If (trfRangeFinders(intRangerNumber).intOrientation > 0) Then
                        sngAdjacent = sngBotRadius - trfRangeFinders(intRangerNumber).intOffset.Y
                    Else
                        sngAdjacent = sngBotRadius + trfRangeFinders(intRangerNumber).intOffset.Y
                    End If
                    If (trfRangeFinders(intRangerNumber).intOrientation = 0) Then
                        sngOpposite = 999999
                    Else
                        sngOpposite = sngAdjacent * Tan(ftnDegreeToRadian(90 - Abs(trfRangeFinders(intRangerNumber).intOrientation)))
                    End If
                    If (Sqrt(sngOpposite ^ 2 + sngAdjacent ^ 2) < sngObstacleRange) Then
                        sngFwdDistanceToObstacle = 99999
                    Else
                        sngFwdDistanceToObstacle = sngObstacleRange * Sin(ftnDegreeToRadian(90 - Abs(trvVector.sngAngle))) + trfRangeFinders(intRangerNumber).intOffset.X - sngBotRadius
                    End If
                    If (sngFwdDistanceToObstacle < sngMinFwdDistanceToObstacle) Then
                        tbpRangerPose.Location = ftnLocationFromEstimatedPose(tbpEstimatedPose, trfRangeFinders(intRangerNumber).intOffset)
                        tmcObstacleLocation = ftnLocationFromEstimatedPose(tbpRangerPose, trvVector)
                        trvVector.sngRange = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tmcObstacleLocation)
                        ftnRangerObstacleVector = trvVector
                        sngMinFwdDistanceToObstacle = sngFwdDistanceToObstacle
                    End If
                End If
            End If
        Next intRangerNumber
    End Function

    Public Function ftnObstacleForwardDistance(ByVal trvObstacleVector As typeRangeVector) As Single
        On Error Resume Next
        If ((trvObstacleVector.sngRange * Sin(ftnDegreeToRadian(Abs(trvObstacleVector.sngAngle)))) < sngBotRadius) Then
            ftnObstacleForwardDistance = trvObstacleVector.sngRange * Cos(ftnDegreeToRadian(Abs(trvObstacleVector.sngAngle))) - sngBotRadius
        Else
            ftnObstacleForwardDistance = 9999
        End If
    End Function



    Public Function ftnRangerBackupObstacleDistance() As Single
        ' returns the distance from the bot center to the nearest object detected behind the bot.  Must have at least one Ranger orientated at 180 degrees
        ftnRangerBackupObstacleDistance = 9999
        On Error Resume Next
        If boolVerboseLogFile Then frmDebug.subWriteLogs(Color.DarkGray, Now() & " **** Check for obstacles")
        If boolRangersAreEnabled Then
            For intRangerNumber As Integer = 1 To intHighestEnabledRangerNumber ' For each Range Finder
                If trfRangeFinders(intRangerNumber).boolEnable And trfRangeFinders(intRangerNumber).intOrientation = 180 Then
                    ftnRangerBackupObstacleDistance = frmRangeFinder.ftnRangeFinderRange(intRangerNumber) + sngBotRadius - trfRangeFinders(intRangerNumber).intOffset.X * sngGridSize ' Get the Range Finder reading
                    Exit Function
                End If
            Next
        End If
        subDoEventsIfMainThread()
    End Function

End Module



Module modPreventCollisions
    '  Detects potential collisions while moving 
    Public Class classObstacleMoving
        Public Event evntCollisionPredicted()
        Public Sub subPreventCollisions()
            On Error Resume Next
            Dim trvObstacleVector As typeRangeVector
            Dim sngDistanceToObstacle As Single
            Dim sngSafeDistance As Single = sngfortyInches * sngBotLinearVelocity / 50
            Dim sngMinDistance As Single = sngSixInches * sngBotLinearVelocity / 50
            Dim intLoopCnt As Short = 0
            Dim tbpPoseWhileMoving As typeBotPose = tbpBotPose
            Dim sngCorrelation As Single = 0
            Dim boolValidLocation As Boolean = False
            While Not boolShutDown
                While boolBotIsMoving And boolDrivingToDestination And Not boolSimulatedMovement And Not boolStop
                    intLoopCnt += 1
                    If (strTypeOfMove = "Fwd") Or (strTypeOfMove = "XY") Then
                        tbpPoseWhileMoving = ftnLocalizeUsingDeadReckoning(tbpPoseWhileMoving, constGotAKinectDelay, tbpTargetPoseGlobal)   ' 
                        Dim sngDistanceLeftToTravel As Single = ftnDistanceBetweenLocations(tbpTargetPoseGlobal.Location, tbpPoseWhileMoving.Location)
                        If (sngDistanceLeftToTravel > sngMinDistance) Then
                            trvObstacleVector = ftnObstacleVectorTop(tbpPoseWhileMoving, strTypeOfMove, tbpTargetPoseGlobal)
                            sngDistanceToObstacle = ftnObstacleForwardDistance(trvObstacleVector)
                            If (sngDistanceToObstacle < sngDistanceLeftToTravel) And (sngDistanceToObstacle < sngSafeDistance) And (sngDistanceLeftToTravel > sngMinDistance) And boolBotIsMoving Then
                                RaiseEvent evntCollisionPredicted()
                                Thread.Sleep(100)
                                frmDebug.subWriteLogs(Color.Black, " /// Collision Predicted: Range = " & trvObstacleVector.sngRange & " at " & trvObstacleVector.sngAngle & " degrees.")
                                While boolBotIsMoving And Not boolStop
                                    Thread.Sleep(100)
                                End While
                                Thread.Sleep(100)
                            End If
                        End If
                    End If
                    Thread.Sleep(100)
                End While
                If (intLoopCnt > 0) And (strTypeOfMove = "Fwd") And boolDebugObstacle Then _
                  frmDebug.subWriteLogs(Color.Black, "        (Checked for Obstacles " & intLoopCnt & " times)")
                intLoopCnt = 0
                Thread.Sleep(250)
            End While
        End Sub

    End Class
End Module

