﻿Imports System.Drawing.Imaging
Imports System.Drawing
Imports System.Math

Imports Emgu.CV
Imports Emgu.CV.UI
Imports Emgu.Util
Imports Emgu.CV.Structure
Imports Emgu.CV.CvEnum
Imports Microsoft.Kinect



'
' TODO
'   - CONVERT TO STRAIGHT LINES
'   - FIFO 
'      - add map
'      - interpret
'      - close loop
'   - frmSLAM
'        - overlay GotABot Map
'        - DEBUG: show raw, bmp, intPath maps


Module modSLAM
    Public byteSlamRawMapArray(Map_SizeX, Map_SizeY) As Byte

    Public Sub subSlamTop(sender As System.Object, e As System.EventArgs)
        On Error Resume Next
        Dim intOldNumberOfScanVectors As Integer = intNumberOfScanVectors
        Dim boolGoodPath As Boolean
        intNumberOfScanVectors = 320
        ftnLocalizeUsingOdometry(tbpBotPose, tbpStartingPose) ' initialize tmcStartingOdometry
        intLastCollisionSequenceNumber = -6
        intDrivingSequenceNumber = 0
        boolSlam = True
        frmDebug.subWriteLogs(Color.DarkGray, Now() & " @@@@@@@@@@@ SLAM:  Start of Map Making   @@@@@@@@@@@")
        ftnSendCommand("clear")  ' Clear the old visual recognizer data
        subDoEventsIfMainThread()

        Dim boolMovedForward As Boolean
        While Not boolStop
            ftnSendCommand("battery")
            subThresholdSlamRawMapArrayToMapArray()
            Do
                Do  ' Move forward until  obstacle encountered
                    subDisplaySlamMap()
                    tbpTargetPoseGlobal = tbpBotPose
                    frmDebug.subWriteLogs(Color.Black, Now() & " @@@@@@@@@@@ SLAM: Move forward until obstacle encountered: ")
                    subCheckForPause()
                    If Not ftnGoodLocalization() Then subScanForLandMarks()
                    tbpBotPose = ftnLocalizeSlam()
                    boolMovedForward = ftnSlamExecuteMove()
                    intDrivingSequenceNumber += 1
                    subPostSlamMove()
                    subDoEventsIfMainThread()
                Loop Until Not boolMovedForward Or boolStop
            Loop Until (ftnObstacleForwardDistance(ftnObstacleVectorTop(tbpBotPose, strTypeOfMove, tbpTargetPoseGlobal)) < ftnInchesToMapUnits(12)) Or boolStop
            tbpBotPose = ftnLocalizeSlam()
            boolGoodPath = ftnFindSlamPath() ' Then Find an unexplored location that can be driven to
            If boolGoodPath And Not boolStop Then
                subDriveToDestination_Top(tmcDestination) ' Drive to unexplored location
            ElseIf Not boolStop Then
                frmDebug.subWriteLogs(Color.Black, Now() & " @@@@@@@@@@@ SLAM: Searching for new unexplored locations: ")
                tbpTargetPoseGlobal.Orientation = ftnConvertTo360(tbpTargetPoseGlobal.Orientation + 60)
                tbpBotPose = ftnBotTurn(tbpBotPose, True, tbpTargetPoseGlobal)
                tbpBotPose = ftnLocalizeSlam()
                subSlamCollisionRecovery()
            End If
        End While

        ftnSendCommand("play phrase 'All done'")
        frmDebug.subWriteLogs(Color.DarkGray, Now() & "  @@@@@@@@@@@ SLAM:  Map Making Complete   @@@@@@@@@@@")
        boolSlam = False
        subDisplaySlamMap()
        subDrawBot(tbpBotPose)
        intNumberOfScanVectors = intOldNumberOfScanVectors
        strStatusDriving = "  Waiting For Command "
        GotABotClass.subUpdateStatusLine()
    End Sub




    '------------------------------------- Misc Routines ----------------------------------------------------------------------------------------

    Function ftnLocalizeSlam() As typeBotPose
        ftnLocalizeSlam = ftnLocalize_Top(tbpBotPose)
        tbpBotPose = ftnLocalizeSlam
        If ftnGoodLocalization() Then
            subUpdateSlamMap_AllRangeMeasurements()
            subUpdateSlamMap_BotFootprint(tbpBotPose.Location)
            subConvertMapToStraightLines()
        End If
    End Function

    Function ftnGoodLocalization() As Boolean
        ftnGoodLocalization = (ftnPoseUncertaintyFactor(tbpBotPose) < 394)   '(394 = (12 inches + 12 inches) * 16 degrees)
    End Function


    Public Function ftnFindSlamPath() As Boolean
        ' returns true if a destination and a path to the destination is found
        ftnFindSlamPath = False
        boolSlamCollision = False
        subThresholdSlamRawMapArrayToMapArray()
        subAddBufferSpace()
        tmcDestination = ftnFindNearestUnexploredLocation()
        If Not ftnMapLocationsEqual(tmcDestination, tbpBotPose.Location) Then
            subGeneratePathMatrix()
            ftnFindSlamPath = ftnGeneratePathCosts(tmcDestination, tbpBotPose.Location)
        End If
        If ftnFindSlamPath And Not boolStop Then
            subDrawDestination(tmcDestination)
            frmDebug.subWriteLogs(Color.Black, Now() & " @@@@@@@@@@@ ")
            frmDebug.subWriteLogs(Color.Black, Now() & " @@@@@@@@@@@ ")
            frmDebug.subWriteLogs(Color.Black, Now() & " @@@@@@@@@@@ ")
            frmDebug.subWriteLogs(Color.Black, Now() & " @@@@@@@@@@@ SLAM: New location to explore: " & tmcDestination.X & ", " & tmcDestination.Y)
            frmDebug.subWriteLogs(Color.Black, Now() & " @@@@@@@@@@@ ")
            frmDebug.subWriteLogs(Color.Black, Now() & " @@@@@@@@@@@ ")
        ElseIf Not ftnFindSlamPath Then
            subSlamMarkAsMoreOccupied(tmcDestination) ' set location and surrounding pixels as slightly occupied so that we don't set it as a destination again
        End If
    End Function

    Public Sub subSlamMarkAsMoreOccupied(ByVal tmcLocation As typeMapCoordinate) ' set location and surrounding pixels as slightly occupied
        Dim tmcCheckLocation As typeMapCoordinate
        For intX As Integer = tmcLocation.X - sngOneInch To tmcLocation.X + sngOneInch
            For intY As Integer = tmcLocation.Y - sngOneInch To tmcLocation.Y + sngOneInch
                tmcCheckLocation = ftnConvertToTMC(intX, intY)
                tmcCheckLocation = ftnCheckMapArrayLimits(tmcCheckLocation)
                If (byteSlamRawMapArray(tmcCheckLocation.X, tmcCheckLocation.Y) < 192) Then _
                    byteSlamRawMapArray(tmcCheckLocation.X, tmcCheckLocation.Y) += 64
            Next intY
        Next intX
    End Sub

    Public Sub subLoadSlamMapArray()
        strStatusDriving = "Loading SLAM Map "
        GotABotClass.subUpdateStatusLine()
        Dim intSizeX As Short = Map_SizeX
        Dim intSizeY As Short = Map_SizeY
        For intX = 0 To intSizeX - 1   ' Convert the map image into byteNavigationMap.   0 = free,  255 = occupied
            For intY = 0 To intSizeY - 1
                byteSlamRawMapArray(intX, intY) = 255 - bmpMap.GetPixel(intX, intY).G
                If (byteSlamRawMapArray(intX, intY) < 128) Then
                    byteNavigationMap(intX, intY) = 0
                Else
                    byteNavigationMap(intX, intY) = 255
                End If
            Next intY
        Next intX
        subDisplaySlamMap() ' Convert and display
    End Sub




    '------------------------------------- Movement ----------------------------------------------------------------------------------------

    Function ftnSlamExecuteMove() As Boolean
        ' returns True if Bot moves forward, False if a Turn
        On Error Resume Next
        ftnSlamExecuteMove = False
        strStatusDriving = intDrivingSequenceNumber & ": Moving  "
        GotABotClass.subUpdateStatusLine()

        strTypeOfMove = "Fwd"
        tbpTargetPoseGlobal.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, ftnInchesToMapUnits(24))
        Dim trvObstacleVector As typeRangeVector = ftnObstacleVectorTop(tbpBotPose, strTypeOfMove, tbpTargetPoseGlobal)
        trvObstacleVector.sngRange = ftnObstacleForwardDistance(trvObstacleVector)
        tbpTargetPoseGlobal = tbpBotPose
        If (boolKinectConnected) And (trvObstacleVector.sngRange > ftnInchesToMapUnits(24)) Then
            tbpTargetPoseGlobal.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, ftnInchesToMapUnits(12))
            tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPoseGlobal)
            ftnSlamExecuteMove = True
        ElseIf (trvObstacleVector.sngRange > ftnInchesToMapUnits(12)) Then
            tbpTargetPoseGlobal.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngSixInches)
            tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPoseGlobal)
            ftnSlamExecuteMove = True
        End If

        tbpTargetPoseGlobal = tbpBotPose
        If Not ftnSlamExecuteMove Then
            tbpBotPose = ftnLocalizeSlam()
            If (trvObstacleVector.sngAngle < 0) Then 'And _
                frmDebug.subWriteLogs(Color.DarkGray, Now() & intDrivingSequenceNumber & ":  Avoiding Obstacle - Turning Left")
                strStatusDriving = intDrivingSequenceNumber & ":  Avoiding Obstacle - Turning Left"
                GotABotClass.subUpdateStatusLine()
                tbpTargetPoseGlobal.Orientation = ftnConvertTo360(tbpTargetPoseGlobal.Orientation + 20)
                tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPoseGlobal)
            Else
                frmDebug.subWriteLogs(Color.DarkGray, Now() & intDrivingSequenceNumber & ":  Avoiding Obstacle - Turning Right")
                strStatusDriving = intDrivingSequenceNumber & ":  Avoiding Obstacle - Turning Right"
                tbpTargetPoseGlobal.Orientation = ftnConvertTo360(tbpTargetPoseGlobal.Orientation - 35)
                tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPoseGlobal)
                GotABotClass.subUpdateStatusLine()
            End If
        End If
        subDoEventsIfMainThread()
    End Function

    Sub subPostSlamMove()
        If frmSlam.radioWaitForScan.Checked Then
            For I As Integer = 1 To frmSlam.updnTime.Value
                strStatusDriving = intDrivingSequenceNumber & ":  Waiting For Range Data " & (frmSlam.updnTime.Value - I + 1).ToString
                GotABotClass.subUpdateStatusLine()
                subWait(1000)
            Next I
            'ElseIf bool_IgnoreAPIOrientation And (tbpBotPose.OrientationUncertainty >= intApiUncertainty) Then
            '   strStatusDriving = intDrivingSequenceNumber & ":  Waiting For Compass Data "
            '   subWait(2000) ' Wait for compass update
        End If
        subDoEventsIfMainThread()
        subSlamCollisionRecovery()
        subDrawBot(tbpBotPose)
        subDoEventsIfMainThread()
    End Sub

    Sub subSlamCollisionRecovery()
        If Not boolCollisionDetected Then boolCollisionDetected = ftnCheckForCollision()
        While boolCollisionDetected And Not boolStop
            frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ":  Collision Recovery  ##################################### ")
            subDoEventsIfMainThread()
            tbpBotPose = ftnCollisionRecovery(tbpBotPose)
            subDisplaySlamMap()
            subDoEventsIfMainThread()
            If Not boolCollisionDetected Then boolCollisionDetected = ftnCheckForCollision()
            tbpBotPose = ftnLocalizeSlam()
        End While
    End Sub



    '------------------------------------- Movement ----------------------------------------------------------------------------------------
    Sub subLimitSlamUncertainties()
        If ((tbpBotPose.LocationUncertainty.X > ftnInchesToMapUnits(20) / sngGridSize) Or (tbpBotPose.LocationUncertainty.Y > ftnInchesToMapUnits(20) / sngGridSize) Or (tbpBotPose.OrientationUncertainty > 20)) Then
            tbpBotPose.LocationUncertainty.X = ftnInchesToMapUnits(20) / sngGridSize
            tbpBotPose.LocationUncertainty.Y = ftnInchesToMapUnits(20) / sngGridSize
            tbpBotPose.OrientationUncertainty = intApiUncertainty
        End If
    End Sub

    Sub subScanForLandMarks()
        'TODO Check that there is a potential LM within scan range
        If (ftnLMCount() > 0) And (boolEnableLocalRCC Or boolEnableLocalRR Or boolER1Selected) Then
            Dim intTurnNumber As Integer = 0
            Dim intMaxTurns As Integer = 360 / (sngCameraFOV * 0.8)
            strStatusDriving = intDrivingSequenceNumber & ": Position unsure.  Scanning. "
            GotABotClass.subUpdateStatusLine()
            While (intTurnNumber < intMaxTurns) And Not boolStop And Not boolShutDown And _
                ((tbpBotPose.LocationUncertainty.X > ftnInchesToMapUnits(20) / sngGridSize) Or (tbpBotPose.LocationUncertainty.Y > ftnInchesToMapUnits(20) / sngGridSize) Or (tbpBotPose.OrientationUncertainty > 20))
                tbpTargetPoseGlobal = tbpBotPose
                tbpTargetPoseGlobal.Orientation = ftnConvertTo360(tbpTargetPoseGlobal.Orientation + -sngCameraFOV * 0.8)
                tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPoseGlobal)
                tbpBotPose = ftnLocalizeSlam()
                subSlamCollisionRecovery()
                intTurnNumber += 1
            End While
        End If
        subLimitSlamUncertainties()
    End Sub

    Function ftnLMCount() As Integer
        ftnLMCount = 0
        For intI As Integer = 1 To 126
            If tlmLandMarkArray(intI).LandMarkName <> "" Then ftnLMCount += 1
        Next intI
    End Function



    '---------------------------------------------------Update Map --------------------------------------------------------------------------------------------------------

    Sub subUpdateSlamMap_AllRangeMeasurements()
        subPushSlamRecords()
        For intRangerNumber As Integer = 1 To intHighestEnabledRangerNumber ' For each Range Finder
            subDoEventsIfMainThread()
            If trfRangeFinders(intRangerNumber).boolEnable And (trfRangeFinders(intRangerNumber).sngRange > sngBotRadius) Then _
            subUpdateSlamMap_Ranger(intRangerNumber)
        Next intRangerNumber
        For intScanVectorNumber As Integer = 0 To 127 ' For each Scan Vector
            subDoEventsIfMainThread()
            If (trvScanVectors(intScanVectorNumber).sngRange > sngBotRadius) Then _
                subUpdateSlamMap_ScanVector(intScanVectorNumber)
        Next intScanVectorNumber
        subDoEventsIfMainThread()
        subDisplaySlamMap()
    End Sub


    Sub subUpdateSlamMap_Ranger(ByVal intRangerNumber As Integer)
        On Error Resume Next
        strStatusDriving = ":  Mapping Ranger Data "
        GotABotClass.subUpdateStatusLine()
        If boolStop Then Exit Sub
        Dim tmcRangeIntermediateLocation As typeMapCoordinate
        Dim trvRangeVector As typeRangeVector
        trvRangeVector.sngAngle = trfRangeFinders(intRangerNumber).intOrientation
        trvRangeVector.sngRange = trfRangeFinders(intRangerNumber).sngRange
        Dim tbpRangerPose As typeBotPose = tbpBotPose
        tbpRangerPose.Location = ftnLocationFromEstimatedPose(tbpRangerPose, trfRangeFinders(intRangerNumber).intOffset)
        Dim sngMaxEmptyRange As Single = ftnMinValue(trfRangeFinders(intRangerNumber).sngRange, trfRangeFinders(intRangerNumber).sngMaxRange) - sngGridSize
        For intDistance As Integer = 0 To sngMaxEmptyRange   ' Empty spaces
            trvRangeVector.sngRange = intDistance
            tmcRangeIntermediateLocation = ftnLocationFromEstimatedPose(tbpRangerPose, trvRangeVector)
            subUpdateSlamMap(tmcRangeIntermediateLocation, 0)
        Next intDistance
        If (trfRangeFinders(intRangerNumber).sngRange < trfRangeFinders(intRangerNumber).sngMaxRange) Then
            trvRangeVector.sngRange = trfRangeFinders(intRangerNumber).sngRange
            tmcRangeIntermediateLocation = ftnLocationFromEstimatedPose(tbpRangerPose, trvRangeVector) ' Occupied Space
            subUpdateSlamMap(tmcRangeIntermediateLocation, 100)
        End If
    End Sub


    Sub subUpdateSlamMap_ScanVector(ByVal intScanVectorNumber As Integer)
        On Error Resume Next
        strStatusDriving = ":  Mapping ScanVector Data "
        GotABotClass.subUpdateStatusLine()
        If boolStop Then Exit Sub
        Dim tmcRangeIntermediateLocation As typeMapCoordinate
        Dim trvRangeVector As typeRangeVector
        trvRangeVector.sngAngle = trvScanVectors(intScanVectorNumber).sngAngle
        trvRangeVector.sngRange = trvScanVectors(intScanVectorNumber).sngRange
        Dim tbpRangerPose As typeBotPose = tbpBotPose
        tbpRangerPose.Location = ftnLocationFromEstimatedPose(tbpRangerPose, tmcScanVectorOffset)
        Dim sngMaxEmptyRange As Single = ftnMinValue(trvScanVectors(intScanVectorNumber).sngRange, ftnInchesToMapUnits(intScanVectorsMaxRange)) - sngGridSize
        For intDistance As Integer = 0 To sngMaxEmptyRange   ' Empty spaces
            trvRangeVector.sngRange = intDistance
            tmcRangeIntermediateLocation = ftnLocationFromEstimatedPose(tbpRangerPose, trvRangeVector)
            subUpdateSlamMap(tmcRangeIntermediateLocation, 0)
        Next intDistance
        trvRangeVector.sngRange = trvScanVectors(intScanVectorNumber).sngRange
        tmcRangeIntermediateLocation = ftnLocationFromEstimatedPose(tbpRangerPose, trvRangeVector) ' Occupied Space
        subUpdateSlamMap(tmcRangeIntermediateLocation, 100)
    End Sub



    Public Sub subUpdateSlamMap(ByVal tmcMapLocation As typeMapCoordinate, ByVal intMeasuredOccupiedPercentage As Integer)
        tmcMapLocation = ftnCheckMapArrayLimits(tmcMapLocation)
        Dim byteB4 As Byte = byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y)
        Dim sngRangeFactor As Single = ftnInchesToMapUnits(48) / ftnDistanceBetweenLocations(tbpBotPose.Location, tmcMapLocation)
        If (sngRangeFactor > 1) Then sngRangeFactor = 1
        Dim sngCertaintyFactor As Single = sngRangeFactor * ftnInchesToMapUnits(30) / _
                                           ((ftnMapUnitsToInches(tbpBotPose.LocationUncertainty.X + tbpBotPose.LocationUncertainty.Y) _
                                              * sngGridSize + tbpBotPose.OrientationUncertainty)) * Abs(50 - intMeasuredOccupiedPercentage) / 50
        sngCertaintyFactor = Sqrt(sngCertaintyFactor)
        If (sngCertaintyFactor > 1) Then sngCertaintyFactor = 1
        sngCertaintyFactor = 1
        If ((intMeasuredOccupiedPercentage * 2.55 * sngCertaintyFactor) > byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y)) Then
            If (byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y) < 224) Then
                byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y) += 32 * sngCertaintyFactor
            Else
                byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y) = 255
            End If
        ElseIf ((intMeasuredOccupiedPercentage * 2.55 + 255 * (1 - sngCertaintyFactor)) < byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y)) Then
            If (byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y) > 7) Then
                byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y) -= 8 * sngCertaintyFactor
            Else
                byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y) = 0
            End If
        End If
        If (byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y) < 128) Then
            byteNavigationMap(tmcMapLocation.X, tmcMapLocation.Y) = 0
        Else
            byteNavigationMap(tmcMapLocation.X, tmcMapLocation.Y) = 255
        End If
        bmpSlamMap.SetPixel(tmcMapLocation.X, tmcMapLocation.Y, ftnGreyToColor(255 - byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y)))
        Dim byteAfter As Byte = byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y)
    End Sub

    Sub subUpdateSlamMap_BotFootprint(ByVal tmcMapLocation As typeMapCoordinate)
        Dim intFootprintRadius As Integer = sngBotDiameter / 3
        Dim tmcLocation As typeMapCoordinate
        For tmcLocation.X = tmcMapLocation.X - intFootprintRadius To tmcMapLocation.X + intFootprintRadius
            For tmcLocation.Y = tmcMapLocation.Y - intFootprintRadius To tmcMapLocation.Y + intFootprintRadius
                subUpdateSlamMap(tmcLocation, 0)
            Next tmcLocation.Y
        Next tmcLocation.X
    End Sub



    '--------------------------------------------------- Map Processing --------------------------------------------------------------------------------------------------------

    Sub subThresholdSlamRawMapArrayToMapArray()
        For intX = 0 To Map_SizeX - 1
            subDoEventsIfMainThread()
            For intY = 0 To Map_SizeY - 1
                If (byteSlamRawMapArray(intX, intY) < 128) Then
                    byteNavigationMap(intX, intY) = 0
                Else
                    byteNavigationMap(intX, intY) = 255
                End If
            Next intY
        Next intX
    End Sub

    Public Sub subDisplayThresholdedSlamMap()
        On Error Resume Next
        subThresholdSlamRawMapArrayToMapArray()
        For intX = 0 To Map_SizeX - 1
            subDoEventsIfMainThread()
            For intY = 0 To Map_SizeY - 1
                If (byteNavigationMap(intX, intY) = 0) Then
                    bmpSlamMap.SetPixel(intX, intY, ftnGreyToColor(255))
                Else
                    bmpSlamMap.SetPixel(intX, intY, ftnGreyToColor(0))
                End If
            Next intY
        Next intX
    End Sub



    '--------------------------------------------------- Display --------------------------------------------------------------------------------------------------------

    Public Sub subDisplaySlamMap()
        Dim imgSlamMapRaw As Image(Of Bgr, Byte) = New Image(Of Bgr, Byte)(bmpSlamMap)
        If Not GotABotClass.InvokeRequired Then
            If frmSlam.mnuMapRaw.Checked Then
                strStatusDriving = "SLAM Raw Map"
            ElseIf frmSlam.mnuMapThreshold.Checked Then
                subDisplayThresholdedSlamMap()
                strStatusDriving = "SLAM Thresholded Map"
            ElseIf frmSlam.mnuMapSmooth.Checked Then
                Dim gray As Emgu.CV.Image(Of Emgu.CV.Structure.Gray, Byte) = imgSlamMapRaw.Convert(Of Gray, Byte).PyrDown.PyrUp()
                Dim dialate As Image(Of Gray, Byte) = gray '.Dilate(1)
                Dim gaussian As Emgu.CV.Image(Of Emgu.CV.Structure.Gray, Byte) = dialate.SmoothGaussian(3)
                Dim Threshold1 As New Gray(129)
                Dim ThresholdMax As New Gray(255)
                Dim threshold As Emgu.CV.Image(Of Emgu.CV.Structure.Gray, Byte) = gaussian.ThresholdBinary(Threshold1, ThresholdMax)
                bmpSlamMap = threshold.ToBitmap
                strStatusDriving = "SLAM Smooth Map"
            ElseIf frmSlam.mnuMapEdge.Checked Then
                Dim gray As Emgu.CV.Image(Of Emgu.CV.Structure.Gray, Byte) = imgSlamMapRaw.Convert(Of Gray, Byte).PyrDown.PyrUp()
                Dim dialate As Image(Of Gray, Byte) = gray '.Dilate(1)
                Dim gaussian As Emgu.CV.Image(Of Emgu.CV.Structure.Gray, Byte) = dialate '.SmoothGaussian(3)
                Dim cannyThreshold As New Gray(64)
                Dim cannyThresholdLinking As New Gray(120)
                Dim cannyEdges As Image(Of Gray, Byte) = gaussian.Canny(cannyThreshold, cannyThresholdLinking)
                bmpSlamMap = cannyEdges.Not.ToBitmap
                strStatusDriving = "SLAM Edge Map "
            End If
            GotABotClass.subUpdateStatusLine()
            GotABotClass.imgMap = bmpSlamMap
            GotABotClass.subRedraw(tbpBotPose)
        End If
    End Sub




    '--------------------------------------------------- Find Unexplored location --------------------------------------------------------------------------------------------------------

    Function ftnFindNearestUnexploredLocation() As typeMapCoordinate
        ftnFindNearestUnexploredLocation = tbpBotPose.Location
        Dim tmcLocation As typeMapCoordinate
        Dim boolFoundUnexploredAndReachable As Boolean = False
        For intOrientation As Short = -60 To 60 Step 30 ' Find any unexplored locations which are a short distance in front (generally)
            For intRange As Integer = sngBotRadius To sngTwentyFiveInches
                subDoEventsIfMainThread()
                tmcLocation = ftnLocationFromEstimatedPose(tbpBotPose, intOrientation, intRange)
                If (byteSlamRawMapArray(tmcLocation.X, tmcLocation.Y) > 143) Then Exit For ' Hit a wall - don't look furthur at this orientation
                If Not boolFoundUnexploredAndReachable Then
                    If ftnLocationUnexploredAndReachable(tmcLocation) Then boolFoundUnexploredAndReachable = True
                    ftnFindNearestUnexploredLocation = tmcLocation
                End If
            Next intRange
        Next intOrientation

        For intX As Short = sngBotRadius To Map_SizeX
            subDoEventsIfMainThread()
            For intY As Short = sngBotRadius To Map_SizeY
                If Not boolFoundUnexploredAndReachable Then
                    If Not boolFoundUnexploredAndReachable Then
                        tmcLocation = ftnConvertToTMC(tbpBotPose.Location.X + intX, tbpBotPose.Location.Y + intY)
                        boolFoundUnexploredAndReachable = ftnLocationUnexploredAndReachable(tmcLocation)
                    End If
                    If Not boolFoundUnexploredAndReachable Then
                        tmcLocation = ftnConvertToTMC(tbpBotPose.Location.X - intX, tbpBotPose.Location.Y + intY)
                        boolFoundUnexploredAndReachable = ftnLocationUnexploredAndReachable(tmcLocation)
                    End If
                    If Not boolFoundUnexploredAndReachable Then
                        tmcLocation = ftnConvertToTMC(tbpBotPose.Location.X + intX, tbpBotPose.Location.Y - intY)
                        boolFoundUnexploredAndReachable = ftnLocationUnexploredAndReachable(tmcLocation)
                    End If
                    If Not boolFoundUnexploredAndReachable Then
                        tmcLocation = ftnConvertToTMC(tbpBotPose.Location.X - intX, tbpBotPose.Location.Y - intY)
                        boolFoundUnexploredAndReachable = ftnLocationUnexploredAndReachable(tmcLocation)
                    End If
                    If boolFoundUnexploredAndReachable Then ftnFindNearestUnexploredLocation = tmcLocation
                End If
            Next intY
        Next intX
    End Function

    Function ftnLocationUnexploredAndReachable(ByRef tmcLocation As typeMapCoordinate) As Boolean
        ftnLocationUnexploredAndReachable = False
        tmcLocation = ftnCheckMapArrayLimits(tmcLocation)
        If ftnLocationUnexplored(tmcLocation) Then
            If ftnLocationReachable(tmcLocation) Then
                ftnLocationUnexploredAndReachable = True
            End If
        End If
    End Function

    Function ftnLocationUnexplored(ByVal tmcLocation As typeMapCoordinate) As Boolean
        On Error Resume Next
        Dim tmcLocationCheck As typeMapCoordinate
        ftnLocationUnexplored = False
        If Not ftnInWall(tmcLocation) Then
            ftnLocationUnexplored = True
            For intX As Integer = tmcLocation.X - sngOneInch To tmcLocation.X + sngOneInch
                For intY As Integer = tmcLocation.Y - sngOneInch To tmcLocation.Y + sngOneInch
                    tmcLocationCheck = ftnConvertToTMC(intX, intY)
                    tmcLocationCheck = ftnCheckMapArrayLimits(tmcLocationCheck)
                    If (byteSlamRawMapArray(tmcLocationCheck.X, tmcLocationCheck.Y) <> 127) Then _
                        ftnLocationUnexplored = False
                Next intY
            Next intX
        End If
    End Function

    Function ftnLocationReachable(ByVal tmcLocationToCheck As typeMapCoordinate) As Boolean
        ftnLocationReachable = False
        subCheckMapArrayLimits(tmcLocationToCheck.X, tmcLocationToCheck.Y)
        If (byteNavigationMap(tmcLocationToCheck.X, tmcLocationToCheck.Y) < 120) Then  ' make sure its not too close to a wall
            For intX As Integer = sngTwoInches To ftnInchesToMapUnits(3)
                subDoEventsIfMainThread()
                For intY As Integer = sngTwoInches To ftnInchesToMapUnits(3)
                    If (byteSlamRawMapArray(tmcLocationToCheck.X + intX, tmcLocationToCheck.Y + intY) < 120) Then _
                        ftnLocationReachable = True
                    If (byteSlamRawMapArray(tmcLocationToCheck.X - intX, tmcLocationToCheck.Y + intY) < 120) Then _
                        ftnLocationReachable = True
                    If (byteSlamRawMapArray(tmcLocationToCheck.X + intX, tmcLocationToCheck.Y - intY) < 120) Then _
                        ftnLocationReachable = True
                    If (byteSlamRawMapArray(tmcLocationToCheck.X - intX, tmcLocationToCheck.Y - intY) < 120) Then _
                        ftnLocationReachable = True
                Next intY
            Next intX
        End If
    End Function




    '--------------------------------------------------- TODO --------------------------------------------------------------------------------------------------------


    Sub subPushSlamRecords()
        ' For I As Integer = 1 To (constSlamRecordLength - 1)
        'tsrSlamRecords(I) = tsrSlamRecords(I - 1)
        'Next
        'tsrSlamRecords(0).trfRangeFinders = trfRangeFinders
        'tsrSlamRecords(0).byteNavigationMap = byteSlamRawMapArray
        'tsrSlamRecords(0).tbpBotPose = tbpBotPose
        'tsrSlamRecords(0).strdriveInstruction = ""
    End Sub


    Sub subConvertMapToStraightLines()

    End Sub

    '--------------------------------------------------- Obsolete / Unused --------------------------------------------------------------------------------------------------------


    'Dim intSizeX As Short = Map_SizeX
    'Dim intSizeY As Short = Map_SizeY
    'Dim byteIntensity As Byte
    ' For intX As Integer = 0 To intSizeX - 1   ' Convert the map image into byteNavigationMap.   0 = free,  255 = occupied
    '    For intY As Integer = 0 To intSizeY - 1
    '        byteIntensity = 255 - byteNavigationMap(intX, intY)
    '        subDrawMapPixel(intX, intY, ftnGreyToColor(byteIntensity))
    '    Next intY
    'Next intX


    'Dim sngMapOccupiedPercentage As Single = byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y) / 256
    'Dim sngProbabilityOfDetectingMeasuredGivenMap As Single = 0.9 * sngMapOccupiedPercentage
    'byteSlamRawMapArray(tmcMapLocation.X, tmcMapLocation.Y) = ftnBayesProbabilityOfAGivenB(sngMapOccupiedPercentage, sngMeasuredOccupiedPercentage, sngProbabilityOfDetectingMeasuredGivenMap) * 255
    'Function ftnBayesProbabilityOfAGivenB(ByVal sngAprobability As Single, ByVal sngBprobability As Single, ByVal sngAprobabilityBGivenA As Single) As Single
    '   ftnBayesProbabilityOfAGivenB = sngAprobabilityBGivenA * sngAprobability / sngBprobability
    'End Function




End Module
