﻿
Imports System
Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO
Imports System.Net


Public Module modSettings

    ' This module is responsible for saveing and loading the User Settings file

    Public Sub SaveSettings(ByVal strFileName As String)
        Dim GotABot_Settings As New BotSettings With { _
        .xml_tmcDock = tmcDock, _
        .xml_boolDockBackIn = boolDockBackIn, _
        .xml_intDockOrientation = intDockOrientation, _
        .xml_intDockTriggerPC = intDockTriggerPC, _
        .xml_sngDockTriggerBot = sngDockTriggerBot, _
        .xml_boolRemoteKinect = boolRemoteKinect, _
        .xml_sngKinectCalibrate = sngKinectCalibrate, _
        .xml_sngKinectCurveAdjust = sngKinectCurveAdjust, _
        .xml_ipKinectAddress = Convert.ToString(ipKinectAddress), _
        .xml_tmcScanVectorOffset = tmcScanVectorOffset, _
        .xml_intNumberOfScanVectors = intNumberOfScanVectors, _
        .xml_intDefaultElevation = intDefaultElevation, _
        .xml_Robot_IPAddress = Convert.ToString(ipRobot_IPAddress), _
        .xml_Robot_Port = intRobot_Port, _
        .xml_sngLocalizationTime = sngLocalizationTime, _
        .xml_intCompassOrientationOffset = intCompassOrientationOffset, _
        .xml_sngAngularVelocityCorrectionFactor = sngAngularVelocityCorrectionFactor, _
        .xml_sngBotLinearAcceleration = sngBotLinearAcceleration, _
        .xml_sngBotLinearVelocity = sngBotLinearVelocity, _
        .xml_sngBotAngularVelocity = sngBotAngularVelocity, _
        .xml_sngBotAngularAcceleration = sngBotAngularAcceleration, _
        .xml_sngUnusedSavedVariable = sngUnusedSavedVariable, _
        .xml_strNewsURL = strNewsURL, _
        .xml_strWeatherURL = strWeatherURL, _
        .xml_strPassword = strPassword, _
        .xml_sngBotDiameter = sngBotDiameter, _
        .xml_sngCameraOffset = sngCameraOffset, _
        .xml_sngCameraFOV = sngCameraFOV, _
        .xml_ticCameraResolution = ticCameraResolution, _
        .xml_sngBotMovementAccuracy = sngBotMovementAccuracy, _
        .xml_sngMaxTravel = sngMaxTravel, _
        .xml_sngZoom = sngZoom, _
        .xml_sngVideoDelay = sngStartOfMoveDelay, _
        .xml_sngGridSize = sngGridSize, _
        .xml_strUnits = GotABotClass.mnuMapUnits.Text, _
        .xml_tbpBotPose = tbpBotPose, _
        .xml_trfRangeFinders = trfRangeFinders, _
        .xml_intRangeCorrectionFactor = intRangeCorrectionFactor, _
        .xml_LandMark = tlmLandMarkArray, _
        .xml_RangeLandMark = tlm2DScanLandMarkArray, _
        .xml_boolShowMore = boolShowMore, _
        .xml_boolPCVoice = boolPCVoice, _
        .xml_boolVoiceCommandEnable = boolVoiceCommandEnable, _
        .xml_boolVerboseLogFile = boolVerboseLogFile, _
        .xml_boolEnableYRotation = boolEnableYRotation, _
        .xml_boolSimulatedMovement = boolSimulatedMovement, _
        .xml_mnuEnableLocalRCC = GotABotClass.mnuEnableLocalRCC.Checked, _
        .xml_mnuEnableGotAGlyph = GotABotClass.mnuEnableGotAGlyph.Checked, _
        .xml_mnuEnableAVM = GotABotClass.mnuEnableAVM.Checked, _
        .xml_mnuEnableLocalRR = GotABotClass.mnuEnableLocalRR.Checked, _
        .xml_mnuEnableBotRCC = GotABotClass.mnuEnableBotRCC.Checked, _
        .xml_boolViewLM = boolViewLM, _
        .xml_boolViewDebug = boolViewDebug, _
        .xml_boolEnableLocalizationWhileMoving = boolEnableLocalizationWhileMoving, _
        .xml_boolEnableMidCourseCorrection = boolEnableMidCourseCorrection, _
        .xml_boolEnableXY_Motion = boolEnableXY_Motion, _
        .xml_boolMute = boolMute, _
        .xml_boolLogFileEnable = boolLogFileEnable, _
        .xml_boolER1Selected = boolER1Selected, _
        .xml_boolEnableBumperSwitches_ER1 = boolEnableBumperSwitches_ER1, _
        .xml_boolEnableEvolutionIR_ER1 = boolEnableEvolutionIR_ER1, _
        .xml_intEvolution_IR_Threshold = intEvolution_IR_Threshold, _
        .xml_boolEnableRangerAveraging = boolEnableRangerAveraging, _
        .xml_boolRoboRealmBotSelected = boolRoboRealmBotSelected, _
        .xml_boolAllowRoboRealmToControlBot = boolAllowRoboRealmToControlBot}
        GotABot_Settings.SaveSettingsXml(strFileName)
        GotABotClass.subRedraw(tbpBotPose)
    End Sub



    Public Sub LoadSettings(ByVal strFileName As String)
        On Error Resume Next
        Dim GotABot_Settings As BotSettings = BotSettings.LoadSettingsXml(strFileName)
        tmcDock = GotABot_Settings.xml_tmcDock
        frmDock.UpDnLocX.Value = tmcDock.X
        frmDock.UpDnLocY.Value = tmcDock.Y
        intDockOrientation = GotABot_Settings.xml_intDockOrientation
        frmDock.updnOrientation.Value = intDockOrientation
        intDockTriggerPC = GotABot_Settings.xml_intDockTriggerPC
        frmDock.UpDownPCTrigger.Value = intDockTriggerPC
        sngDockTriggerBot = GotABot_Settings.xml_sngDockTriggerBot
        frmDock.txtBotBatteryTrigger.Text = sngDockTriggerBot.ToString
        boolDockBackIn = GotABot_Settings.xml_boolDockBackIn
        frmDock.chkBackIn.Checked = boolDockBackIn
        boolRemoteKinect = GotABot_Settings.xml_boolRemoteKinect
        sngKinectCalibrate = GotABot_Settings.xml_sngKinectCalibrate
        sngKinectCurveAdjust = GotABot_Settings.xml_sngKinectCurveAdjust
        ipKinectAddress = IPAddress.Parse(GotABot_Settings.xml_ipKinectAddress.Trim)
        intNumberOfScanVectors = GotABot_Settings.xml_intNumberOfScanVectors
        intDefaultElevation = GotABot_Settings.xml_intDefaultElevation
        tmcScanVectorOffset = GotABot_Settings.xml_tmcScanVectorOffset
        ipRobot_IPAddress = IPAddress.Parse(GotABot_Settings.xml_Robot_IPAddress.Trim)
        intRobot_Port = GotABot_Settings.xml_Robot_Port
        sngLocalizationTime = GotABot_Settings.xml_sngLocalizationTime
        intCompassOrientationOffset = GotABot_Settings.xml_intCompassOrientationOffset
        sngAngularVelocityCorrectionFactor = GotABot_Settings.xml_sngAngularVelocityCorrectionFactor
        sngBotLinearAcceleration = GotABot_Settings.xml_sngBotLinearAcceleration
        If (sngBotLinearAcceleration <= 0) Then sngBotLinearAcceleration = 1
        sngBotLinearVelocity = GotABot_Settings.xml_sngBotLinearVelocity
        sngBotAngularVelocity = GotABot_Settings.xml_sngBotAngularVelocity
        sngBotAngularAcceleration = GotABot_Settings.xml_sngBotAngularAcceleration
        If (sngBotAngularAcceleration <= 0) Then sngBotAngularAcceleration = 1
        If boolBotConnected Then
            ftnSendCommand("set linear velocity " & Int(sngBotLinearVelocity).ToString)
            ftnSendCommand("set angular velocity  " & Int(sngBotAngularVelocity).ToString)
        End If
        sngUnusedSavedVariable = GotABot_Settings.xml_sngUnusedSavedVariable
        If (GotABot_Settings.xml_strNewsURL <> "") Then strNewsURL = GotABot_Settings.xml_strNewsURL
        If (GotABot_Settings.xml_strWeatherURL <> "") Then strWeatherURL = GotABot_Settings.xml_strWeatherURL
        strPassword = GotABot_Settings.xml_strPassword
        sngBotDiameter = GotABot_Settings.xml_sngBotDiameter
        sngBotRadius = sngBotDiameter / 2
        sngCameraFOV = GotABot_Settings.xml_sngCameraFOV
        ticCameraResolution = GotABot_Settings.xml_ticCameraResolution
        sngBotMovementAccuracy = GotABot_Settings.xml_sngBotMovementAccuracy
        sngCameraOffset = GotABot_Settings.xml_sngCameraOffset
        sngMaxTravel = GotABot_Settings.xml_sngMaxTravel
        sngZoom = GotABot_Settings.xml_sngZoom
        sngStartOfMoveDelay = GotABot_Settings.xml_sngVideoDelay
        sngGridSize = GotABot_Settings.xml_sngGridSize
        If (sngGridSize <= 0) Then sngGridSize = 1
        GotABotClass.mnuMapUnits.Text = GotABot_Settings.xml_strUnits
        strUnits = GotABot_Settings.xml_strUnits
        byteNoGoNearWallSpaceThreshold = (constMaxBufferSpaceCost - ftnMapUnitsToInches(sngBotRadius) - 0.5)
        tbpBotPose = GotABot_Settings.xml_tbpBotPose
        For i = 1 To 14
            trfRangeFinders(i) = GotABot_Settings.xml_trfRangeFinders(i)
        Next
        For i = 0 To UBound(intRangeCorrectionFactor)
            intRangeCorrectionFactor(i) = GotABot_Settings.xml_intRangeCorrectionFactor(i)
        Next
        tlmLandMarkArray = GotABot_Settings.xml_LandMark
        tlm2DScanLandMarkArray = GotABot_Settings.xml_RangeLandMark
        boolPCVoice = GotABot_Settings.xml_boolPCVoice
        GotABotClass.mnuPCVoice.Checked = boolPCVoice
        boolVoiceCommandEnable = GotABot_Settings.xml_boolVoiceCommandEnable
        GotABotClass.mnuVoiceCommandEnable.Checked = boolVoiceCommandEnable
        boolShowMore = GotABot_Settings.xml_boolShowMore
        GotABotClass.mnuShowDebugGraphics.Checked = boolShowMore
        boolVerboseLogFile = GotABot_Settings.xml_boolVerboseLogFile
        GotABotClass.mnuVerboseLogFile.Checked = boolVerboseLogFile
        If boolVerboseLogFile Then
            boolDebugDrive = boolVerboseLogFile
            boolDebugLWM = boolVerboseLogFile
            boolDebugObstacle = boolVerboseLogFile
            boolDebugER1IF = boolVerboseLogFile
            boolDebugAPI_IF = boolVerboseLogFile
            boolDebugOdometry = boolVerboseLogFile
            boolDebugLocalize2D = boolVerboseLogFile
            boolDebugKinect = boolVerboseLogFile
            boolDebugDock = boolVerboseLogFile
            boolDebugCompass = boolVerboseLogFile
            boolDebugPath = boolVerboseLogFile
        End If
        boolEnableYRotation = GotABot_Settings.xml_boolEnableYRotation
        GotABotClass.mnuEnableYRotation.Checked = boolEnableYRotation
        boolSimulatedMovement = GotABot_Settings.xml_boolSimulatedMovement
        GotABotClass.mnuSimulatedMovement.Checked = boolSimulatedMovement
        GotABotClass.mnuEnableLocalRCC.Checked = GotABot_Settings.xml_mnuEnableLocalRCC
        boolEnableLocalRCC = GotABotClass.mnuEnableLocalRCC.Checked
        GotABotClass.mnuEnableGotAGlyph.Checked = GotABot_Settings.xml_mnuEnableGotAGlyph
        GotABotClass.mnuEnableAVM.Checked = GotABot_Settings.xml_mnuEnableAVM
        boolEnableGotAGlyph = GotABotClass.mnuEnableGotAGlyph.Checked
        boolEnableAVM = GotABotClass.mnuEnableAVM.Checked
        GotABotClass.mnuEnableLocalRR.Checked = GotABot_Settings.xml_mnuEnableLocalRR
        boolEnableLocalRR = GotABotClass.mnuEnableLocalRR.Checked
        GotABotClass.mnuEnableBotRCC.Checked = GotABot_Settings.xml_mnuEnableBotRCC
        boolEnableBotRCC = GotABotClass.mnuEnableBotRCC.Checked
        boolViewLM = GotABot_Settings.xml_boolViewLM
        boolViewDebug = GotABot_Settings.xml_boolViewDebug
        'frmDebug.Visible = boolViewDebug
        boolEnableLocalizationWhileMoving = GotABot_Settings.xml_boolEnableLocalizationWhileMoving
        GotABotClass.mnuEnableLocalizationWhileMoving.Checked = boolEnableLocalizationWhileMoving
        boolEnableMidCourseCorrection = GotABot_Settings.xml_boolEnableMidCourseCorrection
        GotABotClass.mnuMidCourseCorrection.Checked = boolEnableMidCourseCorrection
        boolEnableXY_Motion = GotABot_Settings.xml_boolEnableXY_Motion
        GotABotClass.mnuXYMotion.Checked = boolEnableXY_Motion
        boolMute = GotABot_Settings.xml_boolMute
        GotABotClass.mnuMute.Checked = boolMute
        boolLogFileEnable = GotABot_Settings.xml_boolLogFileEnable
        GotABotClass.mnuLogFileEnable.Checked = boolLogFileEnable
        boolER1Selected = GotABot_Settings.xml_boolER1Selected
        GotABotClass.mnuER1Selected.Checked = boolER1Selected
        boolEnableBumperSwitches_ER1 = GotABot_Settings.xml_boolEnableBumperSwitches_ER1
        GotABotClass.mnuEnableBumperSwitches.Checked = boolEnableBumperSwitches_ER1
        boolEnableEvolutionIR_ER1 = GotABot_Settings.xml_boolEnableEvolutionIR_ER1
        GotABotClass.mnuEnableEvolutionIRs.Checked = boolEnableEvolutionIR_ER1
        intEvolution_IR_Threshold = GotABot_Settings.xml_intEvolution_IR_Threshold
        boolEnableRangerAveraging = GotABot_Settings.xml_boolEnableRangerAveraging
        GotABotClass.mnuEnableRangerAveraging.Checked = boolEnableRangerAveraging
        boolRoboRealmBotSelected = GotABot_Settings.xml_boolRoboRealmBotSelected
        GotABotClass.mnuRoboRealmBotSelected.Checked = boolRoboRealmBotSelected
        boolAllowRoboRealmToControlBot = GotABot_Settings.xml_boolAllowRoboRealmToControlBot
        GotABotClass.mnuAllowRoboRealmToControlBot.Checked = boolAllowRoboRealmToControlBot
    End Sub



    Public Class BotSettings
        Private _xml_tmcDock As typeMapCoordinate
        Private _xml_intDockOrientation As Integer
        Private _xml_intDockTriggerPC As Integer
        Private _xml_boolDockBackIn As Boolean
        Private _xml_sngDockTriggerBot As Single
        Private _xml_boolRemoteKinect As Boolean
        Private _xml_sngKinectCalibrate As Single
        Private _xml_sngKinectCurveAdjust As Single
        Private _xml_ipKinectAddress As String
        Private _xml_tmcScanVectorOffset As typeMapCoordinate
        Private _xml_intNumberOfScanVectors As Integer
        Private _xml_intDefaultElevation As Integer
        Private _xml_Robot_IPAddress As String
        Private _xml_Robot_Port As Integer
        Private _xml_sngBotLinearAcceleration As Single
        Private _xml_sngBotLinearVelocity As Single
        Private _xml_sngBotAngularVelocity As Single
        Private _xml_sngBotAngularAcceleration As Single
        Private _xml_sngUnusedSavedVariable As Single
        Private _xml_sngLocalizationTime As Single
        Private _xml_intCompassOrientationOffset As Integer
        Private _xml_sngAngularVelocityCorrectionFactor As Single
        Private _xml_strNewsURL As String
        Private _xml_strWeatherURL As String
        Private _xml_strPassword As String
        Private _xml_sngBotDiameter As Single
        Private _xml_sngCameraFOV As Single
        Private _xml_ticCameraResolution As typeImageCoordinate
        Private _xml_sngBotMovementAccuracy As Single
        Private _xml_sngCameraOffset As Single
        Private _xml_sngMaxTravel As Single
        Private _xml_sngZoom As Single
        Private _xml_sngVideoDelay As Single
        Private _xml_sngGridSize As Single
        Private _xml_strUnits As String
        Private _xml_tbpBotPose As typeBotPose
        Private _xml_trfRangeFinders(14) As typeRangeFinder
        Private _xml_intRangeCorrectionFactor(UBound(intRangeCorrectionFactor)) As Integer
        Private _xml_LandMark(128) As typeLandMark
        Private _xml_RangeLandMark(128) As typeLandMark
        Private _xml_boolPCVoice As Boolean
        Private _xml_boolVoiceCommandEnable As Boolean
        Private _xml_boolShowMore As Boolean
        Private _xml_boolVerboseLogFile As Boolean
        Private _xml_boolEnableYRotation As Boolean
        Private _xml_boolSimulatedMovement As Boolean
        Private _xml_mnuEnableLocalRCC As Boolean
        Private _xml_mnuEnableGotAGlyph As Boolean
        Private _xml_mnuEnableAVM As Boolean
        Private _xml_mnuEnableLocalRR As Boolean
        Private _xml_mnuEnableBotRCC As Boolean
        Private _xml_boolViewLM As Boolean
        Private _xml_boolViewDebug As Boolean
        Private _xml_boolEnableLocalizationWhileMoving As Boolean
        Private _xml_boolEnableMidCourseCorrection As Boolean
        Private _xml_boolEnableXY_Motion As Boolean
        Private _xml_boolMute As Boolean
        Private _xml_boolLogFileEnable As Boolean
        Private _xml_boolER1Selected As Boolean
        Private _xml_boolEnableBumperSwitches_ER1 As Boolean
        Private _xml_boolEnableEvolutionIR_ER1 As Boolean
        Private _xml_intEvolution_IR_Threshold As Integer
        Private _xml_boolEnableRangerAveraging As Boolean
        Private _xml_boolRoboRealmBotSelected As Boolean
        Private _xml_boolAllowRoboRealmToControlBot As Boolean

        Public Property xml_tmcDock() As typeMapCoordinate
            Get
                Return _xml_tmcDock
            End Get
            Set(ByVal value As typeMapCoordinate)
                _xml_tmcDock = value
            End Set
        End Property

        Public Property xml_intDockOrientation() As Integer
            Get
                Return _xml_intDockOrientation
            End Get
            Set(ByVal value As Integer)
                _xml_intDockOrientation = value
            End Set
        End Property

        Public Property xml_intDockTriggerPC() As Integer
            Get
                Return _xml_intDockTriggerPC
            End Get
            Set(ByVal value As Integer)
                _xml_intDockTriggerPC = value
            End Set
        End Property

        Public Property xml_sngDockTriggerBot() As Single
            Get
                Return _xml_sngDockTriggerBot
            End Get
            Set(ByVal value As Single)
                _xml_sngDockTriggerBot = value
            End Set
        End Property

        Public Property xml_boolDockBackIn() As Boolean
            Get
                Return _xml_boolDockBackIn
            End Get
            Set(ByVal value As Boolean)
                _xml_boolDockBackIn = value
            End Set
        End Property

        Public Property xml_boolRemoteKinect() As Boolean
            Get
                Return _xml_boolRemoteKinect
            End Get
            Set(ByVal value As Boolean)
                _xml_boolRemoteKinect = value
            End Set
        End Property

        Public Property xml_sngKinectCalibrate() As Single
            Get
                Return _xml_sngKinectCalibrate
            End Get
            Set(ByVal value As Single)
                _xml_sngKinectCalibrate = value
            End Set
        End Property

        Public Property xml_sngKinectCurveAdjust() As Single
            Get
                Return _xml_sngKinectCurveAdjust
            End Get
            Set(ByVal value As Single)
                _xml_sngKinectCurveAdjust = value
            End Set
        End Property

        Public Property xml_ipKinectAddress() As String
            Get
                Return _xml_ipKinectAddress
            End Get
            Set(ByVal value As String)
                _xml_ipKinectAddress = value
            End Set
        End Property

        Public Property xml_tmcScanVectorOffset() As typeMapCoordinate
            Get
                Return _xml_tmcScanVectorOffset
            End Get
            Set(ByVal value As typeMapCoordinate)
                _xml_tmcScanVectorOffset = value
            End Set
        End Property

        Public Property xml_intNumberOfScanVectors() As Integer
            Get
                Return _xml_intNumberOfScanVectors
            End Get
            Set(ByVal value As Integer)
                _xml_intNumberOfScanVectors = value
            End Set
        End Property

        Public Property xml_intDefaultElevation() As Integer
            Get
                Return _xml_intDefaultElevation
            End Get
            Set(ByVal value As Integer)
                _xml_intDefaultElevation = value
            End Set
        End Property

        Public Property xml_sngLocalizationTime() As Single
            Get
                Return _xml_sngLocalizationTime
            End Get
            Set(ByVal value As Single)
                _xml_sngLocalizationTime = value
            End Set
        End Property

        Public Property xml_intCompassOrientationOffset() As Integer
            Get
                Return _xml_intCompassOrientationOffset
            End Get
            Set(ByVal value As Integer)
                _xml_intCompassOrientationOffset = value
            End Set
        End Property

        Public Property xml_sngAngularVelocityCorrectionFactor() As Single
            Get
                Return _xml_sngAngularVelocityCorrectionFactor
            End Get
            Set(ByVal value As Single)
                _xml_sngAngularVelocityCorrectionFactor = value
            End Set
        End Property

        Public Property xml_sngBotLinearAcceleration() As Single
            Get
                Return _xml_sngBotLinearAcceleration
            End Get
            Set(ByVal value As Single)
                _xml_sngBotLinearAcceleration = value
            End Set
        End Property

        Public Property xml_sngBotLinearVelocity() As Single
            Get
                Return _xml_sngBotLinearVelocity
            End Get
            Set(ByVal value As Single)
                _xml_sngBotLinearVelocity = value
            End Set
        End Property

        Public Property xml_sngBotAngularVelocity() As Single
            Get
                Return _xml_sngBotAngularVelocity
            End Get
            Set(ByVal value As Single)
                _xml_sngBotAngularVelocity = value
            End Set
        End Property

        Public Property xml_sngBotAngularAcceleration() As Single
            Get
                Return _xml_sngBotAngularAcceleration
            End Get
            Set(ByVal value As Single)
                _xml_sngBotAngularAcceleration = value
            End Set
        End Property

        Public Property xml_sngUnusedSavedVariable() As Single
            Get
                Return _xml_sngUnusedSavedVariable
            End Get
            Set(ByVal value As Single)
                _xml_sngUnusedSavedVariable = value
            End Set
        End Property

        Public Property xml_sngCameraFOV() As Single
            Get
                Return _xml_sngCameraFOV
            End Get
            Set(ByVal value As Single)
                _xml_sngCameraFOV = value
            End Set
        End Property

        Public Property xml_ticCameraResolution() As typeImageCoordinate
            Get
                Return _xml_ticCameraResolution
            End Get
            Set(ByVal value As typeImageCoordinate)
                _xml_ticCameraResolution = value
            End Set
        End Property

        Public Property xml_sngBotMovementAccuracy() As Single
            Get
                Return _xml_sngBotMovementAccuracy
            End Get
            Set(ByVal value As Single)
                _xml_sngBotMovementAccuracy = value
            End Set
        End Property

        Public Property xml_sngCameraOffset() As Single
            Get
                Return _xml_sngCameraOffset
            End Get
            Set(ByVal value As Single)
                _xml_sngCameraOffset = value
            End Set
        End Property

        Public Property xml_sngZoom() As Single
            Get
                Return _xml_sngZoom
            End Get
            Set(ByVal value As Single)
                _xml_sngZoom = value
            End Set
        End Property

        Public Property xml_sngVideoDelay() As Single
            Get
                Return _xml_sngVideoDelay
            End Get
            Set(ByVal value As Single)
                _xml_sngVideoDelay = value
            End Set
        End Property

        Public Property xml_strNewsURL() As String
            Get
                Return _xml_strNewsURL
            End Get
            Set(ByVal value As String)
                _xml_strNewsURL = value
            End Set
        End Property

        Public Property xml_strWeatherURL() As String
            Get
                Return _xml_strWeatherURL
            End Get
            Set(ByVal value As String)
                _xml_strWeatherURL = value
            End Set
        End Property

        Public Property xml_strPassword() As String
            Get
                Return _xml_strPassword
            End Get
            Set(ByVal value As String)
                _xml_strPassword = value
            End Set
        End Property

        Public Property xml_strUnits() As String
            Get
                Return _xml_strUnits
            End Get
            Set(ByVal value As String)
                _xml_strUnits = value
            End Set
        End Property

        Public Property xml_sngMaxTravel() As Single
            Get
                Return _xml_sngMaxTravel
            End Get
            Set(ByVal value As Single)
                _xml_sngMaxTravel = value
            End Set
        End Property

        Public Property xml_tbpBotPose() As typeBotPose
            Get
                Return _xml_tbpBotPose
            End Get
            Set(ByVal value As typeBotPose)
                _xml_tbpBotPose = value
            End Set
        End Property

        Public Property xml_trfRangeFinders() As typeRangeFinder()
            Get
                Return _xml_trfRangeFinders
            End Get
            Set(ByVal value As typeRangeFinder())
                For i = 1 To 14
                    _xml_trfRangeFinders(i) = value(i)
                Next i
            End Set
        End Property

        Public Property xml_intRangeCorrectionFactor() As Integer()

            Get
                Return _xml_intRangeCorrectionFactor
            End Get
            Set(ByVal value As Integer())
                'For i = 0 To UBound(intRangeCorrectionFactor)
                For i = 0 To UBound(value)
                    _xml_intRangeCorrectionFactor(i) = value(i)
                Next i
            End Set
        End Property

        Public Property xml_Robot_IPAddress() As String
            Get
                Return _xml_Robot_IPAddress
            End Get
            Set(ByVal value As String)
                _xml_Robot_IPAddress = value
            End Set
        End Property

        Public Property xml_Robot_Port() As Integer
            Get
                Return _xml_Robot_Port
            End Get
            Set(ByVal value As Integer)
                _xml_Robot_Port = value
            End Set
        End Property
        Public Property xml_sngBotDiameter() As Single
            Get
                Return _xml_sngBotDiameter
            End Get
            Set(ByVal value As Single)
                _xml_sngBotDiameter = value
            End Set
        End Property
        Public Property xml_sngGridSize() As Single
            Get
                Return _xml_sngGridSize
            End Get
            Set(ByVal value As Single)
                _xml_sngGridSize = value
            End Set
        End Property

        Public Property xml_LandMark() As typeLandMark()
            Get
                Return _xml_LandMark
            End Get
            Set(ByVal value As typeLandMark())
                For i = 0 To UBound(tlmLandMarkArray)
                    _xml_LandMark(i) = value(i)
                Next i
            End Set
        End Property

        Public Property xml_RangeLandMark() As typeLandMark()
            Get
                Return _xml_RangeLandMark
            End Get
            Set(ByVal value As typeLandMark())
                For i = 0 To UBound(tlm2DScanLandMarkArray)
                    _xml_RangeLandMark(i) = value(i)
                Next i
            End Set
        End Property

        Public Property xml_boolPCVoice() As Boolean
            Get
                Return _xml_boolPCVoice
            End Get
            Set(ByVal value As Boolean)
                _xml_boolPCVoice = value
            End Set
        End Property

        Public Property xml_boolVoiceCommandEnable() As Boolean
            Get
                Return _xml_boolVoiceCommandEnable
            End Get
            Set(ByVal value As Boolean)
                _xml_boolVoiceCommandEnable = value
            End Set
        End Property

        Public Property xml_boolShowMore() As Boolean
            Get
                Return _xml_boolShowMore
            End Get
            Set(ByVal value As Boolean)
                _xml_boolShowMore = value
            End Set
        End Property

        Public Property xml_boolVerboseLogFile() As Boolean
            Get
                Return _xml_boolVerboseLogFile
            End Get
            Set(ByVal value As Boolean)
                _xml_boolVerboseLogFile = value
            End Set
        End Property

        Public Property xml_boolEnableYRotation() As Boolean
            Get
                Return _xml_boolEnableYRotation
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableYRotation = value
            End Set
        End Property

        Public Property xml_boolSimulatedMovement() As Boolean
            Get
                Return _xml_boolSimulatedMovement
            End Get
            Set(ByVal value As Boolean)
                _xml_boolSimulatedMovement = value
            End Set
        End Property

        Public Property xml_mnuEnableLocalRCC() As Boolean
            Get
                Return _xml_mnuEnableLocalRCC
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableLocalRCC = value
            End Set
        End Property

        Public Property xml_mnuEnableGotAGlyph() As Boolean
            Get
                Return _xml_mnuEnableGotAGlyph
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableGotAGlyph = value
            End Set
        End Property

        Public Property xml_mnuEnableAVM() As Boolean
            Get
                Return _xml_mnuEnableAVM
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableAVM = value
            End Set
        End Property

        Public Property xml_mnuEnableLocalRR() As Boolean
            Get
                Return _xml_mnuEnableLocalRR
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableLocalRR = value
            End Set
        End Property

        Public Property xml_mnuEnableBotRCC() As Boolean
            Get
                Return _xml_mnuEnableBotRCC
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableBotRCC = value
            End Set
        End Property

        Public Property xml_boolViewLM() As Boolean
            Get
                Return _xml_boolViewLM
            End Get
            Set(ByVal value As Boolean)
                _xml_boolViewLM = value
            End Set
        End Property

        Public Property xml_boolViewDebug() As Boolean
            Get
                Return _xml_boolViewDebug
            End Get
            Set(ByVal value As Boolean)
                _xml_boolViewDebug = value
            End Set
        End Property

        Public Property xml_boolEnableLocalizationWhileMoving() As Boolean
            Get
                Return _xml_boolEnableLocalizationWhileMoving
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableLocalizationWhileMoving = value
            End Set
        End Property

        Public Property xml_boolEnableMidCourseCorrection() As Boolean
            Get
                Return _xml_boolEnableMidCourseCorrection
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableMidCourseCorrection = value
            End Set
        End Property

        Public Property xml_boolEnableXY_Motion() As Boolean
            Get
                Return _xml_boolEnableXY_Motion
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableXY_Motion = value
            End Set
        End Property

        Public Property xml_boolMute() As Boolean
            Get
                Return _xml_boolMute
            End Get
            Set(ByVal value As Boolean)
                _xml_boolMute = value
            End Set
        End Property

        Public Property xml_boolLogFileEnable() As Boolean
            Get
                Return _xml_boolLogFileEnable
            End Get
            Set(ByVal value As Boolean)
                _xml_boolLogFileEnable = value
            End Set
        End Property

        Public Property xml_boolER1Selected() As Boolean
            Get
                Return _xml_boolER1Selected
            End Get
            Set(ByVal value As Boolean)
                _xml_boolER1Selected = value
            End Set
        End Property

        Public Property xml_boolEnableBumperSwitches_ER1() As Boolean
            Get
                Return _xml_boolEnableBumperSwitches_ER1
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableBumperSwitches_ER1 = value
            End Set
        End Property

        Public Property xml_boolEnableEvolutionIR_ER1() As Boolean
            Get
                Return _xml_boolEnableEvolutionIR_ER1
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableEvolutionIR_ER1 = value
            End Set
        End Property

        Public Property xml_intEvolution_IR_Threshold() As Integer
            Get
                Return _xml_intEvolution_IR_Threshold
            End Get
            Set(ByVal value As Integer)
                _xml_intEvolution_IR_Threshold = value
            End Set
        End Property

        Public Property xml_boolEnableRangerAveraging() As Boolean
            Get
                Return _xml_boolEnableRangerAveraging
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableRangerAveraging = value
            End Set
        End Property

        Public Property xml_boolRoboRealmBotSelected() As Boolean
            Get
                Return _xml_boolRoboRealmBotSelected
            End Get
            Set(ByVal value As Boolean)
                _xml_boolRoboRealmBotSelected = value
            End Set
        End Property


        Public Property xml_boolAllowRoboRealmToControlBot() As Boolean
            Get
                Return _xml_boolAllowRoboRealmToControlBot
            End Get
            Set(ByVal value As Boolean)
                _xml_boolAllowRoboRealmToControlBot = value
            End Set
        End Property


        ' Empty constructor required for serialization.
        Public Sub New()
        End Sub

        Public Sub New( _
            ByVal _xml_tmcDock As typeMapCoordinate, _
            ByVal _xml_intDockOrientation As Integer, _
            ByVal _xml_intDockTriggerPC As Integer, _
            ByVal _xml_boolDockBackIn As Boolean, _
            ByVal _xml_sngDockTriggerBot As Single, _
            ByVal _xml_boolRemoteKinect As Boolean, _
            ByVal _xml_sngKinectCalibrate As Single, _
            ByVal _xml_sngKinectCurveAdjust As Single, _
            ByVal _xml_ipKinectAddress As String, _
            ByVal _xml_Robot_IPAddress As String, _
            ByVal _xml_tmcScanVectorOffset As typeMapCoordinate, _
            ByVal _xml_intNumberOfScanVectors As Integer, _
            ByVal _xml_intDefaultElevation As Integer, _
            ByVal _xml_Robot_Port As Integer, _
            ByVal _xml_sngLocalizationTime As Single, _
            ByVal _xml_intCompassOrientationOffset As Integer, _
            ByVal _xml_sngAngularVelocityCorrectionFactor As Single, _
            ByVal _xml_sngBotLinearAcceleration As Single, _
            ByVal _xml_sngBotLinearVelocity As Single, _
            ByVal _xml_sngBotAngularVelocity As Single, _
            ByVal _xml_sngBotAngularAcceleration As Single, _
            ByVal _xml_sngUnusedSavedVariable As Single, _
            ByVal _xml_strNewsURL As String, _
            ByVal _xml_strWeatherURL As String, _
            ByVal _xml_strPassword As String, _
            ByVal _xml_sngBotDiameter As Single, _
            ByVal _xml_sngCameraFOV As Single, _
            ByVal _xml_ticCameraResolution As typeImageCoordinate, _
            ByVal _xml_sngBotMovementAccuracy As Single, _
            ByVal _xml_sngCameraOffset As Single, _
            ByVal _xml_sngMaxTravel As Single, _
            ByVal _xml_sngGridSize As Single, _
            ByVal _xml_sngZoom As Single, _
            ByVal _xml_sngVideoDelay As Single, _
            ByVal _xml_strUnits As String, _
            ByVal _xml_tbpBotPose As typeBotPose, _
            ByVal _xml_intRangeCorrectionFactor() As Integer, _
            ByVal _xml_LandMark() As typeLandMark, _
            ByVal _xml_RangeLandMark() As typeLandMark, _
            ByVal _xml_boolPCVoice As Boolean, _
            ByVal _xml_boolVoiceCommandEnable As Boolean, _
            ByVal _xml_boolShowMore As Boolean, _
            ByVal _xml_boolVerboseLogFile As Boolean, _
            ByVal _xml_boolEnableYRotation As Boolean, _
            ByVal _xml_boolSimulatedMovement As Boolean, _
            ByVal _xml_mnuEnableLocalRCC As Boolean, _
            ByVal _xml_mnuEnableGotAGlyph As Boolean, _
            ByVal _xml_mnuAVM As Boolean, _
            ByVal _xml_mnuEnableLocalRR As Boolean, _
            ByVal _xml_mnuEnableBotRCC As Boolean, _
            ByVal _xml_boolViewLM As Boolean, _
            ByVal _xml_boolViewDebug As Boolean, _
            ByVal _xml_boolEnableLocalizationWhileMoving As Boolean, _
            ByVal _xml_boolEnableMidCourseCorrection As Boolean, _
            ByVal _xml_boolEnableXY_Motion As Boolean, _
            ByVal _xml_boolMute As Boolean, _
            ByVal _xml_boolLogFileEnable As Boolean, _
            ByVal _xml_boolER1Selected As Boolean, _
            ByVal _xml_boolEnableBumperSwitches_ER1 As Boolean, _
            ByVal _xml_boolEnableEvolutionIR_ER1 As Boolean, _
            ByVal _xml_intEvolution_IR_Threshold As Integer, _
            ByVal _xml_boolEnableRangerAveraging As Boolean, _
            ByVal _xml_boolRoboRealmBotSelected As Boolean, _
            ByVal _xml_boolAllowRoboRealmToControlBot As Boolean _
                )
            On Error Resume Next
            tmcDock = xml_tmcDock
            intDockOrientation = xml_intDockOrientation
            intDockTriggerPC = xml_intDockTriggerPC
            boolDockBackIn = xml_boolDockBackIn
            sngDockTriggerBot = xml_sngDockTriggerBot
            boolRemoteKinect = xml_boolRemoteKinect
            sngKinectCalibrate = xml_sngKinectCalibrate
            sngKinectCurveAdjust = xml_sngKinectCurveAdjust
            ipKinectAddress = IPAddress.Parse(xml_ipKinectAddress.Trim)
            tmcScanVectorOffset = xml_tmcScanVectorOffset
            intNumberOfScanVectors = xml_intNumberOfScanVectors
            intDefaultElevation = xml_intDefaultElevation
            ipRobot_IPAddress = IPAddress.Parse(xml_Robot_IPAddress.Trim)
            intRobot_Port = xml_Robot_Port
            sngBotLinearAcceleration = xml_sngBotLinearAcceleration
            sngBotLinearVelocity = xml_sngBotLinearVelocity
            sngBotAngularVelocity = xml_sngBotAngularVelocity
            sngBotAngularAcceleration = xml_sngBotAngularAcceleration
            sngUnusedSavedVariable = xml_sngUnusedSavedVariable
            sngLocalizationTime = xml_sngLocalizationTime
            intCompassOrientationOffset = xml_intCompassOrientationOffset
            sngAngularVelocityCorrectionFactor = xml_sngAngularVelocityCorrectionFactor
            If (xml_strNewsURL <> "") Then strNewsURL = xml_strNewsURL
            If (xml_strWeatherURL <> "") Then strWeatherURL = xml_strWeatherURL
            strPassword = xml_strPassword
            sngBotDiameter = xml_sngBotDiameter
            sngCameraFOV = xml_sngCameraFOV
            ticCameraResolution = xml_ticCameraResolution
            sngBotMovementAccuracy = xml_sngBotMovementAccuracy
            sngCameraOffset = xml_sngCameraOffset
            sngMaxTravel = xml_sngMaxTravel
            sngZoom = xml_sngZoom
            sngStartOfMoveDelay = xml_sngVideoDelay
            sngGridSize = xml_sngGridSize
            GotABotClass.mnuMapUnits.Text = xml_strUnits
            tbpBotPose.Location = xml_tbpBotPose.Location
            tbpBotPose.LocationUncertainty = xml_tbpBotPose.LocationUncertainty
            tbpBotPose.Orientation = xml_tbpBotPose.Orientation
            tbpBotPose.OrientationUncertainty = xml_tbpBotPose.OrientationUncertainty
            For i = 1 To 14
                trfRangeFinders(i) = xml_trfRangeFinders(i)
            Next i
            For i = 0 To UBound(intRangeCorrectionFactor)
                intRangeCorrectionFactor(i) = xml_intRangeCorrectionFactor(i)
            Next i
            For i = 0 To UBound(tlmLandMarkArray)
                tlmLandMarkArray(i) = xml_LandMark(i)
            Next i
            For i = 0 To UBound(tlm2DScanLandMarkArray)
                tlm2DScanLandMarkArray(i) = xml_RangeLandMark(i)
            Next i
            boolPCVoice = xml_boolPCVoice
            boolVoiceCommandEnable = xml_boolVoiceCommandEnable
            boolShowMore = xml_boolShowMore
            boolVerboseLogFile = xml_boolVerboseLogFile
            boolEnableYRotation = xml_boolEnableYRotation
            boolSimulatedMovement = xml_boolSimulatedMovement
            GotABotClass.mnuEnableLocalRCC.Checked = xml_mnuEnableLocalRCC
            boolEnableLocalRCC = xml_mnuEnableLocalRCC
            GotABotClass.mnuEnableGotAGlyph.Checked = xml_mnuEnableGotAGlyph
            boolEnableGotAGlyph = xml_mnuEnableGotAGlyph
            boolEnableAVM = xml_mnuEnableAVM
            GotABotClass.mnuEnableLocalRR.Checked = xml_mnuEnableLocalRR
            boolEnableLocalRR = xml_mnuEnableLocalRR
            GotABotClass.mnuEnableBotRCC.Checked = xml_mnuEnableBotRCC
            boolEnableBotRCC = xml_mnuEnableBotRCC
            boolViewLM = xml_boolViewLM
            boolViewDebug = xml_boolViewDebug
            boolEnableLocalizationWhileMoving = xml_boolEnableLocalizationWhileMoving
            boolEnableMidCourseCorrection = xml_boolEnableMidCourseCorrection
            boolEnableXY_Motion = xml_boolEnableXY_Motion
            boolMute = xml_boolMute
            boolLogFileEnable = xml_boolLogFileEnable
            GotABotClass.mnuLogFileEnable.Checked = boolLogFileEnable
            GotABotClass.mnuMute.Checked = boolMute
            boolER1Selected = xml_boolER1Selected
            boolEnableBumperSwitches_ER1 = xml_boolEnableBumperSwitches_ER1
            boolEnableEvolutionIR_ER1 = xml_boolEnableEvolutionIR_ER1
            intEvolution_IR_Threshold = xml_intEvolution_IR_Threshold
            boolEnableRangerAveraging = xml_boolEnableRangerAveraging
            boolRoboRealmBotSelected = xml_boolRoboRealmBotSelected
            boolAllowRoboRealmToControlBot = xml_boolAllowRoboRealmToControlBot
        End Sub



        Public Sub SaveSettingsXml(ByVal path As String)
            On Error Resume Next
            Dim xserializer As New XmlSerializer(Me.GetType)
            Using file As New FileStream(path, FileMode.Create)
                xserializer.Serialize(file, Me)
            End Using
        End Sub

        Public Shared Function LoadSettingsXml(ByVal path As String) As BotSettings
            On Error Resume Next
            Dim deserializer As New XmlSerializer(GetType(BotSettings))
            Using file As New FileStream(path, FileMode.Open)
                Return DirectCast(deserializer.Deserialize(file), BotSettings)
            End Using
        End Function



    End Class




End Module




