﻿Imports System.Math
Imports System.Threading


Public Module modSpeechResponse


    Public Sub subSpeechInitialize()
        On Error Resume Next
        subStartSpeechRecognition()

    End Sub

    Private Declare Function ShellExecute _
                            Lib "shell32.dll" _
                            Alias "ShellExecuteA" ( _
                            ByVal hwnd As Long, _
                            ByVal lpOperation As String, _
                            ByVal lpFile As String, _
                            ByVal lpParameters As String, _
                            ByVal lpDirectory As String, _
                            ByVal nShowCmd As Long) _
                            As Long


    Public Sub subVoiceParse(ByRef strVoiceCommand As String) 'must be thread safe
        On Error Resume Next
        strStatusDriving = strVoiceCommand
        Dim strParsedMessage As String() = strVoiceCommand.Split(vbCr)
        strParsedMessage = strParsedMessage(0).Split(" "c)
        If CBool(InStr(strVoiceCommand, "command")) And Not GotABotClass.InvokeRequired Then
            If CBool(InStr(strVoiceCommand, "dock")) Then
                frmDock.subDock()
            ElseIf CBool(InStr(strVoiceCommand, "localize")) Then
                tbpBotPose = ftnLocalize_Top(tbpBotPose)
            ElseIf CBool(InStr(strVoiceCommand, "pause")) Then
                boolPause = Not boolPause
                If boolPause Then ftnSendCommand("play phrase 'I am in pause mode.'")
                If boolPause Then frmDebug.subWriteLogs(Color.Black, Now() & "    >>>>  PAUSE voice command received  >>> ")
                'If boolPause Then subCheckForPause()
            ElseIf CBool(InStr(strVoiceCommand, "fox news")) Then
                ftnSendCommand("play phrase 'Starting fox news.'")
                Process.Start(" http://affiliates.foxnewsradio.com/radio/player.html")
            ElseIf CBool(InStr(strVoiceCommand, "npr news")) Then
                ftnSendCommand("play phrase 'Starting n p r news.'")
                Process.Start("http://www.npr.org/player/v2/mediaPlayer.html?action=1&t=4&islist=false")
            ElseIf CBool(InStr(strVoiceCommand, "bbc news")) Then
                ftnSendCommand("play phrase 'Starting b b c news.'")
                Process.Start("http://tunein.com/radio/Newshour-(BBC)-p5/")
            ElseIf CBool(InStr(strVoiceCommand, "news")) Then
                ftnSendCommand("play phrase 'Starting news.'")
                Process.Start(strNewsURL)
            ElseIf CBool(InStr(strVoiceCommand, "forecast")) Then
                Dim strWeather As String = ftnGetWeatherRSS(strWeatherURL)
                ftnSendCommand("play phrase '" & strWeather & "'")
            ElseIf CBool(InStr(strVoiceCommand, "time")) Then
                Dim strTime As String = DateTime.Now().ToShortTimeString()
                ftnSendCommand("play phrase '" & strTime & "'")
            ElseIf CBool(InStr(strVoiceCommand, "stop")) Then
                tbpBotPose = modBotMovementControl.ftnBotStop(tbpBotPose)
                ftnSendCommand("play phrase 'I am stopped'")
                tbpBotPose = ftnLocalize_Top(tbpBotPose)
            ElseIf CBool(InStr(strVoiceCommand, "move")) And CBool(InStr(strVoiceCommand, ",")) And (UBound(strParsedMessage) >= 3) Then
                tmcDestination.X = strParsedMessage(2)
                tmcDestination.Y = strParsedMessage(3)
                subDrawDestination(tmcDestination)
                subDriveToDestination_Top(tmcDestination)
            ElseIf CBool(InStr(strVoiceCommand, "report")) Then
                ftnSendCommand("battery") ' allows extra time for Bot deacceleration 
                If (sngBotBatteryVoltage < 11.4) Or (sngLaptopBatteryPercent < 40) Then
                    ftnSendCommand("play phrase 'Battery is low'")
                ElseIf (sngBotBatteryVoltage < 11.9) Or (sngLaptopBatteryPercent < 90) Then
                    ftnSendCommand("play phrase 'Battery is OK'")
                Else
                    ftnSendCommand("play phrase 'Battery is full'")
                End If
                If Not GotABotClass.InvokeRequired Then subWait(300)
                If ftnMapLocationsEqual(tbpBotPose.Location, tmcDock) Or boolDocked Then
                    ftnSendCommand("play phrase 'I am at my docking station'")
                ElseIf boolDock Then
                    ftnSendCommand("play phrase 'I am docking'")
                ElseIf boolDrivingToDestination Then
                    ftnSendCommand("play phrase 'I am driving to destination'")
                ElseIf ftnIAmLost(tbpBotPose) Then
                    ftnSendCommand("play phrase 'I am lost'")
                End If
                If boolPause Then ftnSendCommand("play phrase 'I am in pause mode'")
            ElseIf CBool(InStr(strVoiceCommand, "funny")) Then
                subJoke()
            ElseIf CBool(InStr(strVoiceCommand, "thanks")) Then
                subThanks()
            ElseIf CBool(InStr(strVoiceCommand, "hello")) Then
                subHi()
            ElseIf CBool(InStr(strVoiceCommand, "goodbye")) Then
                subGoodBye()
            ElseIf CBool(InStr(strVoiceCommand, "move")) And CBool(InStr(strVoiceCommand, "degrees")) And (UBound(strParsedMessage) >= 2) Then
                Dim tbpTargetPose As typeBotPose = tbpBotPose
                tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + Val(strParsedMessage(2)))
                tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
            ElseIf CBool(InStr(strVoiceCommand, "move")) Then
                Dim tbpTargetPose As typeBotPose = tbpBotPose
                If CBool(InStr(strVoiceCommand, " cm")) Then
                    tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, ftnCmToMapUnits(Val(strParsedMessage(2))))
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                Else
                    tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, ftnInchesToMapUnits(Val(strParsedMessage(2))))
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                End If
            Else
                strVoiceCommand = Replace(strVoiceCommand, "command ", "")
                strVoiceCommand = Replace(strVoiceCommand, "OK", "")
                ftnSendCommand(strVoiceCommand)
            End If
            GotABotClass.subRedraw(tbpBotPose)
        ElseIf (UBound(strParsedMessage) >= 2) And CBool(InStr(strVoiceCommand, "distance")) Then
            tmcAccelerometerDistance.X = ftnCmToMapUnits(Val(strParsedMessage(1)))
            tmcAccelerometerDistance.Y = ftnCmToMapUnits(Val(strParsedMessage(2)))
        End If
        strVoiceCommand = " "
    End Sub

 

    Sub subHi()
        On Error Resume Next
        Dim rnd As New Random()
        Dim intRndNumber As Integer = rnd.Next(1, 9)
        Select Case intRndNumber
            Case 1
                ftnSendCommand("play phrase 'Hi.'")
            Case 2
                ftnSendCommand("play phrase 'Hello.'")
            Case 3
                ftnSendCommand("play phrase 'Good to see you.'")
            Case 4
                ftnSendCommand("play phrase 'Whats up?'")
            Case 5
                ftnSendCommand("play phrase 'How are you today?'")
            Case 6
                ftnSendCommand("play phrase 'Bonjour.'")
            Case 7
                ftnSendCommand("play phrase 'Good Day.'")
            Case 8
                ftnSendCommand("play phrase 'Greetings.'")
            Case Else
                ftnSendCommand("play phrase 'Hey.'")
        End Select
    End Sub


    Sub subGoodBye()
        On Error Resume Next
        Dim rnd As New Random()
        Dim intRndNumber As Integer = rnd.Next(1, 10)
        Select Case intRndNumber
            Case 1
                ftnSendCommand("play phrase 'Bye.'")
            Case 2
                ftnSendCommand("play phrase 'Good Bye.'")
            Case 3
                ftnSendCommand("play phrase 'See you later.'")
            Case 4
                ftnSendCommand("play phrase 'Until next time.'")
            Case 5
                ftnSendCommand("play phrase 'Take care.'")
            Case 6
                ftnSendCommand("play phrase 'Cheerio.'")
            Case 7
                ftnSendCommand("play phrase 'Bye Bye.'")
            Case 8
                ftnSendCommand("play phrase 'So Long.'")
            Case 9
                ftnSendCommand("play phrase 'hasta la vista, baby.'")
            Case Else
                ftnSendCommand("play phrase 'Adios.'")
        End Select
    End Sub

    Sub subThanks()
        On Error Resume Next
        Dim rnd As New Random()
        Dim intThanksNumber As Integer = rnd.Next(1, 13)
        Select Case intThanksNumber
            Case 1
                ftnSendCommand("play phrase 'You are welcome.'")
            Case 2
                ftnSendCommand("play phrase 'You are most welcome.'")
            Case 3
                ftnSendCommand("play phrase 'No problem.'")
            Case 4
                ftnSendCommand("play phrase 'Glad to be of service.'")
            Case 5
                ftnSendCommand("play phrase 'Your wish is my command.'")
            Case 6
                ftnSendCommand("play phrase 'Any time.'")
            Case 7
                ftnSendCommand("play phrase 'My pleasure.'")
            Case 8
                ftnSendCommand("play phrase 'Dont mention it.'")
            Case 9
                ftnSendCommand("play phrase 'It was nothing.'")
            Case 10
                ftnSendCommand("play phrase 'Not at all.'")
            Case 11
                ftnSendCommand("play phrase 'No worries.'")
            Case 12
                ftnSendCommand("play phrase 'no problemo.'")
            Case Else
                ftnSendCommand("play phrase 'Youre welcome.'")
        End Select
    End Sub

    Sub subJoke()
        On Error Resume Next
        Dim rnd As New Random()
        Dim intJokeNumber As Integer = rnd.Next(1, 26)
        subDoEventsIfMainThread()
        Select Case intJokeNumber
            Case 1
                ftnSendCommand("play phrase 'Two robots are working.'")
                subWait(1500)
                ftnSendCommand("play phrase 'One says to the other, You are such a tool.'")
            Case 2
                ftnSendCommand("play phrase 'A robot walks into a bar and orders a drink.'")
                subWait(500)
                ftnSendCommand("play phrase 'The bartender says, hey. we do not serve robots.'")
                subWait(500)
                ftnSendCommand("play phrase 'And the robot says, Oh, but someday you will.'")
            Case 3
                ftnSendCommand("play phrase 'A man buys a lie detector robot that slaps people who lie.'")
                subWait(500)
                ftnSendCommand("play phrase 'He decides to try it out at dinner.'")
                subWait(500)
                ftnSendCommand("play phrase 'Dad asks his son, Where were you today?'")
                subWait(500)
                ftnSendCommand("play phrase 'The son says, At school.'")
                subWait(500)
                ftnSendCommand("play phrase 'The Robot slaps son. Ok, I went to the movies.'")
                subWait(500)
                ftnSendCommand("play phrase 'Dad says, Which one?'")
                subWait(500)
                ftnSendCommand("play phrase 'The son says, Toy Story. The Robot slaps son again.'")
                subWait(500)
                ftnSendCommand("play phrase 'Ok, it was A Day with a Porn Star.'")
                subWait(500)
                ftnSendCommand("play phrase 'Dad says,  When I was your age, I did not even know what porn was.'")
                subWait(500)
                ftnSendCommand("play phrase 'The Robot slaps dad.'")
                subWait(500)
                ftnSendCommand("play phrase 'Mom says, HA HA! After all, he is your son.'")
                subWait(500)
                ftnSendCommand("play phrase 'The Robot slaps mom'")
                subWait(500)
            Case 4
                ftnSendCommand("play phrase ' what do robots like to eat?'")
                subWait(500)
                ftnSendCommand("play phrase 'microchips'")
            Case 5
                ftnSendCommand("play phrase ' Why did the robot cross the road?'")
                subWait(500)
                ftnSendCommand("play phrase 'He was programmed to chase the chicken!'")
            Case 6
                ftnSendCommand("play phrase ' What is a robots favorite type of music?'")
                subWait(500)
                ftnSendCommand("play phrase 'Heavy metal!'")
            Case 7
                ftnSendCommand("play phrase '  Why did the robot go back to robot school?'")
                subWait(500)
                ftnSendCommand("play phrase 'Because his skills were getting a little rusty!'")
            Case 7
                ftnSendCommand("play phrase 'Why was the robot angry?'")
                subWait(500)
                ftnSendCommand("play phrase 'Because someone kept pushing his buttons!'")
            Case 8
                ftnSendCommand("play phrase 'Why are robots never afraid?'")
                subWait(500)
                ftnSendCommand("play phrase 'Because they have nerves of steel!'")
            Case 9
                ftnSendCommand("play phrase 'Why is a robot mechanic never lonely?'")
                subWait(500)
                ftnSendCommand("play phrase 'Because he is always making new friends!'")
            Case 10
                ftnSendCommand("play phrase 'What did the man say to his dead robot?'")
                subWait(500)
                ftnSendCommand("play phrase 'Rust in peace.'")
            Case 11
                ftnSendCommand("play phrase 'What do you get when you cross a robot and a tractor?'")
                subWait(500)
                ftnSendCommand("play phrase 'A trans farmer.'")
            Case 12
                ftnSendCommand("play phrase 'Why did the robot act crazy?'")
                subWait(500)
                ftnSendCommand("play phrase 'Because he had a screw loose.'")
            Case 13
                ftnSendCommand("play phrase 'Do robots have sisters?'")
                subWait(500)
                ftnSendCommand("play phrase 'No, just transistors.'")
            Case 14
                ftnSendCommand("play phrase 'What do you call a robot that always takes the longest route round ?'")
                subWait(500)
                ftnSendCommand("play phrase 'R2 detour.'")
            Case 15
                ftnSendCommand("play phrase 'What is a zombies favorite toy?'")
                subWait(500)
                ftnSendCommand("play phrase 'A DEADY bear!'")
            Case 16
                ftnSendCommand("play phrase 'Why did the zombie ignore all his new Facebook friends?'")
                subWait(500)
                ftnSendCommand("play phrase 'He was still DIGESTING all his old Facebook friends!'")
            Case 17
                ftnSendCommand("play phrase 'Who did the zombie take out for dinner?'")
                subWait(500)
                ftnSendCommand("play phrase 'His GHOULfriend!'")
            Case 18
                ftnSendCommand("play phrase 'What kind of candy do zombies refuse to eat?'")
                subWait(500)
                ftnSendCommand("play phrase 'LIFE Savers!'")
            Case 19
                ftnSendCommand("play phrase 'Where do zombies go swimming?'")
                subWait(500)
                ftnSendCommand("play phrase 'The DEAD Sea!'")
            Case 20
                ftnSendCommand("play phrase 'Where do most zombies live?'")
                subWait(500)
                ftnSendCommand("play phrase 'On DEAD end streets!'")
            Case 21
                ftnSendCommand("play phrase 'Where is the safest place in your home from a zombie?'")
                subWait(500)
                ftnSendCommand("play phrase 'The LIVING room!'")
            Case 22
                ftnSendCommand("play phrase 'What did the zombie say before his fight?'")
                subWait(500)
                ftnSendCommand("play phrase 'Do you want a PIECE of me?'")
            Case 23
                ftnSendCommand("play phrase 'How do you know a zombie is tired?'")
                subWait(500)
                ftnSendCommand("play phrase 'Hes DEAD on his feet!'")
            Case 24
                ftnSendCommand("play phrase 'Why did the zombie cross the road?'")
                subWait(500)
                ftnSendCommand("play phrase 'He wanted to EAT the chicken!'")
            Case 25
                ftnSendCommand("play phrase 'Why was the zombie afraid to cross the road?'")
                subWait(500)
                ftnSendCommand("play phrase 'He had LOST his GUTS!'")
                'Case 6
                '   ftnSendCommand("play phrase '")
            Case Else
                ftnSendCommand("play phrase 'Error.  Joke not found'")
        End Select
    End Sub




End Module
